;
; WORD-CLEAN BY MICHAEL DAY   AS OF 24 AUG 1982
;
; WORD-CLEAN WAS CREATED TO STRIP OFF BIT 8 OF
; DATA FILES CREATED ON SYSTEMS AND OR PROGRAMS
; THAT USE BIT 8 FOR CONTROL PURPOSES. (SUCH AS
; 'WORDSTAR') THIS HAS THE UNFORTUNATE SIDE
; EFFECT OF DRIVING OTHER SYSTEMS/PROGRAMS
; CRAZY AS THEY ARE EXPECTING BIT 8 TO BE OFF.
;
;
; WORD-CLEAN IS CALLED WITH THE FORMAT AS FOLLOWS
;
; 'WRDCLEAN SOURCE.TYP DEST.TYP'
;
; WHERE SOURCE.TYP IS THE FILE TO BE CLEANED, AND 
; DEST.TYP IS THE NAME OF THE LAUNDERED FILE.
;
; FIXED TO ACTUALLY CLEAN BIT EIGHT OFF OF THE FILE
; 1 AUG 1984  MICHAEL DAY (OOPS...)

;*********************************
;
	ORG 100H
;
;*********************************
;
WRDCLEN	LXI SP,STACK

	LDA FCB+1	;SOURCE?
	CPI ' '
	JZ NORFILE

	LDA FCB+17	;DEST?
	CPI ' '
	JZ NOWFILE

	LXI H,FCB	;SAVE SOURCE
	LXI D,RDFCB
	MVI B,12
	CALL MOVE

	MVI B,21	;CLEAR REST OF THE FCB
	LXI H,RDFCB+12
RDFCLR	MVI M,00H
	INX H
	DCR B
	JNZ RDFCLR

	LXI H,FCB+16	;SAVE DEST
	LXI D,WRFCB
	MVI B,12
	CALL MOVE

	MVI B,21	;CLEAR THE REST OF THE FCB
	LXI H,WRFCB+12
WRFCLR	MVI M,00H
	INX H
	DCR B
	JNZ WRFCLR

	LXI D,RDFCB	;OPEN SOURCE
	MVI C,15
	CALL BDOSX
	CPI 255
	JZ NOFILE

	LXI D,WRFCB	;DEST FILE EXIST ALREADY?
	MVI C,17
	CALL BDOSX
	CPI 255
	JNZ NWFILE

	LXI D,WRFCB	;MAKE DEST FILE
	MVI C,22
	CALL BDOSX
	CPI 255
	JZ NOFILE

	LXI D,WRFCB	;OPEN DEST
	MVI C,15
	CALL BDOSX
	CPI 255
	JZ NOFILE

	CALL RDSECT	;GET FIRST SOURCE RECORD
	JC BADCOMP
	CPI 1
	JZ ALLDONE
;
	CALL PROMPT
	DB CR,LF
	DB 'WORD-CLEAN  VERSION 1.1  AS OF 1 AUG 1984',CR,LF
	DB '   BY MICHAEL DAY ',CR,LF,81H
;
;*************************************
;
NXTCHR	CALL GETCHR	;GET A CHARACTER
	ANI 7FH		;HERE IS THE HEART OF THE PROGRAM....
	STA THISCHR
	CALL PUTCHR	;STRIPS BIT 8 AND SAVES IT
	JMP NXTCHR
;
;**************************************::
;
GETCHR	LDA THISCHR	;UPDATE LAST CHAR
	STA LASTCHR

	LDA CHRCNT	;NEED TO READ MORE DATA?
	CPI 80H
	JC NOREAD

	CALL RDSECT	;YES, GET IT
	JC BADCOMP	;ERROR
	CPI 1
	JZ ALLDONE	;READ ALL DONE

NOREAD	LDA CHRCNT	;INC BUFFER COUNT
	INR A
	STA CHRCNT

	LHLD CHRPTR	;GET THE CHAR
	MOV A,M
	INX H
	SHLD CHRPTR

	STA THISCHR	;SAVE IT
	ORA A
	RET
;
;************************************::
;
PUTCHR	LDA THISCHR	;GET THE CHARACTER TO SAVE
	LHLD SAVPTR
	MOV M,A
	INX H
	SHLD SAVPTR

	CPI 'Z'-40H	;IF FIND A ^Z, WE ARE ALL DONE WITH 
	JZ ALLDONE	;THE FILE, SO CLOSE UP SHOP AND GO HOME

	LDA WRCPCNT	;TIME TO WRITE A SECTOR?
	INR A
	STA WRCPCNT
	CPI 80H
	JC NWRIT

	CALL WRSECT	;YES, DO IT
	JC BADCOMP

NWRIT	LDA THISCHR
;	CALL TYPE

	ORA A
	RET
;
;****************************************************
;
RDSECT	LDA SECINBF	;GET A SECTOR FROM RBUF
	DCR A		;IF NONE AVAILABLE, GO READ ANOUTHER BLOCK
	STA SECINBF	;RETURNS CARRY SET ON DISK ERROR
	JM RDBLOCK	;AND EOFLG = 1 ON LAST READ

	XRA A
	STA CHRCNT
	RET

RDBLOCK	LDA EOFLG	;READ IN A GROUP OF 16 SECTORS INTO RBUF
	CPI 1
	RZ
	MVI C,0
	LXI D,RBUF

RDSECLP	PUSH B
	PUSH D
	MVI C,26
	CALL BDOSX

	LXI D,RDFCB
	MVI C,20
	CALL BDOSX
	POP D
	POP B
	ORA A
	JZ RDSECOK
	DCR A
	JZ REOF

RDSECER	CALL CRLF
	CALL PROMPT
	DB '++ FILE READ ERROR ++',81H
	ORI 255
	STC
	POP H
	POP D
	POP B
	RET

RDSECOK	LXI H,80H
	DAD D
	XCHG
	INR C
	MOV A,C
	CPI 16
	JNC RDBFULL
	JMP RDSECLP

REOF	MVI A,1		;END OF FILE REACHED
	STA EOFLG
	MOV A,C

RDBFULL	STA SECINBF	;READ DONE

	LXI D,DEFDMA	;RESTORE DEFAULT DMA
	MVI C,26
	CALL BDOSX

	LXI H,RBUF	;SET READ POINTER TO BEGINING OF BUFFER
	SHLD CHRPTR

	JMP RDSECT
;
;******************************************************
;
WRSECT	LDA WRCPCNT	;NOTHING TO WRITE, SO DON'T
	ORA A
	RZ

	LDA WSCINBF	;MOVE THE RECIEVED SECTORS TO WBUF
	INR A
	STA WSCINBF
	CPI 16
	JNC WRBLOCK

	XRA A		;CLEAR WRITE BUFFER COUNTER
	STA WRCPCNT
	RET

WRBLOCK	LDA WSCINBF	;WRITE WBUF TO DISK
	ORA A
	RZ
	MOV C,A
	LXI D,WBUF

DKWRLP	PUSH H
	PUSH D
	PUSH B
	MVI C,26
	CALL BDOSX

	LXI D,WRFCB
	MVI C,21
	CALL BDOSX
	POP B
	POP D
	POP H
	ORA A
	JNZ WRERR

	LXI H,80H
	DAD D
	XCHG
	DCR C
	JNZ DKWRLP

	LXI D,DEFDMA	;RESTORE DEFAULT DMA
	MVI C,26
	CALL BDOSX

	LXI H,WBUF	;SET WRITE POINTER TO BEGINING OF BUFFER
	SHLD SAVPTR

	XRA A
	STA WSCINBF
	STA WRCPCNT
	RET

WRERR	CALL PROMPT
	DB CR,LF
	DB '++ ERROR WRITING FILE ++',81H
	ORI 255
	STC
	RET
;
ALLDONE	LHLD SAVPTR	;MAKE SURE FILE IS TAGED WITH A ^Z
	MVI M,'Z'-40H

	CALL WRSECT	;SAVE THE LAST SECTOR
	CALL WRBLOCK	;THEN WRITE THE BLOCK

	LXI D,WRFCB	;AND THEN CLOSE THE FILE
	MVI C,16
	CALL BDOSX
	CPI 255
	JNZ ALLOK

	CALL PROMPT
	DB CR,LF
	DB '++ CANNOT CLOSE FILE ++',81H
	JMP BADCOMP
;
ALLOK	CALL PROMPT
	DB CR,LF
	DB '-- LAUNDRY IS DONE -- TICKET PLEASE --',81H
	JMP 0

BDOSX	PUSH H		;CALL CPM BDOS
	PUSH D
	PUSH B
	CALL 5
	POP B
	POP D
	POP H
	RET
;
NOWFILE	CALL PROMPT
	DB CR,LF
	DB '++ NO DESTINATION FILE ++',81H
	JMP SHOWEM
;
NORFILE	CALL PROMPT
	DB CR,LF
	DB '++ NO SOURCE FILE ++',81H

SHOWEM	CALL PROMPT
	DB 'FORMAT IS > WRDCLEAN SOURCE.TYP DEST.TYP',81H
	JMP 0
;
NOFILE	CALL PROMPT
	DB CR,LF
	DB '++ CANNOT OPEN FILE ++',81H
	JMP 0
;
NWFILE	CALL PROMPT
	DB CR,LF
	DB '++ FILE ALREADY EXISTS ++',81H
	JMP 0
;
ERROR	CALL PROMPT
	DB '++ MEMORY OVERFLOW ++',80H
;
BADCOMP	CALL PROMPT
	DB CR,LF,BELL,'++ WORD-CLEAN ABORTED ++',BELL,81H
	JMP 0
;
;*************************************************
;
PROMPT	XTHL		;PRINT A PROMPT
PM100	CALL CHOUT
	JP PM100
	XTHL
	SUI 128
	RZ
	XRA A
;
CRLF	PUSH PSW	;DO A CRLF
	CALL PROMPT
	DB CR,LF,80H
	POP PSW
	RET
;
CHOUT	MOV A,M
	INX H
	ORA A
	RM

TYPE	PUSH PSW
	PUSH B
	PUSH H
	PUSH D
	MOV E,A
	MVI C,2
	CALL BDOSX
	POP D
	POP H
	POP B
	POP PSW
	RET
;
MOVE	MOV A,M
	STAX D
	INX D
	INX H
	DCR B
	JNZ MOVE
	RET
;
CHLDE	MOV A,H
	CMP D
	RNZ
	MOV A,L
	CMP E
	RET
;
PHL	PUSH PSW
	MOV A,H
	CALL PHEX
	MOV A,L
	CALL PHEX
	POP PSW
	RET
;
PHEX	PUSH PSW
	RAR!RAR!RAR!RAR
	CALL NIBBLE
	POP PSW

NIBBLE	PUSH PSW
	ANI 0FH
	CPI 10
	JC ISNUM
	ADI 7
ISNUM	ADI '0'
	CALL TYPE
	POP PSW
	RET
;
EOFLG	DB 0	;THESE ARE THE INITAL VALUES
CHRCNT	DB 0	;FOR THE VARIABLES
WRCPCNT	DB 0
SECINBF	DB 0
WSCINBF	DB 0
THISCHR	DB 0
LASTCHR	DB 0
;
CHRPTR	DW RBUF
SAVPTR	DW WBUF

BUFFER	DB 0	;BLANK SAVE BUFFER
	DS 100H

RDFCB	DS 40
WRFCB	DS 40

WBUF	DS 2049
RBUF	DS 2049

ESTACK	DS 32
STACK	DS 2

FCB	EQU 5CH
DEFDMA	EQU 80H

CR	EQU 13
LF	EQU 10
BELL	EQU 7

	END 100H
;


 
