
; READCPM  Version 2.01 as of 27 Dec 87
;  BY MICHAEL E. DAY

;Copyright (C) 1987  Day Research

;This program reads KAYPRO CP/M disks on a MS-DOS machine.
;The program will run on a IBM (and 100% clones), or on
;a Sanyo 555. See IBM/SANYO equates below for selection.
;on quad density Sanyo's set QUADDISK to "YES" as well.


YES	EQU 0FFFFH
NO	EQU 0000H

IBM 	  EQU YES	;Make "NO" for Sanyo 555, otherwise make "YES"
SANYO	  EQU NO	;Make "NO" for IBM, "YES" for Sanyo 555
QUADDISK  EQU NO	;FOR QUAD DENSITY SANYO DISKS ONLY
			;enable both SANYO and QUADDISK for this one

SEGBUFFER EQU NO	;always use no, this is a kludge that never worked.


;This program was written to be assembled by the Seattle Computer
;Products Assembler (SASM). You will either have to adapt it to
;MASM if you want to assemble it under MASM, or find a copy of
;SASM for your own use. I can provide a SASM compatible assembler
;from Hawthorne Techonology (HASM) for $50.00 if you wish to go that
;route. It has the advantage of being about ten times faster than
;MASM for small files like this.

	ORG 100H

;PUT THE INIT STUFF HERE

CR	EQU 0DH
LF	EQU 0AH

MAXREC:		EQU 256		;MAX # RECS IN WBUFFER
WBUFFER:	EQU 6000H
WRITESEG:	EQU 800H	;WRITE SEG STARTS AT 32K
				;AND USES A FULL 64K BUFFER

BEGIN:
	JMP START

START:
	MOV SP,STACK
	MOV AX,DS
	MOV ES,AX

	MOV B,[EXITFLG],00H	;CLEAR PRENAMED FLAG
	MOV B,[CONVFLAG],00H
	MOV B,[COPYFLAG],00H

	MOV DI,READFCB	;SAVE SOURCE FILE INFO IF GIVEN
	MOV SI,5CH
	MOV CX,16
	REP
	MOVB

	MOV DI,WRITEFCB	;SAVE DEST FILE IF GIVEN
	MOV SI,6CH
	MOV CX,16
	REP
	MOVB 

	CMP B,[5DH],20H		;SOURCE FILE GIVEN?
	JZ NOFILESPEC

	MOV B,[EXITFLG],0FFH	;RET TO MSDOS WHEN DONE

	CMP B,[6DH],20H	;CHECK IF NEW NAME TO BE GIVEN
	JNZ FILESELOK	;YES, NEW NAME
	
	MOV B,[COPYFLAG],0FFH	;COPY SAME NAME
	MOV B,[CONVFLAG],0FFH	;CONVERT .COM FILES TO .CPM
	JMP FILESOK2

FILESELOK:
	CALL WILDTEST	;WILD CARDS NOT ALLOWED IF 2ND NAME GIVEN
	JZ BUMFILSEL

	CALL WILDTEST2
	JNZ FILESOK2

BUMFILSEL:
	MOV DX,BADCMDCALL
	MOV AH,9
	INT 21H
	JMP USERBOOT

FILESOK2:
	MOV AH,19H
	INT 21H
	INC AL
	MOV [DEFDRIVE],AL

	MOV AL,[WRITEFCB]
	CALL REALDRIVE
	MOV [WRITEFCB],AL

	MOV AL,[READFCB]
	CMP AL,00H
	JNZ NODEFREAD
	CALL REALDRIVE
	MOV [READFCB],AL
	CALL DOCPMMSG	;GET CPM DISK IN THE DRIVE

NODEFREAD:
	MOV B,[DRVRESFLG],0FFH	;RESET DRIVE
	MOV B,[FORCEFLG],0FFH	;AND FORCE A SEEK

	CALL READDIR		;MOVE THE KAYPRO DIRECTORY INTO MEM
	JZ DIRREADOK

	MOV DX,DIRERRMSG	;COULDN'T READ THE DIRECTORY
	MOV AH,9
	INT 21H
	JMP USERBOOT


;WE ENTER HERE IF NO FILENAMES WERE GIVEN, OR BAD
;FILENAME FORMAT GIVEN.

NOFILESPEC:
	MOV AH,19H
	INT 21H
	INC AL
	MOV [DEFDRIVE],AL

	MOV DX,OPENMSG		;PRINT COPYRIGHT MSG
	MOV AH,9
	INT 21H

	MOV AL,[READFCB]	;MAKE DEF DRIVES REAL
	CALL REALDRIVE
	MOV [READFCB],AL
	MOV AL,[WRITEFCB]
	CALL REALDRIVE
	MOV [WRITEFCB],AL

DIRMENU:
	CALL GETCPMDIR		;PREP A FILE COPY FROM MENU

DIRREADOK:
	MOV B,[THISNAME],00H	;CHECK IF FIRST NAME IS THERE
	MOV B,[FILECNT],64
	MOV BX,DIRTABLE
	MOV [NAMEADDR],BX
	CALL FINDNAME
	CMP AL,0FFH
	JZ NOCPMFILE

	JMP FILESTART	;NOW GO PROCESS THE FILE




DISKLOOP:
	CALL CPMMSG
	MOV BX,[NAMEADDR]
	CALL FINDNAME		;FIND NEXT NAME TO COPY
	CMP AL,00H
	JZ FILESTART
	CMP B,[EXITFLG],00H	;NO MORE, SO RET TO CALLER
	JZ DISKDONE
	JMP USERBOOT

DISKDONE:
	MOV DX,RESTARTMSG
	MOV AH,9
	INT 21H
	MOV DX,INPUTBUFF
	MOV AH,10
	INT 21H
	MOV DX,ENDFILENAME
	MOV AH,9
	INT 21H
	CMP B,[INPUTBUFF+1],00H
	JZ DISKDONE
	MOV AL,[INPUTBUFF+2]
	AND AL,5FH
	CMP AL,'Y'
	JZ DIRMENU
	CMP AL,'N' 
	JNZ DISKDONE
	MOV B,[EXITFLG],0FFH
	JMP USERBOOT


FILESTART:
	CMP B,[COPYFLAG],00H
	JZ FILEXCOPY
	MOV CX,DS
	MOV ES,CX

	MOV SI,DIRNAME		;COPY READ NAME TO WRITE NAME 
	MOV DI,WRITEFCB+1
	MOV CX,11
	REP
	MOVB
	MOV B,[WRITEFCB+12],00H

FILEXCOPY:
	CALL CONVCHECK		;CONV .COM TO .CPM?
	MOV B,[FIRSTFLG],00H

	CALL OPENCPMFIL		;OPEN THE CPM FILE
	CMP AL,0FFH
	JZ NOCPMFILE
	JMP FILELOOP2	;NO NEED TO SWITCH CPM DISK YET

NOCPMFILE:
	MOV DX,NOCPMFILMSG
	MOV AH,9
	INT 21H
	JMP ERRORRETURN


;NOW WE START TO READ THE FILE

FILELOOP:
	CALL CPMMSG	;TELL EM TO CHANGE DISKS IF NEEDED
FILELOOP2:
	CALL READCPM	;READ IN CPM BLOCK
	CMP AL,01H
	JZ ALLDONE
	CMP AL,0FFH
	JZ CPMRDERR

	CALL MSDOSMSG	;TELL EM TO CHANGE DISKS IF NEEDED
	CALL WRITEMSDOS	;WRITE OUT MSDOS BLOCK
	CMP AL,0FFH
	JZ MSDOSWERR
	MOV B,[FIRSTFLG],0FFH	;CLEAR FIRSTTIME FLAG
	JMP FILELOOP

ALLDONE:
	CALL MSDOSMSG	;TELL EM TO CHANGE DISKS IF NEEDED
	CALL WRITEMSDOS	;WRITE OUT THE LAST BLOCK
	CMP AL,0FFH
	JZ MSDOSWERR

	MOV CX,DS
	MOV ES,CX
	MOV DI,WRITEFCB+10H	;RESTORE REAL NAME
	MOV SI,TEMPFCB
	MOV CX,12
	REP
	MOVB
	MOV DX,WRITEFCB
	MOV AH,17H
	INT 21H

	JMP DISKLOOP	;THIS FILE DONE, ANY MORE?

CPMRDERR:
	MOV DX,CPMRDMSG
	MOV AH,9
	INT 21H
	JMP ERRORRETURN

MSDOSWERR:
	MOV DX,MSDOSWMSG
	MOV AH,9
	INT 21H
	JMP ERRORRETURN

CLOSEERROR:
	MOV DX,CLOSERMSG
	MOV AH,9
	INT 21H
	JMP ERRORRETURN


CPMMSG:
	MOV AL,[WRITEFCB]
	CMP [READFCB],AL
	JNZ CPMDISKOK

DOCPMMSG:
	MOV DX,CPMDISKMSG	;TELL THEM TO CHANGE DISKS
	MOV AH,09H
	INT 21H
	MOV AH,01H	;WAIT FOR INPUT
	INT 21H
	MOV DX,ENDFILENAME
	MOV AH,9
	INT 21H

CPMDISKOK:
	RET

MSDOSMSG:
	MOV AL,[WRITEFCB]
	CMP [READFCB],AL
	JNZ MSDOSDISKOK

DOMSDOSMSG:
	MOV DX,MSDISKMSG	;TELL THEM TO CHANGE DISKS
	MOV AH,09H
	INT 21H
	MOV AH,01H	;WAIT FOR INPUT
	INT 21H
	MOV DX,ENDFILENAME
	MOV AH,9
	INT 21H

MSDOSDISKOK:
	RET

CONVCHECK:
	CMP B,[CONVFLAG],00H	;CONVERT .COM TO .CPM?
	JZ NOTCOMFILE

	CMP B,[WRITEFCB+9],'C'	;CONVERT COM FILES TO CPM
	JNZ NOTCOMFILE
	CMP B,[WRITEFCB+10],'O'
	JNZ NOTCOMFILE
	CMP B,[WRITEFCB+11],'M'
	JNZ NOTCOMFILE

	MOV B,[WRITEFCB+9],'C'
	MOV B,[WRITEFCB+10],'P'
	MOV B,[WRITEFCB+11],'M'

NOTCOMFILE:
	RET

WILDTEST2:
	MOV SI,WRITEFCB+1
	JMP WILDTESTB

WILDTEST:
	MOV SI,READFCB+1

WILDTESTB:
	MOV CL,11

WILDLOOP:
	LODSB
	CMP AL,'?'
	JZ GOTWILD
	DEC CL
	JNZ WILDLOOP

	OR AL,0FFH	;RET NONZERO IF NOT WILD
	RET

GOTWILD:
	XOR AL,AL	;RET ZERO IF WILD FOUND
	RET


ERRORRETURN:
	CMP B,[EXITFLG],00H
	JNZ USERBOOT

	MOV DX,EWAITMSG
	MOV AH,9
	INT 21H
	MOV AH,01H
	INT 21H
	MOV DX,ENDFILENAME
	MOV AH,9
	INT 21H		;FALL THRU TO USERBOOT

USERBOOT:
	MOV SP,STACK
	CMP B,[EXITFLG],00H	;RET TO MENU WHEN DONE?
	JNZ EXITPRG
	JMP DIRMENU

EXITPRG:
	INT 20H		;ALL DONE, GO HOME


EWAITMSG:
	DB CR,LF
	DB 'Strike any key to continue : $'

OPENMSG:
	DB CR,LF
	DB 'READCPM Copyright (c) 1987  '
	DB 'By Michael Day',CR,LF
	DB 'Version 3.01 As of December 27, 1987  ',CR,LF
	DB CR,LF 
	DB '$'

COPYINGMSG:
	DB 'Copying: $'

COPYSEPMSG:
	DB '-> $'

BADCMDCALL:
	DB 'Invalid command format.'
	DB CR,LF,'$'

MSDISKMSG:
	DB 'Insert destination disk in drive '
	DB 'and strike any key : $'

CPMDISKMSG:
	DB '        Insert CPM disk in drive '	
	DB 'and strike any key > $'

NOCPMFILMSG:
	DB 'Cannot find designated CPM file.'
	DB CR,LF,'$'

NOMSDFILMSG:
	DB 'Cannot create designated destination (copy) file.'
	DB CR,LF,'$'

CPMRDMSG:
	DB 'Unable to read the CPM file.'
	DB CR,LF,'$' 

MSDOSWMSG:
	DB 'Unable to write to the destination (copy) file.'
	DB CR,LF,'$'

FILEXMSG:
	DB 'That file exists already, use a different destination name.'
	DB CR,LF,'$'

CLOSERMSG:
	DB 'Cannot close the destination (copy) file.'
	DB CR,LF,'$'

DIRERRMSG:
	DB 'Cannot read CPM disk.'
	DB CR,LF,'$'

DFILENAME:
	DB 'FILENAME.EXT$'

ENDFILENAME:
	DB CR,LF,'$'

SEPFILENAME:
	DB '  |  $'

AVAILFILESMSG:
	DB 'Files available on CPM disk (Drive $'

AVAILFMSGTAG:
	DB ':)'
	DB CR,LF,CR,LF,'$'

ENTERNAMEMSG:
	DB '     Enter name of CPM file to copy from (source) : $'

ENTERNXTNMMSG:
	DB 'Enter destination filename (Return for same name) : $'

NOINPUTNMMSG:
	DB CR,LF
	DB 'Error - No source filename given.$'

RESTARTMSG:
	DB CR,LF
	DB 'Copy another file(s)? (Y or N) : $'


BURP:
	DB 'BURP',7,CR,LF,'$'


INCALTNAME:
	CMP B,[ALTERFCB+7],'9'
	JZ INCALTNAME2
	INC B,[ALTERFCB+7]
	XOR AL,AL
	RET
INCALTNAME2:
	CMP B,[ALTERFCB+8],'9'
	JZ INCALTNAME3
	MOV B,[ALTERFCB+7],'0'
	INC B,[ALTERFCB+8]
	XOR AL,AL
	RET
INCALTNAME3:
	OR AL,0FFH
	RET


MAKEMSDOSFIL:
	MOV B,[MAKENEW],00H
	MOV B,[MAKEFLG],00H

	MOV DX,READBUFF		;POINT DMA TO SAFE AREA FOR SEARCHING
	MOV AH,1AH
	INT 21H

RMAKEMSDOSFIL:
	MOV DX,WRITEFCB
	MOV AH,11H	
	INT 21H
	CMP AL,00H
	JZ FILEEXISTS

	MOV BX,WRITEFCB+12
	MOV CX,24
WFCBINITLOOP:
	MOV B,[BX],00H
	INC BX
	DEC CX
	JNZ WFCBINITLOOP

	MOV CX,DS
	MOV ES,CX
	MOV DI,TEMPFCB
	MOV SI,WRITEFCB
	MOV CX,12H
	REP
	MOVB 


	MOV B,[WRITEFCB+9],'$'
	MOV B,[WRITEFCB+10],'$'
	MOV B,[WRITEFCB+11],'$'

	MOV DX,WRITEFCB	;CREATE THE FILE TO WRITE
	MOV AH,16H
	INT 21H
	CMP AL,0FFH
	JZ MAKEERROR
	RET

MAKEERROR:
	CMP B,[MAKENEW],0FFH
	JZ MAKEERREXIT
	MOV DI,WRITEFCB+1
	MOV SI,ALTERFCB+1
	MOV CX,11H
	REP
	MOVB
	MOV B,[MAKENEW],0FFH
	CALL INCALTNAME
	JNZ MAKEERREXIT
	JMP RMAKEMSDOSFIL


FILEEXISTS:
	CMP B,[MAKEFLG],0FFH
	JZ MAKEERREXIT
	MOV DX,WRITEFCB
	MOV AH,13H
	INT 21H
	MOV B,[MAKEFLG],0FFH
	JMP RMAKEMSDOSFIL

MAKEERREXIT:
	MOV DX,FILEXMSG
	MOV AH,9
	INT 21H
	JMP ERRORRETURN


NOMSDOSFILE:
	MOV DX,NOMSDFILMSG
	MOV AH,9
	INT 21H
	JMP ERRORRETURN

WRITEMSDOS:
	PUSH SI
	PUSH DI
	PUSH BX
	PUSH DX
	PUSH CX 
	MOV AH,0DH	;RESET MSDOS
	INT 21H
	MOV B,[DRVRESFLG],0FFH
	MOV AH,0	;RESTORE THE DISK FIRST THING
	INT 13H
	POP CX
	POP DX
	POP BX
	POP DI
	POP SI 

	CMP B,[FIRSTFLG],0FFH	;IF FIRST TIME THRU, MAKE THE FILE FIRST
	JZ REOPENWFILE
	MOV [OLDWBLOCK],0000H
	MOV B,[OLDWREC],00H

	CALL MAKEMSDOSFIL	;OPEN MSDOS FILE ON FIRST PASS
	CMP AL,0FFH
	JZ NOMSDOSFILE
	JMP WALRDYOPN

REOPENWFILE:
	MOV DX,WRITEFCB		;REOPEN THE WRITE FILE IF AFTER 
	MOV AH,0FH		;FIRST PASS
	INT 21H
	MOV BX,[OLDWBLOCK]
	MOV [WRITEFCB+12],BX
	MOV AH,[OLDWREC]
	MOV [WRITEFCB+32],AH

WALRDYOPN:
	MOV DX,WBUFFER		;SET WRITE POINTER TO BEG OF WRITE SEG
	MOV BX,[WRECORDS]	;GET NUMBER OF RECORDS TO WRITE
	CMP BX,00H
	JZ WRITEDONE	;NOTHING THERE, SO DON'T WRITE

WRITELOOP:
	PUSH DX
	PUSH BX
	PUSH CX

	PUSH DS
     IF SEGBUFFER
	MOV AX,WRITESEG	;POINT DS TO WRITE BUFFER SEGMENT
	MOV CX,DS
	ADD AX,CX
	MOV DS,AX
     ENDIF

	MOV AH,1AH	;SET THE DMA
	INT 21H
	POP DS

	MOV DX,WRITEFCB	;AND WRITE THE REC
	MOV AH,15H
	INT 21H
	POP CX
	POP BX
	POP DX

	CMP AL,00
	JNZ WERROR
	
	ADD DX,128	;POINT TO NEXT RECORD
	DEC BX
	JNZ WRITELOOP

WRITEDONE:
	MOV DX,WRITEFCB	;THIS PASS IS DONE, SO CLOSE FILE
	MOV AH,10H
	INT 21H
	MOV BX,[WRITEFCB+12]	;SAVE OLD FILE DATA
	MOV [OLDWBLOCK],BX
	MOV AH,[WRITEFCB+32]
	MOV [OLDWREC],AH

	MOV AL,00H
	RET

WERROR:
	MOV AL,0FFH
	RET


REALDRIVE:
	OR AL,AL
	JNZ REALDRVEX	;FORCES CORRECT DRIVE SELECT
	MOV AL,[DEFDRIVE]

REALDRVEX:
	RET


READCPM:
	MOV B,[DRVRESFLG],0FFH	;RESET DISK FIRST OFF
	MOV B,[FORCEFLG],0FFH	;FORCE A SEEK ON FIRST TIME
	MOV B,[OLDSECT],0FFH
	MOV [WRECORDS],00H	;INIT POINTERS
	MOV [WBUFFPTR],WBUFFER	;START AT BEG OF BUFFER

READCPMLOOP:
	CALL GETPARMS	;SET PARMS TO READ THE DISK
	CMP AL,01H	;01H=EOF  02=NO READ NEEDED
	JZ FILERDONE
	CMP AL,02H
	JZ SECREADOK
	CALL READSECTOR
	CMP AL,0FFH
	JNZ SECREADOK
	RET

FILERDONE:
	RET

SECREADOK:
	CALL GETRECORD	;POINT TO THE RECORD IN THE READ BUFFER (SI)
	MOV CX,DS
	MOV ES,CX

     IF SEGBUFFER
	MOV DX,WRITESEG
	MOV CX,DS
	ADD DX,CX
	MOV ES,DX
     ENDIF

	MOV DI,[WBUFFPTR]
	MOV CX,128

READMOVELOOP:
	LODSB
	SEG ES
	STOSB
	DEC CX
	JNZ READMOVELOOP

	MOV CX,DS
	MOV ES,CX
	ADD [WBUFFPTR],128	;MOVE POINTER
	INC [WRECORDS]		;INC COUNT
	CMP [WRECORDS],MAXREC	;LIMIT REACHED?
	JNZ READCPMLOOP		;CONTINUE READING IF NOT
	MOV AL,00H		;TELL EM THIS BLOCK IS GOOD
	RET

GETRECORD:
	PUSH BX		;POINT TO 128 RECORD WITHIN SECTOR READ
	PUSH DX
	PUSH AX
	MOV AL,[OFFSET]
	MOV AH,0
	MOV BX,128
	MUL AX,BX
	MOV DX,READBUFF
	ADD AX,DX
	MOV SI,AX
	POP AX
	POP DX
	POP BX
	RET


READSECTOR:
	PUSH AX
	MOV AH,10	;NUMBER OR TIMES TO RETRY
	PUSH AX
READSECLOOP:
	PUSH ES
	PUSH CX
	PUSH BX
	PUSH DX
	MOV AX,DS
	MOV ES,AX
	MOV BX,READBUFF	
	MOV CH,[RTRACK]
	MOV CL,[RSECTOR]
	MOV DH,[RHEAD]
	MOV DL,[RDRIVE]
	MOV AL,[RNSECT]
	MOV AH,2

     IF IBM
	INT 13H		;FOR IBM WE JUST USE NORMAL IBM DISK INT
	JMP IBMDRET
     ENDIF

     IF SANYO

;THIS READS IN THE DESIRED TRACK/SECTOR INFORMATION
;THIS SORT OF EMULATES THE INT 13 SYSTEM READ CALL 
 
DSELPORT EQU 1CH
DTRACK	EQU 0AH
DSECTOR	EQU 0CH
DDATA	EQU 0EH
DCMD	EQU 08H
DSTAT	EQU 08H

READIT:
	INB DSELPORT
	MOV AH,DH
	SHL AH
	SHL AH
	AND AH,04H	;SET UP SIDE SELECT
	AND AL,0F8H
	OR AL,AH
	AND DL,03H	;SETUP DRIVE SELECT
	OR AL,DL
	OUTB DSELPORT

	CMP B,[DRVRESFLG],00H	;RESET CONTROLER FIRST?
	JZ NODRVRES
	CALL RESETDRV
	JZ NODRVRES
	JMP READSECERR

NODRVRES:
	MOV B,[DRVRESFLG],00H

	CMP B,[FORCEFLG],0FFH	;FORCED SEEK?
	JZ FORCESEEK
	INB DTRACK
	CMP AL,CH	;DIFF TRACK THEN BEFORE?
	JNZ FORCESEEK
	JMP SEEKRDY

FORCESEEK:
	MOV B,[FORCEFLG],00H	;CLEAR FORCE SEEK FLAG
	PUSH BX
	PUSH CX
	MOV BH,CH
	MOV BL,0AH

SEEKRETRY:
	DEC BL
	JZ SEEKERROR
	CMP BL,05H
	JNZ SKRTYAGN
	CALL RESETDRV
	JNZ SEEKRETRY
SKRTYAGN:

     ENDIF

     IF QUADDISK
	INB DTRACK
	PUSH AX
	POP AX
	SAL AL
	OUTB DTRACK
     ENDIF

     IF SANYO
	MOV AL,BH	;SEEK NEW TRACK
     ENDIF

     IF QUADDISK
	SAL AL		;IF QUAD DISK, DOUBLE TRACK NUMBER
     ENDIF

     IF SANYO
	OUTB DDATA
	AAM
	AAM
	MOV AL,1BH
	OUTB DCMD
	AAM
	AAM

TSEEKBUSY:
	INB DSTAT
	TEST AL,01H
	JNZ TSEEKBUSY	;WAIT TILL SEEK DONE

	TEST AL,80H	;ALL OK?
	JZ SEEKRDYOK
	JMP SEEKRETRY

SEEKERROR:
	POP CX
	POP BX
	JMP READSECERR

SEEKRDYOK:
	MOV AL,BH
	OUTB DTRACK	;FORCE TRACK REGISTER TO REAL TRACK

	POP CX
	POP BX

SEEKRDY:
	PUSH DI
	PUSH SI
	PUSH BX
	
	MOV AL,CL
	OUTB DSECTOR
	CLI
	CLD
	MOV DI,BX
	MOV DX,DSTAT
	MOV SI,STATWAIT3
	MOV BH,02H
	MOV BL,96H
	MOV AH,00H

	MOV AL,080H
	OUTB DCMD	;CMD TO DO READ
	AAM
	AAM 

STATWAIT1:
	INB DX
	SAR AL
	JNC RDDONE	
	JNZ STATWAIT1
STATWAIT2:
	INB DX
	AND AL,BL
	JZ STATWAIT2
	INB DDATA
	STOSB
STATWAIT3:
	INB DX
	DEC AX
	JZ STATWAIT3
	CMP AL,BH
	JNZ RDDONE
STATWAIT4:
	INB DDATA
	STOSB
	INB DX
	DEC AX
	CMP AL,BH
	JZ STATWAIT4
	JMP SI

RDDONE:
	MOV BX,DI

	INB DSTAT
	STI
	POP BX
	POP SI
	POP DI
	OR AL,AL
	JZ READSECOK

READSECERR:
	OR AL,0FFH
	STC
READSECOK:

    ENDIF	;END OF SANYO READ ROUTINE

IBMDRET:
	POP DX
	POP BX
	POP CX
	POP ES
	JNC READOK	;NO ERRORS
	POP AX
	PUSH AX
	DEC AH
	JZ READSECEX
	CMP AH,6
	JZ DODRVRES
	CMP AH,3
	JZ DODRVRES

	MOV B,[FORCEFLG],0FFH
	JMP READSECLOOP

DODRVRES:
	MOV B,[DRVRESFLG],0FFH
	JMP READSECLOOP

READSECEX:
	POP AX
	POP AX
	OR AL,0FFH
	RET
READOK:
	POP AX
	POP AX
	XOR AL,AL
	RET

     IF SANYO
RESETDRV:
	PUSH BX
	PUSH CX
	PUSH DX
	PUSH SI
	PUSH DI
	MOV AH,0
	INT 13H
	POP DI
	POP SI
	POP DX
	POP CX
	POP BX
	MOV AL,0BH
	OUTB DCMD
	MOV AL,0
	MOV [OLDTRACK],AL
	MOV B,[FORCEFLG],0FFH	;FORCE SEEK IF RESET
	AAM
	AAM

RESDRVBUSY:
	INB DSTAT
	TEST AL,01H
	JNZ RESDRVBUSY	;WAIT TIL RESET DONE
	TEST AL,80H
	RET
     ENDIF


GETPARMS:
	MOV BX,[PARMPTR]	;LOAD PARMS FROM THE PARM TABLE
	MOV AL,[BX]		;TO READ SECTOR FROM DISK
	MOV [RTRACK],AL	;TRACK #
	INC BX
	MOV AL,[BX]
	MOV [RHEAD],AL		;HEAD #
	INC BX
	MOV AL,[BX]
	MOV [RSECTOR],AL	;SECTOR #
	INC BX
	MOV AL,[BX]
	MOV [OFFSET],AL		;POSITION OF RECORD WITHIN SECTOR
	CMP AL,0FFH
	JZ READDONE		;OFFSET OF 0FFH = NO MORE TO GET
	INC BX
	MOV [PARMPTR],BX	;SAVE POINTER 
	MOV AL,[READFCB]
	OR AL,AL
	JZ SCPMRDERR
	DEC AL
	MOV [RDRIVE],AL		;DRIVE #
	MOV B,[RNSECT],01H	;NUMBER OF SECTORS TO READ (ALWAYS 1)
	MOV AL,[RSECTOR]
	CMP AL,[OLDSECT]	;IF SAME PHYSICAL SECTOR, NO NEED TO READ
	MOV [OLDSECT],AL	;SAVE OUR LATEST SECTOR #
	JNZ NOTSAMESEC
	MOV AL,02H		;LET EM KNOW WE DON'T NEED TO READ
	RET

SCPMRDERR:
	JMP CPMRDERR

NOTSAMESEC:
	MOV AL,00H	;WE GOTA READ THIS ONE
	RET

READDONE:
	MOV AL,01H	;ALL DONE READING
	RET

;**********************************************************
;CREATE THE PARM TABLE FOR THE READ ROUTINE

OPENCPMFIL:
	PUSH SI
	PUSH DI
	PUSH CX
	PUSH DX
	PUSH BX

	MOV AX,DS
	MOV ES,AX

	MOV [PARMPTR],PARMTABLE	;POINT TO BEG OF PARM TABLE

	MOV B,[NAMECNT],00H
	MOV B,[NAMEPOS],00H
	MOV CL,64
	MOV DI,NAMETABLE
	MOV BX,DIRTABLE
	CALL SEARCHNAMES
	MOV AL,[NAMECNT]
	CMP AL,00H
	JNZ PRNCOPYMSG

	OR AL,0FFH
	JMP OPENCPMEXIT

PRNCOPYMSG:
	MOV DX,COPYINGMSG
	MOV AH,9
	INT 21H

	MOV DL,[READFCB]
	OR DL,40H
	MOV AH,2
	INT 21H
	MOV DL,':'
	MOV AH,2
	INT 21H
	MOV SI,DIRNAME
	CALL COPYOUTPRN
	CALL COPYSEPFILL

	MOV DX,COPYSEPMSG
	MOV AH,9
	INT 21H
	MOV SI,WRITEFCB
	LODSB
	OR AL,40H
	MOV DL,AL
	MOV AH,2
	INT 21H
	MOV DL,':'
	MOV AH,2
	INT 21H
	CALL COPYOUTPRN
	MOV DX,ENDFILENAME
	MOV AH,9
	INT 21H

	CALL SORTNAMES

	MOV CL,[NAMECNT]
	MOV SI,NAMETABLE
GROUPLOOP:
	LODSB
	DEC AL
	MOV AH,32
	MUL AL,AH
	MOV BX,DIRTABLE
	ADD BX,AX	
	ADD BX,15
	MOV AL,[BX]
	MOV B,[DIRFILESIZE],AL
	INC BX
	MOV [GROUPPTR],BX
	PUSH SI
	PUSH CX
	CALL SETPARMS
	POP CX
	POP SI
	DEC CL
	JNZ GROUPLOOP

	MOV BX,[PARMPTR]
	MOV B,[BX],0FFH
	MOV B,[BX+1],0FFH
	MOV B,[BX+2],0FFH
	MOV B,[BX+3],0FFH
	MOV [PARMPTR],PARMTABLE
	XOR AL,AL

OPENCPMEXIT:
	POP BX
	POP DX
	POP CX
	POP DI
	POP SI
	RET

COPYOUTPRN:
	MOV BX,0
	MOV CX,8
	CALL COPYOUTLOOP
	MOV DL,'.'
	MOV AH,2
	INT 21H
	MOV CX,3
	CALL COPYOUTLOOP
	MOV DL,' '
	MOV AH,2
	INT 21H
	RET


COPYOUTLOOP:
	LODSB
	CMP AL,' '
	JZ COPYOUTBPS	;DON'T PRINT SPACES IN FILENAME 
	MOV DL,AL
	MOV AH,2
	INT 21H
	JMP CPYOUTBPS2
COPYOUTBPS:
	INC BX		;REMEMBER # SPACES BYPASSED
CPYOUTBPS2:
	DEC CX
	JNZ COPYOUTLOOP
	RET

COPYSEPFILL:
	CMP BX,0
	JZ COPYOUTLPDN
	MOV DL,'-'
	MOV AH,2
	INT 21H
	DEC BX
	JMP COPYSEPFILL
COPYOUTLPDN:
	RET


NEXTDIRNAME:
	ADD BX,32
	DEC CL
	JNZ SEARCHNAMES
	RET

SEARCHNAMES:
	INC B,[NAMEPOS]
	CMP B,[BX],00H
	JNZ NEXTDIRNAME
	PUSH SI
	PUSH DI
	PUSH CX
	MOV CX,DS
	MOV ES,CX
	MOV SI,DIRNAME
	MOV DI,BX
	INC DI
	MOV CX,11
	REPE
	CMPSB
	POP CX
	POP DI
	POP SI
	JNZ NEXTDIRNAME
	INC B,[NAMECNT]
	MOV AL,[NAMEPOS]
	STOSB
	JMP NEXTDIRNAME

SORTNAMES:
	CMP B,[NAMECNT],00H
	JZ EXITSORT
	CMP B,[NAMECNT],01H
	JZ EXITSORT

	PUSH DI
	PUSH SI
	PUSH AX

SORTNAMESLOOP:
	MOV DI,0
	MOV B,[INORDER],00H

CONTSCAN:
	CALL POINTER
	MOV AL,[SI]
	INC DI
	CALL POINTER
	CMP AL,[SI]
	JZ SAME
	JNC SWAP
SAME:
	MOV AX,DI
	CMP [NAMECNT],AL
	JNZ CONTSCAN
	CMP B,[INORDER],0FFH	
	JZ CONTSCAN
	POP AX
	POP SI
	POP DI
EXITSORT:
	RET

SWAP:
	MOV B,[INORDER],0FFH
	MOV AL,[NAMETABLE+DI-1]
	MOV AH,[NAMETABLE+DI]
	MOV [NAMETABLE+DI-1],AH
	MOV [NAMETABLE+DI],AL
	JMP SORTNAMESLOOP

POINTER:
	PUSH AX
	MOV AL,[NAMETABLE+DI]
	DEC AL
	MOV AH,32
	MUL AL,AH
	ADD AX,DIRTABLE+12
	MOV SI,AX
	POP AX
	RET


NEXTFINDNAME:
	ADD BX,32
	DEC B,[FILECNT]	;POINT TO NEXT NAME
	JNZ FINDNAME
FINDNAMEDN:
	OR AL,0FFH	;NO MORE NAMES
	RET

FINDNAME:
	MOV AX,DS
	MOV ES,AX 
	CMP B,[FILECNT],00H	;NO MORE TO GET?
	JZ FINDNAMEDN
	INC B,[THISNAME]	;POINT TO NEXT NAME
	CMP B,[BX],00H
	JNZ NEXTFINDNAME	;VALID NAME?
	MOV SI,READFCB+1
	MOV DI,BX		;CHECK IT OUT
	INC DI
	MOV CX,11
NAMECHRLOOP:
	MOV AL,[SI]
	CMP AL,'?'		;WE TAKE ANYTHING ON ?
	JZ NEXTFINDCHAR
	CMP AL,[DI]		;OTHERWISE MUST MATCH
	JNZ NEXTFINDNAME
NEXTFINDCHAR:
	INC SI
	INC DI
	DEC CX
	JNZ NAMECHRLOOP
	CMP B,[DI],00H		;MUST BE 0 EXT
	JNZ NEXTFINDNAME
	ADD BX,32
	MOV [NAMEADDR],BX	;POINT TO NEXT NAME
	DEC B,[FILECNT]
	MOV AL,[THISNAME]	;POINT TO THE FOUND NAME
	DEC AL
	MOV AH,32
	MUL AL,AH
	ADD AX,DIRTABLE+1
	MOV SI,AX
	MOV DI,DIRNAME		;MOVE THE NAME WE FOUND INTO DIRNAME
	MOV CX,12
	REP
	MOVB
	XOR AL,AL
	RET


READDIR:
	MOV B,[RTRACK],01H
	MOV B,[RSECTOR],00H
	MOV B,[RHEAD],00H
	MOV B,[RNSECT],01H
	MOV AL,[READFCB]
	DEC AL
	MOV [RDRIVE],AL
	CALL READSECTOR
	JZ READDIROK
	RET

READDIROK:
	MOV CX,DS
	MOV ES,CX
	MOV BL,3
	MOV DI,DIRTABLE

RDDIRLOOP:
	MOV SI,READBUFF
	MOV CX,512
	REP
	MOVB

	INC B,[RSECTOR]
	PUSH DI
	CALL READSECTOR
	POP DI
	JZ DIRRD2OK
	RET

DIRRD2OK:
	DEC BL
	JNZ RDDIRLOOP
	MOV SI,READBUFF	;MOVE THE LAST SECTOR READ

	MOV CX,512
	REP
	MOVB

	XOR AL,AL
	RET

NODIRNM:
	OR AL,0FFH
	RET

SETPARMS:
NEXTGROUP:
	CALL CONVGROUP
	JZ GROUPDONE

NEXTPOKE:
	CALL POKEREC
	JZ POKEDONE

	INC B,[GOFFSET]
	CMP B,[GOFFSET],04H
	JNZ SAMESECTOR
	MOV B,[GOFFSET],00H
	INC B,[GSECTOR]

SAMESECTOR:
	DEC B,[NGROUP]
	JNZ NEXTPOKE
	JMP NEXTGROUP

GROUPDONE:
POKEDONE:
	RET


CONVGROUP:
	MOV BX,[GROUPPTR]
	MOV AL,[BX]
	INC BX
	MOV [GROUPPTR],BX
	MOV AH,00H
	ADD AX,AX
	CMP AX,00H
	JZ ENDBLOCK
	MOV BX,10
	MOV DX,0
	DIV AX,BX
	ADD AL,1	;SYS TRACKS OFFSET
 	MOV B,[GTRACK],AL
	MOV B,[GSECTOR],DL
	MOV B,[GHEAD],00H
	MOV B,[GOFFSET],00H
	MOV B,[NGROUP],8
	OR AL,0FFH
	RET

ENDBLOCK:
	XOR AL,AL
	RET

POKEREC:
	MOV BX,[PARMPTR]
	MOV AL,[GTRACK]
	MOV [BX],AL
	INC BX
	MOV AL,[GHEAD]
	MOV [BX],AL
	INC BX
	MOV AL,[GSECTOR]
	MOV [BX],AL
	INC BX
	MOV AL,[GOFFSET]
	MOV [BX],AL
	INC BX
	MOV [PARMPTR],BX

	DEC B,[DIRFILESIZE]
	JNZ POKERECOK
	XOR AL,AL
	RET

POKERECOK:
	OR AL,0FFH
	RET

GETCPMDIR:
	CALL CPMMSG

GETNEWDIR:
	MOV B,[EXITFLG],00H
	MOV B,[DRVRESFLG],0FFH
	MOV B,[FORCEFLG],0FFH
	MOV B,[COPYFLAG],00H
	MOV B,[CONVFLAG],00H

	CALL READDIR
	JZ BDIRREADOK

	MOV DX,DIRERRMSG
	MOV AH,9
	INT 21H
	JMP ERRORRETURN

BDIRREADOK:
	CALL CLEARSCREEN
	MOV DX,AVAILFILESMSG
	MOV AH,9
	INT 21H
	MOV AL,[READFCB]
	CALL REALDRIVE
	MOV DL,AL
	OR DL,40H
	MOV AH,2
	INT 21H
	MOV DX,AVAILFMSGTAG
	MOV AH,9
	INT 21H

	MOV CL,64
	MOV CH,4
	MOV BX,DIRTABLE
PRNNAMELOOP:
	CMP B,[BX],00H
	JNZ PRNNEXTNAME
	CMP B,[BX+12],00H
	JNZ PRNNEXTNAME
	CALL PRINTNAME
PRNNEXTNAME:
	ADD BX,32
	DEC CL
	JNZ PRNNAMELOOP
	CMP CH,4
	JZ ENDPRNEXIT
	MOV DX,ENDFILENAME
	MOV AH,9
	INT 21H
ENDPRNEXIT:
	MOV DX,ENDFILENAME
	MOV AH,9
	INT 21H

INPUTNAME:
	MOV DX,ENTERNAMEMSG
	MOV AH,9
	INT 21H

	MOV DX,INPUTBUFF
	MOV AH,10
	INT 21H

	MOV DX,ENDFILENAME
	MOV AH,9
	INT 21H

	CMP B,[INPUTBUFF+1],00H
	JNZ INNAMEOK

	JMP GETNEWDIR


INNAMEOK:
	MOV AL,[READFCB]
	PUSH AX

	MOV AX,DS
	MOV ES,AX
	MOV SI,INPUTBUFF+2
	MOV DI,READFCB
	MOV AL,00
	MOV AH,29H
	INT 21H

	POP AX
	CMP B,[READFCB],00H
	JNZ NOREADDRV
	MOV B,[READFCB],AL
	NOREADDRV:
	CMP B,[READFCB+1],20H
	JNZ INNAMECHK
	CALL DOCPMMSG
	JMP GETNEWDIR

INNAMECHK:
	MOV DX,ENTERNXTNMMSG
	MOV AH,9
	INT 21H

	MOV B,[INPUTBUFF+2],CR
	MOV B,[INPUTBUFF+3],CR

	MOV DX,INPUTBUFF
	MOV AH,10
	INT 21H

	MOV DX,ENDFILENAME
	MOV AH,9
	INT 21H

	MOV AL,[WRITEFCB]
	PUSH AX

	MOV AX,DS
	MOV ES,AX
	MOV SI,INPUTBUFF+2
	MOV DI,WRITEFCB
	MOV AL,00
	MOV AH,29H
	INT 21H
	POP AX
	CMP B,[WRITEFCB],00H
	JNZ NOSECNAME
	CMP B,[WRITEFCB+1],20H
	JZ NOSECNAME
	MOV B,[WRITEFCB],AL

NOSECNAME:
	CMP B,[WRITEFCB+1],20H
	JNZ WRITEFILEOK

	MOV B,[COPYFLAG],0FFH
	MOV B,[CONVFLAG],0FFH

WRITEFILEOK:
	MOV AL,[WRITEFCB]
	CALL REALDRIVE
	MOV [WRITEFCB],AL
	RET

CLEARSCREEN:
	PUSH AX
	PUSH BX
	PUSH CX
	PUSH DX

	MOV CL,25
CLSLP10:
	PUSH CX
	MOV DL,LF
	MOV AH,2
	INT 21H
	POP CX
	DEC CL
	JNZ CLSLP10 

	MOV AL,0
	MOV AH,2
	MOV CX,0
	MOV BX,0
	MOV DX,0
	INT 10H

	POP DX
	POP CX
	POP BX
	POP AX
	RET


PRINTNAME:
	PUSH DI
	PUSH SI
	PUSH BX
	PUSH CX

	MOV AX,DS
	MOV ES,AX

	CMP CH,4
	JZ FILESEPOK

	MOV DX,SEPFILENAME
	MOV AH,9
	INT 21H

FILESEPOK:
	MOV SI,BX
	INC SI
	MOV CX,8
	MOV DI,DFILENAME
	MOV AH,9
	REP
	MOVB
	INC DI
	MOV CX,3
	REP
	MOVB
	MOV DX,DFILENAME
	MOV AH,9
	INT 21H

	POP CX
	DEC CH
	PUSH CX
	JNZ FILESEPOK2
	POP CX
	MOV CH,4
	PUSH CX

	MOV DX,ENDFILENAME
	MOV AH,9
	INT 21H

FILESEPOK2:
	POP CX
	POP BX
	POP SI
	POP DI
	RET

PRTBYTE:
	PUSH DX
	PUSH BX
	PUSH CX
	PUSH AX
	PUSHF 
	MOV DL,AL
	ROR DL
	ROR DL
	ROR DL
	ROR DL
	CALL HEX2A
	PUSH AX
	MOV AH,2
	INT 21H
	POP AX
	MOV DL,AL
	CALL HEX2A	
	MOV AH,2
	INT 21H
	POPF 
	POP AX
	POP BX
	POP CX
	POP DX
	RET


HEX2A:
	AND DL,0FH
	ADD DL,30H
	CMP DL,3AH
	JC HEXN
	ADD DL,07H
HEXN:
	RET

;********************************************
;MISC VARIABLES AND BUFFERS

OLDTRACK:
	DB 0	;OLD TRACK NUMBER
	DS 1

FIRSTFLG:
	DB 0	;FIRST TIME FLAG
	DS 1

WRECORDS:
	DW 0	;# RECS TO WRITE

WBUFFPTR:
	DW 0	;WRITE BUFFER POINTER

PARMPTR:
	DW PARMTABLE	;PARM TABLE POINTER

GROUPPTR:
	DW DIRTABLE	;FILE GROUP POINTER

OLDSECT:
	DB 0FFH	;LAST PHYSICAL SECTOR READ
	DS 1

RTRACK:
	DB 0	;TRACK TO READ
	DS 1

RSECTOR:
	DB 1	;SECTOR TO READ
	DS 1

RNSECT:
	DB 1	;# SECTS TO READ
	DS 1

RDRIVE:
	DB 0	;DRIVE # TO READ FROM
	DS 1

RHEAD:
	DB 0	;HEAD NUMBER TO USE FOR READ
	DS 1

OFFSET:
	DB 0	;RECORD OFFSET WITHIN SECTOR
	DS 1

GOFFSET:
	DB 0
	DS 1

GSECTOR:
	DB 0
	DS 1

GTRACK:
	DB 0
	DS 1

NGROUP:
	DB 0
	DS 1

GHEAD:
	DB 0
	DS 1

DIRFILESIZE:
	DB 0
	DS 1

EXITFLG:
	DB 0	;EXIT BACK TO MSDOS WHEN DONE FLAG
	DS 1

MAKEFLG:
	DB 0	;FIRST MAKE PASS?
	DS 1

MAKENEW:
	DB 0	;FIRST RENAME ATTEMPT?
	DS 1

CONVFLAG:
	DB 0	;CONV .COM TO .CPM FLAG
	DS 1

COPYFLAG:
	DB 0	;COPY READ NAME TO WRITE NAME
	DS 1

FORCEFLG:
	DB 0	;FORCED TRACK SEEK FLAG
	DS 1

INORDER:
	DB 0	;SORT ORDER FLAG
	DS 1

NAMECNT:
	DB 0	;# NAMES IN CPM DIR
	DS 1

NAMEPOS:
	DB 0	;POS OF NAME WITHIN DIR
	DS 1

OLDWBLOCK:
	DW 0	;LAST KNOWN WRITE BLOCK

OLDWREC:
	DB 0	;LAST KNOWN WRITE REC
	DS 1

DRVRESFLG:
	DB 0	;RESET DRIVES?
	DS 1

DEFDRIVE:
	DB 0	;DEFAULT DRIVE STORAGE
	DS 1

FILECNT:
	DB 0	;NAMES LEFT TO CHECK
	DS 1

THISNAME:
	DB 0		;CURRENT NAME IN DIR TABLE IN USE
	DS 1

NAMEADDR:
	DW DIRTABLE	;POINTS TO NEXT NAME TO USE IN DIR TABLE


;ALTERNATE FILE NAME FOR USE IF BUM FILE NAME

ALTERFCB:
	DB 0		;DRIVE
	DB '$FILE$00'	;FILENAME
	DB '$$$'	;EXT
	DB 0,0,0,0,0
	DB 0,0,0,0,0


	DB 0,0,0,0,0	;PREFCB EXT
	DB 0,0,0
WRITEFCB:
	DB 0		;DRIVE
	DB '        '	;FILENAME
	DB '   '	;EXT
	DB 0,0,0,0,0	;OTHER JUNK
	DB 0,0,0,0,0
	DB 0,0,0,0,0
	DB 0,0,0,0,0
	DB 0,0,0,0,0
	DB 0,0,0,0,0


	DB 0,0,0,0,0	;PREFCB EXT
	DB 0,0,0
READFCB:
	DB 0		;DRIVE
	DB '        '	;FILENAME
	DB '   '	;EXT
	DB 0,0,0,0,0	;OTHER JUNK
	DB 0,0,0,0,0
	DB 0,0,0,0,0
	DB 0,0,0,0,0
	DB 0,0,0,0,0
	DB 0,0,0,0,0


TEMPFCB:
	DS 36	;TEMP FCB FOR WRITE


INPUTBUFF:
	DB 20H	;GEN PURPOSE INPUT BUFFER
	DB 0
	DS 20H


	DS 400H	;INTERNAL STACK
STACK:
	DS 8

NAMETABLE:
	DS 64

DIRNAME:
	DS 16

READBUFF:
	DS 1024

DIRTABLE:
	DS 2048

PARMTABLE:
	DS 4000H


	END 100H

