
;	ZRUN.ASM
;	APRIL 2 1988
;	Z80 CP/M EMULATOR FOR 8088
;	DERIVED FROM 8080 CPEMULATOR
;
;This program expects the Seattle Computer Products 8086
;assembler to be used to assemble it. Alternately, the
;Hawthorne Technology 8086 assembler can be used which is
;compatible to SASM.
;Or you can modify the program to work with MASM.
;The original cpemulator program was written in SASM which
;is why it is still in that assmebly style, besides which
;SASM is about ten times faster than MASM on small files 
;like this.


	ORG 100H
;
NO	EQU 0000H
YES	EQU 0FFFFH

NOTREENTER EQU YES	;YES=NORMAL EM, NO=RENTER OLD PRG

EMADM3	 EQU YES	;YES=ADM3 EMULATION, NO=NO EMULATION
NOEMADM3 EQU NO 	;---> MUST BE OPPOSITE OF EMADM3 <---

CR	EQU 0DH
LF	EQU 0AH
BELL	EQU 07H	


RAMSEGMENT	EQU 600H	;6000H  24K FOR EMULATOR

;
; SET UP ALL VARIABLES FOR EMULATOR
; DO ALL ONE TIME INITILIZATION
;
;	INITALIZATION SECTION
;
	JMP INIT

ATRIB:	DB 0FH


CPMMSG:
     IF NOEMADM3
	DB 'This version of ZC80 does not have terminal emulation. For terminal emulation',CR,LF
	DB 'use a screen device driver such as ANSI.SYS. See documentation for more info.',CR,LF
     ENDIF
     IF EMADM3
	DB 'This version of ZC80 supports ADM3A terminal emulation. It will bypass any',CR,LF
	DB 'device driver that you might have installed. See documentation for more info.',CR,LF
     ENDIF
CPMMSG2:
	DB CR,LF
	DB '64K  ZC80 CPeMulator  Version 3.21 as of April 2, 1988',CR,LF
	DB '       Copyright (c) 1984 - 1988  Michael Day',CR,LF
	DB CR,LF
	DB 'OPERATION: To run a program, type "ZC80 FILENAME" at the MS-DOS prompt (CP/M',CR,LF
 	DB 'programs are assumed to have a filename extent of .CPM).',CR,LF
	DB 'This will allow you to run 8080 and Z80 based CP/M-80 programs on your MS-DOS',CR,LF
	DB 'machine (within hardware and software limitations).',CR,LF
	DB 'DISCLAIMER: I make no warranties or claims of the fitness of this product for',CR,LF
	DB 'any particular purpose.  (As always, make backups first!)',CR,LF
	DB 'NOTICE: Users of this program are granted a license to make copies of this',CR,LF
	DB 'program for use on a private non-commercial basis.  A simple and painless',CR,LF
	DB 'commercial license is also available.  See documentation for more information.',CR,LF 
	DB 'No enforcement will be made of this policy, it is simply a (reasonable I hope)',CR,LF
	DB 'request.  Thank you for your cooperation!',CR,LF
	DB 0FFH


; This is a simple clear screen nothing fancy, just roll the screen up
BLNKSCR:
	DB CR,LF	;1
	DB CR,LF
	DB CR,LF	;3
	DB CR,LF
	DB CR,LF	;5
	DB CR,LF
	DB CR,LF	;7
	DB CR,LF
	DB CR,LF	;9
	DB CR,LF
	DB CR,LF	;11
	DB CR,LF
	DB CR,LF	;13
	DB CR,LF
	DB CR,LF	;15
	DB CR,LF
	DB CR,LF	;17
	DB CR,LF
	DB CR,LF	;19
	DB CR,LF
	DB CR,LF	;21
	DB CR,LF
	DB CR,LF	;23
	DB CR,LF
	DB 0FFH

;-------------------------------------------------------------------
; BEG OF PROGRAM


	DB 'So, your looking around inside here are you? Tsk tsk tsk...',CR,LF
	DB 'If you are really interested, the source code *is* available',CR,LF
	DB 'Save yourself a lot of trouble and get real commented source',CR,LF
	DB 'code instead of trying to figure it all out with a debugger?',CR,LF
	DB 0FFH


; BEG OF PROGRAM

INIT:
	MOV SP,STACK
	MOV AX,CS
	MOV DS,AX
;


	JMP INITMORE		;NOW GO SETUP EMULATOR


USERBOOT:
	INT 20H		;RETURN TO MSDOS


;OUTPUT CONTROL ROUTINES

     IF EMADM3
CURCONT:
	CMP DL,00H	;IGNORE NULLS
	JZ CURBYPASS

	MOV AL,[EQFLAG]		;WE GOT AN ESC IS IT CURSOR CONT?
	CMP AL,0FFH
	JZ GETROW
	CMP DL,'='
	JNZ CLRCURFLG
	MOV B,[EQFLAG],0FFH
CURBYPASS:
	RET

GETROW:
	MOV AL,[ROWFLAG]
	CMP AL,0FFH
	JZ GETCOL
	SUB DL,32
	INC DL
	MOV [ROWCNT],DL
	MOV B,[ROWFLAG],0FFH
	RET

GETCOL:
	SUB DL,32
	MOV DH,[ROWCNT]
	MOV AH,2
	MOV AL,0
	MOV BX,0
	INT 10H

CLRCURFLG:
	MOV B,[CURFLAG],00H
	MOV B,[EQFLAG],00H
	MOV B,[ROWFLAG],00H
	RET
     ENDIF

;
GETSCREEN:
     IF EMADM3
	AND DL,7FH		;ESC SEQUENCE?
	CMP B,[CURFLAG],0FFH
	JZ CURCONT

	CMP DL,00H		;NULL?
	JZ GETSCEXIT
	CMP DL,1BH		;ESC CHAR
	JZ SETESC
	CMP DL,1AH		;CLEAR SCREEN
	JZ CLEARSCX
	CMP DL,1EH		;HOME
	JZ SETHOMEX
	CMP DL,0BH		;CURSOR UP?
	JZ CURSORUPX
	CMP DL,17H		;CLEAR END OF SCREEN
	JZ CLREOSX
	CMP DL,18H		;CLEAR EOL
	JZ CLREOLX

	CMP DL,0CH		;CURSOR RIGHT?
	JNZ CHAROUTOK
	JMP CURRIGHT

GETSCEXIT:
	RET

CLEARSCX:
	JMP CLEARSC

SETHOMEX:
	JMP SETHOME

CURSORUPX:
	JMP CURSORUP

CLREOSX:
	JMP CLREOS

CLREOLX:
	JMP CLREOL


SETESC:
	MOV B,[CURFLAG],0FFH
	RET
     ENDIF

CHAROUTOK:
     IF EMADM3
	PUSH DX
	MOV AH,3	;FIND OUT WHERE WE ARE AT
	MOV AL,0
	MOV BX,0
	INT 10H
	MOV [LASTXY],DX
	POP DX
     ENDIF

	MOV AH,06		;NORMAL CHAR
	INT 21H

     IF EMADM3
	MOV AH,3
	MOV AL,0
	MOV BX,0
	INT 10H

	MOV BX,[LASTXY]
	CMP DH,0
	JZ FIXROW 
	CMP DH,24
	JC NOERASETOP
	CMP BH,24
	JC NOERASETOP
	CMP DL,0
	JZ ERASETOP
	CMP DL,BL
	JZ ERASETOP
NOERASETOP:
	RET
ERASETOP:
	MOV AH,7	;ERASE THE TOP LINE ON THE SCREEN
	MOV AL,0
	MOV CX,0
	MOV DH,0
	MOV DL,79
	SEG CS
	MOV BH,[ATRIB]
	INT 10H
	RET

FIXROW:
	MOV DH,1	;OFFSET BACK TO LINE 1 IF WAS AT 0
	MOV AH,2
	MOV AL,0
	MOV BX,0
	INT 10H
	RET
     ENDIF

	RET

     IF EMADM3
CLREOL:	MOV AH,3
	MOV AL,0
	MOV BX,0
	INT 10H
	MOV AL,0
	MOV AH,6
	SEG CS
	MOV BH,[ATRIB]
	MOV CX,DX
	MOV DL,79
	INT 10H
	RET

CLREOS:	CALL CLREOL
	MOV AH,3
	MOV AL,0
	MOV BX,0
	INT 10H
	MOV AH,6
	SEG CS
	MOV BH,[ATRIB]
	MOV AL,0
	MOV CX,DX
	INC CH
	MOV CL,0
	MOV DH,24
	MOV DL,79
	INT 10H
	RET

CLEARSC:
	MOV AH,6
	MOV AL,0
	MOV CX,0
	MOV DH,24
	MOV DL,79
	SEG CS
	MOV BH,[ATRIB]
	INT 10H		;FALL THRU TO SETHOME

SETHOME:
	MOV AH,2
	MOV AL,0
	MOV DH,0
	MOV DL,0
	INC DH		;LINE 1 IS TOP OF PAGE IF BLANK TOP 	
	MOV BX,0
	INT 10H
	RET

CURSORUP:
	MOV AH,3
	MOV AL,0
	MOV BX,0
	INT 10H
	DEC DH
	CMP DH,0
	JNZ ROWUPOK
	INC DH

ROWUPOK:
	MOV AH,2
	MOV AL,0
	MOV BX,0
	INT 10H
	RET


CURRIGHT:
	MOV AL,0
	MOV AH,3
	MOV BX,0
	INT 10H
	INC DL
	CMP DL,80
	JC CURROK
	DEC DL
CURROK:
	MOV AH,2
	MOV AL,0
	MOV BX,0
	INT 10H
	RET

     ENDIF
;
GETKEYST:

	CMP B,[BYTERDYFLG],00H
	JNZ HAVENOW

	MOV AH,06H
	MOV DL,0FFH
	INT 21H
	CMP AL,00H
	JZ NOTREADY
	AND AL,7FH
	MOV [BYTEIN],AL
	MOV [GETIN],AL

HAVENOW:
	MOV AL,0FFH
	MOV [BYTERDYFLG],AL
	MOV [STRDY],AL
	JMP DKEYSTX
NOTREADY:
	MOV AL,00H
DKEYSTX:
	OR AL,AL
	RET


GETCOMMST:
	CMP B,[COMBRDYFLG],00H
	JNZ HAVECOMNOW
	MOV AH,03H
	MOV DX,0
	INT 14H
	AND AL,01H
	JZ NOTREADY
	MOV AH,02H
	MOV DX,0
	INT 14H
	AND AL,7FH
	MOV [COMBYTEIN],AL
	MOV [GETIN],AL
	JMP HAVECOMNOW

HAVECOMNOW:
	MOV AL,0FFH
	MOV [COMBRDYFLG],AL
	MOV [STRDY],AL
	JMP DKEYSTX

;
GETKEYIN:
	CMP B,[BYTERDYFLG],00H
	JNZ GOTALREADY
	CALL GETKEYST
	JMP GETKEYIN

GOTALREADY:
	MOV B,[STRDY],00H
	MOV B,[BYTERDYFLG],00H
	MOV AL,[BYTEIN]
	RET


GETCOMMIN:
	CMP B,[COMBRDYFLG],00H
	JNZ GOTCOMMNOW
	CALL GETCOMMST
	JMP GETCOMMIN
GOTCOMMNOW:
	MOV B,[STRDY],00H
	MOV B,[COMBRDYFLG],00H
	MOV AL,[COMBYTEIN]
	RET


GETCOMMOUT:
	MOV AH,01H
	MOV AL,DL
	MOV DX,0
	INT 14H
	RET

GETPRINOUT:
	MOV AH,05H
	INT 21H
	RET

;
;OUTPUT A BYTE TO THE CONSOLE
;
BCONOT:
	AND DL,7FH
	CMP B,[CONFLAG],00H
	JZ NOTBDCONOT
	CALL DIRCONCHK
	CMP AL,00H
	JNZ NOTBDCONOT
	CALL STOPCHECK
	RET

NOTBDCONOT:
	CALL DOBCONOT
	CALL STOPCHECK
	RET

DOBCONOT:
	MOV AL,[03H]
	AND AL,03H
	JZ SCREEN
	CMP AL,01H
	JZ COMMOUT
	CMP AL,02H
	JZ PRINOUT
	CALL COMMOUT
	JMP SCREEN

;GET A BYTE FROM THE CONSOLE
;
BCONIN:
	CMP B,[CONFLAG],00H
	JZ DOBCONIN
	CALL DOBCONIN
	JMP DIRCINCHK 

DOBCONIN:
	MOV AL,[03H]
	AND AL,03H
	JZ KEYIN
	CMP AL,01H
	JZ COMMIN
	CMP AL,02H
	JZ COMMIN
	CALL KEYST
	OR AL,AL
	JNZ KEYIN
	JMP COMMIN


BCONST:
	MOV AL,[03H]
	AND AL,03H
	JZ KEYST
	CMP AL,01H
	JZ COMMST
	CMP AL,02H
	JZ COMMST
	CALL COMMST
	MOV AH,AL
	PUSH AX
	CALL KEYST
	POP AX
	OR AL,AH
	RET

KEYST:
	JMP GETKEYST
COMMST:
	JMP GETCOMMST
KEYIN:
	JMP GETKEYIN
COMMIN:
	JMP GETCOMMIN
SCREEN:
	JMP GETSCREEN
COMMOUT:
	JMP GETCOMMOUT
PRINOUT:
	JMP GETPRINOUT

BRDIN:
	MOV AL,[03H]
	AND AL,0CH
	JZ KEYIN
	CMP AL,04H
	JZ COMMIN
	CMP AL,08H
	JZ KEYIN
	JMP COMMIN

BPUNOUT:
	MOV AL,[03H]
	AND AL,30H
	JZ SCREEN
	CMP AL,10H
	JZ COMMOUT
	CMP AL,20H
	JZ PRINOUT
	JMP COMMOUT


BLISTOUT:
	MOV AL,[03H]
	AND AL,0C0H
	JZ SCREEN
	CMP AL,040H
	JZ COMMOUT
	CMP AL,080H
	JZ PRINOUT
	JMP COMMOUT


STOPCHECK:
	PUSH DX
	CALL BCONST
	CMP B,[STRDY],00H
	JZ NOSTPCHR
	CMP B,[GETIN],'S'-40H
	JNZ NOSTPCHR
	CALL BCONIN	;CLEAR THIS CHR
	CALL BCONIN	;WAIT FOR NEXT ONE
NOSTPCHR:
	POP DX
	RET

;
DIRCONCHK:
	CMP DL,00H
	JZ IGNOREOUT
	CMP DL,7FH
	JZ IGNOREOUT
	CMP DL,'I'-40H
	JNZ CONOUTOK

TABOUTLP:
	MOV DL,' '
	CALL BCONOT
	MOV AL,[SPCOUNT]
	AND AL,07H
	JNZ TABOUTLP

IGNOREOUT:
	MOV AL,00H
	RET

CONOUTOK:
	CMP DL,0DH
	JNZ INCSPC1
	MOV B,[SPCOUNT],00H
	JMP CONTSPC

DECSPC:
	CMP B,[SPCOUNT],00H
	JZ CONTSPC
	DEC B,[SPCOUNT]
	JMP CONTSPC

INCSPC1:
	CMP DL,'H'-40H
	JZ DECSPC
	CMP DL,' '
	JC CONTSPC
	CMP DL,7FH
	JZ CONTSPC
	INC B,[SPCOUNT]
CONTSPC:
	CMP B,[PRTFLAG],0FFH
	JNZ NOPRTOUT
	PUSH DX
	CALL BLISTOUT
	POP DX
NOPRTOUT:
	MOV AL,0FFH
	RET

DIRCINCHK:
	CMP AL,7FH
	JZ NOCINECHO
	CMP AL,'H'-40H
	JZ CINECHO
	CMP AL,'I'-40H
	JZ CINECHO
	CMP AL,'J'-40H
	JZ CINECHO
	CMP AL,'M'-40H
	JZ CINECHO
	CMP AL,' '
	JC NOCINECHO
CINECHO:
	PUSH DX
	PUSH AX
	MOV DL,AL
	CALL BCONOT
	POP AX
	POP DX
NOCINECHO:
	RET

;
; END OF INSTALLATION SECTION
;
;*******************************************************
;
; SIMULATE CP/M CALLS WITH MS DOS CALLS
;

JCONST:
	INC SI
	PUSH ES
	PUSH DS
	PUSH SI
	PUSH DI
	PUSH BP
	PUSH DX
	PUSH CX
	PUSH BX 

	MOV B,[CONFLAG],00H
	CALL BCONST
	OR AL,AL
	LAHF

	POP BX
	POP CX
	POP DX
	POP BP
	POP DI
	POP SI
	POP DS
	POP ES
	JMP DONE

JCONIN:
	INC SI
	PUSH ES
	PUSH DS
	PUSH SI
	PUSH DI
	PUSH BP
	PUSH DX
	PUSH CX
	PUSH BX 

	MOV B,[CONFLAG],00H
	CALL BCONIN
	LAHF

	POP BX
	POP CX
	POP DX
	POP BP
	POP DI
	POP SI
	POP DS
	POP ES
	JMP DONE

JCONOUT:
	INC SI
	PUSH ES
	PUSH DS
	PUSH SI
	PUSH DI
	PUSH BP
	PUSH DX
	PUSH CX
	PUSH BX 

	MOV B,[CONFLAG],00H
	MOV DL,CL
	CALL BCONOT
	LAHF

	POP BX
	POP CX
	POP DX
	POP BP
	POP DI
	POP SI
	POP DS
	POP ES
	JMP DONE

JLIST:
	INC SI
	PUSH ES
	PUSH DS
	PUSH SI
	PUSH DI
	PUSH BP
	PUSH DX
	PUSH CX
	PUSH BX 

	MOV DL,CL
	MOV B,[CONFLAG],00H
	CALL BLISTOUT
	LAHF

	POP BX
	POP CX
	POP DX
	POP BP
	POP DI
	POP SI
	POP DS
	POP ES
	JMP DONE

JPUNCH:
	INC SI
	PUSH ES
	PUSH DS
	PUSH SI
	PUSH DI
	PUSH BP
	PUSH DX
	PUSH CX
	PUSH BX 

	MOV DL,CL
	MOV B,[CONFLAG],00H
	CALL BPUNOUT
	LAHF

	POP BX
	POP CX
	POP DX
	POP BP
	POP DI
	POP SI
	POP DS
	POP ES
	JMP DONE

JREADER:
	INC SI
	PUSH ES
	PUSH DS
	PUSH SI
	PUSH DI
	PUSH BP
	PUSH DX
	PUSH CX
	PUSH BX 

	MOV B,[CONFLAG],00H
	CALL BRDIN
	LAHF

	POP BX
	POP CX
	POP DX
	POP BP
	POP DI
	POP SI
	POP DS
	POP ES
	JMP DONE

JHOME:
	INC SI
	PUSH ES
	PUSH DS
	PUSH SI
	PUSH DI
	PUSH BP
	PUSH DX
	PUSH CX
	PUSH BX 

	MOV AH,00H
	INT 13H
	LAHF

	POP BX
	POP CX
	POP DX
	POP BP
	POP DI
	POP SI
	POP DS
	POP ES
	JMP DONE

JSELDSK:
	INC SI
	PUSH ES
	PUSH DS
	PUSH SI
	PUSH BP
	PUSH DX
	PUSH CX
	PUSH BX 

	MOV DL,CL
	MOV [DISKREG],DL
	MOV AH,0EH
	PUSH DX
	INT 21H
	POP DX
	CMP DL,AL
	MOV BX,DPARM
	JC DSKSELEX
DISKERROR:
	STC
	MOV BX,0000H	;INVALID SELECT, SO INDICATE ERROR
	JMP DSKSELEX2

DSKSELEX:
	OR AL,AL
DSKSELEX2:
	MOV DI,BX
	LAHF
	POP BX
	POP CX
	POP DX
	POP BP
	POP SI
	POP DS
	POP ES
	JMP DONE

JSETTRK:
	INC SI
	JMP BIOSERROR

JSETSEC:
	INC SI
	JMP BIOSERROR

JSETDMA:
	INC SI
	PUSH ES
	PUSH DS
	PUSH SI
	PUSH DI
	PUSH BP
	PUSH DX
	PUSH CX
	PUSH BX 

	MOV [DMA],CX
	MOV DX,CX
	MOV AH,1AH
	INT 21H

	POP BX
	POP CX
	POP DX
	POP BP
	POP DI
	POP SI
	POP DS
	POP ES
	JMP DONE

JREAD:
	INC SI
	JMP BIOSERROR
JWRITE:
	INC SI
	JMP BIOSERROR

JLISTST:
	INC SI
	OR AL,255
	LAHF
	JMP DONE

JSECTRAN:
	INC SI
	MOV DI,CX
	INC DI
	JMP DONE

BIOSERROR:
	PUSH AX
	MOV DL,CR
	MOV AH,2
	INT 21H
	MOV DL,LF
	MOV AH,2
	INT 21H
	MOV DL,BELL
	MOV AH,2
	INT 21H
	POP AX
	CALL PRTBYTE

	PUSH DS
	MOV BX,CS
	MOV DS,BX
	MOV DX,BIOSERRMSG
	MOV AH,09H
	INT 21H
	POP DS

	CALL HEADER
	CALL DEBUG
	JMP USERBOOT

BIOSERRMSG:
	DB ' <- Invalid BIOS call ***',BELL,CR,LF,'$'

BDOSFUNERROR:
	PUSH AX
	MOV DL,CR
	MOV AH,2
	INT 21H
	MOV DL,LF
	MOV AH,2
	INT 21H
	MOV DL,BELL
	MOV AH,2
	INT 21H
	POP AX
	MOV AL,AH
	CALL PRTBYTE

	PUSH DS
	MOV BX,CS
	MOV DS,BX
	MOV DX,FUNERRMSG
	MOV AH,09H
	INT 21H
	POP DS

	CALL HEADER
	CALL DEBUG
	JMP USERBOOT

FUNERRMSG:
	DB ' <- Invalid BDOS function call ***',BELL,CR,LF,'$'



RBDOS: 
	INC SI
	PUSH SI
	PUSH BP
	PUSH ES

	PUSH DS
	MOV AH,CL

;	CALL DEBUG

	MOV B,[DMAFLAG],00H
	MOV AL,00H
	MOV BH,0
	MOV BL,AH
	CMP BL,MAXBDOSFUN
	JNC BDOSFUNERROR
	SAL BX
	SEG CS
	JMP [BDOSFUNTABLE+BX]

NORMBDOS:
	INT 21H

BDOSDONE:
	CMP B,[DMAFLAG],00H	;FIX DMA?
	JZ NODMAMOD

	PUSH AX
	PUSH BX
	PUSH CX
	PUSH DX
	MOV DX,[DMA]
	MOV AH,1AH
	INT 21H
	POP DX
	POP CX
	POP BX 
	POP AX

NODMAMOD:
	POP DS
	MOV DI,BX
	OR AL,AL
	LAHF
	POP ES
	POP BP
	POP SI
	JMP DONE


BDOSFUNTABLE:
	DW USERBOOT	;0
	DW BDOSCONIN	;1
	DW BDOSCONOT	;2
	DW BDOSRDIN	;3
	DW BDOSPNOUT	;4
	DW BDOSLOUT	;5
	DW BDOSDIO	;6
	DW GETIO	;7
	DW PUTIO	;8
	DW BDOSPSOUT	;9
	DW BDOSRBUF	;10
	DW BDOSCONST	;11
	DW BVERSION	;12
	DW RESETSYS	;13
	DW SELDISK	;14
	DW OPENFILE	;15
	DW CLOSEFILE	;16
	DW SRCHFST	;17
	DW SRCHNXT	;18
	DW NORMBDOS	;19
	DW READSEQ	;20
	DW WRITESEQ	;21
	DW MAKEFILE	;22
	DW NORMBDOS	;23
	DW GETDLOG	;24
	DW NORMBDOS	;25
	DW SBDOSDMA	;26
	DW GETALLOC	;27
	DW NULLBDOS	;28
	DW NULLBDOS	;29
	DW NULLBDOS	;30
	DW GETPARM	;31
	DW NULLBDOS	;32
	DW RANREAD	;33
	DW RANWRITE	;34
	DW GETFSIZE	;35
	DW NORMBDOS	;36
	DW DRVRESET	;37
	DW BDOSFUNERROR	;38
	DW BDOSFUNERROR	;39
	DW RANZWRITE	;40
	DW BDOSFUNERROR	;41

MAXBDOSFUN: EQU 41


OPENFILE:
	PUSH BX
	MOV BX,DX
	MOV [BX+14],00H
	POP BX
	JMP NORMBDOS

CLOSEFILE:
	JMP NORMBDOS

GETFSIZE:
	JMP NORMBDOS

READSEQ:
	MOV B,[DMAFLAG],0FFH
	INT 21H
	CMP AL,03H
	JNZ READSEQX
	MOV AL,00H
READSEQX:
	JMP BDOSDONE

RANREAD:
	MOV B,[DMAFLAG],0FFH
	JMP NORMBDOS

WRITESEQ:
	MOV B,[DMAFLAG],0FFH
	PUSH BX
	MOV BX,DX
	MOV B,[BX+13],00H	;PATCH FCB
	POP BX
	JMP NORMBDOS

RANWRITE:
	MOV B,[DMAFLAG],0FFH
	JMP NORMBDOS

RANZWRITE:
	MOV B,[DMAFLAG],0FFH
	JMP NORMBDOS

MAKEFILE:
	PUSH BX
	MOV BX,DX
	MOV B,[BX+14],00H
	POP BX
	JMP NORMBDOS


DRVRESET:
	MOV AH,0DH
	JMP NORMBDOS

RESETSYS:
	MOV [DRVLOG],01H
	JMP NORMBDOS

SBDOSDMA:
	MOV [DMA],DX
	JMP NORMBDOS

NULLBDOS:
	MOV AL,00H
	MOV BX,0000H
	JMP BDOSDONE

BVERSION:
	MOV AL,22H
	MOV BX,0022H
	JMP BDOSDONE
;
SRCHFST:
	PUSH SI
	PUSH DI
	MOV SI,DX
	MOV DI,TEMPFCB
	MOV CX,48
	REP
	MOVB
	POP DI
	POP SI

	MOV DI,DX
	CMP B,[DI+0CH],'?'	;EXTENT #
	JZ SRCHFSTOK
	CMP B,[DI+0CH],00H
	JZ SRCHFSTOK
	MOV AL,0FFH
	JMP SRCHFSTEND

SRCHFSTOK:
	PUSH DX
	MOV DX,TEMPFCB
	PUSH DS
	INT 21H
	POP DS
	CALL FIXDMA
	POP DX
SRCHFSTEND:
	JMP BDOSDONE


SRCHNXT:
	PUSH DX 
	MOV DX,TEMPFCB

	MOV DI,DX
	CMP B,[DI+0CH],'?'	;EXTENT #
	JZ SRCHNXTOK
	CMP B,[DI+0CH],00H
	JZ SRCHNXTOK
	MOV AL,0FFH
	JMP SRCHNXTEND

SRCHNXTOK:
	PUSH DS
	INT 21H
	POP DS
	CALL FIXDMA
	POP DX
SRCHNXTEND:
	JMP BDOSDONE


FIXDMA:
	PUSH DX
	PUSH BX
	PUSH AX
	MOV BX,[DMA]
	MOV AH,0FH
	MOV DX,BX
	INT 21H
	MOV BX,[DMA]
	MOV B,[BX],00H		;SET USR AS 00 
	MOV B,[BX+0CH],00H	;CLEAR EXT

	MOV AX,[BX+18]		;POKE FILE SIZE INFO
	CMP AX,0000H
	JNZ FULLSIZE
	MOV AX,[BX+16]
	CMP AX,03FFFH
	JNC FULLSIZE
	ADD AX,AX
	CMP AL,00H
	JZ FIXDMADONE
	INC AH

FIXDMADONE:
	MOV [BX+15],AH

	PUSH BX
	ADD BX,10H
	MOV AL,16
FIXDMABLKLP:
	MOV B,[BX],00H	;MARK ALL GROUPS IN DMA AS ZERO
	INC BX
	DEC AL
	JNZ FIXDMABLKLP
	POP BX 

	POP AX
	POP BX
	POP DX
	RET

FULLSIZE:
	MOV AH,80H
	JMP FIXDMADONE

GETIO:
	MOV AL,[03H]
	MOV BL,AL
	MOV BH,00H
	JMP BDOSDONE
PUTIO:
	MOV AL,AH
	MOV BL,AL
	MOV BH,00H
	MOV [03H],AL
	JMP BDOSDONE

GETDLOG:
	MOV BX,[DRVLOG]
	MOV AL,BL
	JMP BDOSDONE

SELDISK:
	MOV AL,DL
	MOV BX,01H
DLOGLOOP:
	DEC AL
	JC DLOGDN
	ROL BX
	JMP DLOGLOOP
DLOGDN:
	OR BX,[DRVLOG]
	MOV [DRVLOG],BX
	JMP NORMBDOS

GETALLOC:
	MOV BX,ALLOC
	MOV AL,BL
	JMP BDOSDONE
GETPARM:
	MOV BX,DPARM
	MOV AL,BL
	JMP BDOSDONE

;
BDOSCONIN:
	MOV B,[CONFLAG],0FFH
	CALL BCONIN
	JMP BDOSDONE

BDOSCONOT:
	MOV B,[CONFLAG],0FFH
	CALL BCONOT
	JMP BDOSDONE

BDOSRDIN:
	MOV B,[CONFLAG],0FFH
	CALL BRDIN
	JMP BDOSDONE

BDOSPNOUT:
	MOV B,[CONFLAG],0FFH
	CALL BPUNOUT
	JMP BDOSDONE

BDOSLOUT:
	MOV B,[CONFLAG],0FFH
	CALL BLISTOUT
	JMP BDOSDONE

BDOSCONST:
	MOV B,[CONFLAG],0FFH
	CALL BCONST
	JMP BDOSDONE

BDOSDIO:
	MOV B,[CONFLAG],00H
	CMP DL,0FFH
	JZ BDOSDST
	CALL BCONOT
	JMP BDOSDONE

BDOSDST:
	CALL BCONST
	CMP AL,00H
	JNZ BDOSDOUT
	JMP BDOSDONE

BDOSDOUT:
	CALL BCONIN
	JMP BDOSDONE

BDOSPSOUT:
	MOV B,[CONFLAG],0FFH
	MOV BX,DX
BPSOUTLP:
	MOV DL,[BX]
	CMP DL,'$'
	JZ BPSOUTDN
	PUSH BX
	CALL BCONOT
	POP BX
	INC BX
	JMP BPSOUTLP
BPSOUTDN:
	JMP BDOSDONE


FLIPPRT:
	XOR B,[PRTFLAG],0FFH
	JMP INBUFA

INBUFR:
	CALL RBBCRLF
	JMP BDOSDONE

IPCRLF:
	CALL RBBCRLF
	MOV B,[BEGBUFF],00H
	JMP INBUFA

BACKSPACE:
	CALL BACKUPCHR
	JMP INBUFA

BDOSRBUF:
;	JMP NORMBDOS
INBUFF:
	MOV BX,DX
	INC BX
	MOV B,[BX],00H
	MOV AL,[SPCOUNT]
	MOV [BEGBUFF],AL
	MOV B,[DELCOUNT],00H

INBUFA:
	PUSH DX
	PUSH BX
	PUSH CX
	MOV B,[CONFLAG],00H
	CALL BCONIN
	POP CX
	POP BX
	POP DX
	AND AL,7FH
	CMP AL,0AH
	JZ INBUFR
	CMP AL,0DH
	JZ INBUFR
	CMP AL,7FH
	JZ IDELETE
	CMP AL,08H
	JZ BACKSPACE
	CMP AL,'U'-40H
	JZ INBUFU
	CMP AL,'X'-40H
	JZ INBUFX
	CMP AL,'R'-40H
	JZ RETYPE
	CMP AL,'E'-40H
	JZ IPCRLF
	CMP AL,'P'-40H
	JZ FLIPPRT
	JMP SAVEBCHR

INBUFU:
	MOV AL,'#'
	CALL RBBCONOT
	CALL RBBCRLF
	CALL SETBEGBUFF
	MOV B,[BX],00H
	MOV B,[DELCOUNT],00H
	JMP INBUFA

INBUFX:
	MOV AL,[SPCOUNT]
	CMP AL,[BEGBUFF]
	JZ INBUFXDN
	CALL ERASECHAR
	JMP INBUFX
INBUFXDN:
	MOV B,[BX],00H
	JMP INBUFA

RETYPE:
	MOV B,[DELCOUNT],00H
	MOV AL,'#'
	CALL RBBCONOT
	CALL RBBCRLF
	CALL SETBEGBUFF
	CMP B,[BX],00H
	JZ RETYPEDN
	CALL TYPEITBACK
RETYPEDN:
	JMP INBUFA

IDELETE:
	CMP B,[BX],00H
	JZ NODELETE
	CALL RDBUFCHR
	PUSH AX
	CALL RBBCONOT
	POP AX
	DEC B,[BX]

	CMP AL,'I'-40H
	JZ TABBACKUP
	CMP AL,' '
	JNC NOTCTRLDEL
	ADD B,[DELCOUNT],2
NOTCTRLDEL:
	ADD B,[DELCOUNT],2
	JMP INBUFA

TABBACKUP:
	MOV AL,[SPCOUNT]
	AND AL,07H
	JNZ NOTFULLTAB
	MOV AL,08H
NOTFULLTAB:
	ADD [DELCOUNT],AL 
	
NODELETE:
	JMP INBUFA


BACKUPCHR:
	CMP B,[BX],00H
	JZ NOBACKUP
	CMP B,[SPCOUNT],00H
	JZ NOBACKUP

DELERALOOP:
	CMP B,[DELCOUNT],00H
	JZ DELBACKDN
	CALL ERASECHAR
	DEC B,[DELCOUNT]
	JNZ DELERALOOP

DELBACKDN:
	CALL ERASECHAR
	DEC B,[BX]
NOBACKUP:
	RET

ERASECHAR:
	MOV AL,08H
	CALL RBBCONOT
	MOV AL,' '
	CALL RBBCONOT
	MOV AL,08H
	CALL RBBCONOT
	RET

RDBUFCHR:
	PUSH CX
	PUSH BX
	MOV CH,00H
	MOV CL,[BX]
	ADD BX,CX
	MOV AL,[BX]
	POP BX
	POP CX
	RET

TYPEITBACK:
	PUSH CX
	PUSH BX
	MOV CL,[BX]
CTLRLP:
	INC BX
	MOV AL,[BX]
	CALL RBBCONOT
	DEC CL
	JNZ CTLRLP
	POP BX
	POP CX
	RET

FORWARDTAB:
	PUSH CX
	MOV CL,[SPCOUNT]
	AND CL,07H
FWDTABDN:
	MOV AL,08H
	SUB AL,CL
	DEC AL
	POP CX
	ADD [DELCOUNT],AL
	MOV AL,'I'-40H
	JMP SAVCHRCNT

SAVEBCHR:
	CMP AL,'I'-40H
	JZ FORWARDTAB
	CMP AL,'C'-40H
	JNZ SAVCHRCNT
	CMP B,[BX],00H
	JNZ SAVCHRCNT
	JMP USERBOOT

SAVCHRCNT:
	INC B,[BX]
	PUSH CX
	PUSH BX
	MOV CH,00H
	MOV CL,[BX]
	ADD BX,CX
	MOV [BX],AL
	POP BX
	CALL RBBCONOT
	MOV CL,[BX]
	CMP CL,[BX-1]
	POP CX
	JNC IALERT
	JMP INBUFA

IALERT:
	JMP INBUFR	;OVERFLOW EXIT

RBBCONOT:
	PUSH DX
	PUSH BX
	PUSH CX
	PUSH AX
	CMP AL,0DH
	JZ DORBCONOT
	CMP AL,0AH
	JZ DORBCONOT 
	CMP AL,'I'-40H
	JZ DORBCONOT
	CMP AL,'H'-40H
	JZ DORBCONOT
	CMP AL,' '
	JNC DORBCONOT
	PUSH AX
	MOV AL,'^'
	CALL RBBCONOT
	POP AX
	OR AL,40H
DORBCONOT:
	MOV B,[CONFLAG],0FFH
	MOV DL,AL
	CALL BCONOT
	POP AX
	POP CX
	POP BX
	POP DX
	RET

RBBCRLF:
	PUSH AX
	MOV AL,0DH
	CALL RBBCONOT
	MOV AL,0AH
	CALL RBBCONOT
	POP AX
	RET

SETBEGBUFF:
	MOV AL,[SPCOUNT]
	CMP AL,[BEGBUFF]
	JZ BEGBUFFDN
	MOV AL,' '
	CALL RBBCONOT
	JMP SETBEGBUFF
BEGBUFFDN:
	RET






INITMORE:
	MOV SI,2
	MOV BX,[SI]

;
; SETUP TEMP FCB
	PUSH BX
	MOV SI,005CH
	MOV DI,FCB
	MOV CX,16
	REP
	MOVB
	POP BX
;
; SET UP SEGMENT REGISTER
	MOV DX,RAMSEGMENT
	MOV CX,DS
	ADD DX,CX
	MOV ES,DX

	MOV AX,DX
	ADD AX,4096
	CMP AX,BX
	JC INITSZOK

	SUB AX,BX
	PUSH AX
	MOV AL,CR
	CALL TYPEITOUT
	MOV AL,LF
	CALL TYPEITOUT
	MOV AL,BELL
	CALL TYPEITOUT
	MOV AL,'['
	CALL TYPEITOUT
	MOV AL,'-'
	CALL TYPEITOUT
	POP AX
	PUSH AX
	MOV AL,AH
	CALL PRTBYTE
	POP AX
	CALL PRTBYTE
	MOV AL,'0'
	CALL TYPEITOUT

	MOV BX,CS
	MOV DS,BX
	MOV DX,NOMEMMSG
	MOV AH,09H
	INT 21H
	JMP USERBOOT		;RE BOOT

NOMEMMSG:
	DB '] *** Insufficient user memory available to run program ***'
	DB 7,CR,LF,'$' 



;
; SETUP JUMP TABLES OF CPM
;
INITSZOK:
	MOV SI,BOOT
	MOV DI,0000H
	MOV CX,100H
	REP
	MOVB
;
	MOV SI,REALBDOS
	MOV DI,0EC06H
	MOV CX,3
	REP
	MOVB
;
	MOV SI,CPMJMP
	MOV DI,0FA00H
	MOV CX,64
	REP
	MOVB

	MOV SI,CBOOT
	MOV DI,0FB00H
	MOV CX,128
	REP
	MOVB

;
; SETUP FCB TO READ IN COM FILE



	CMP B,[FCB+9],20H
	JNZ WHOLEFCB

	MOV B,[FCB+9],'C'
	MOV B,[FCB+10],'P'
	MOV B,[FCB+11],'M'

WHOLEFCB:
	MOV SI,FCB
	MOV DI,0FE00H
	MOV CX,36
	REP
	MOVB
;
	MOV DS,DX
;CREATE DEFDMA COMMAND LINE
;
	MOV BX,81H
SPDINITLP:
	SEG CS
	MOV AL,[80H]
	CMP AL,00H
	JZ DEFEMPTY
	SEG CS
	MOV AL,[BX]
	CMP AL,20H
	JNZ SPSEARCH	
	INC BX
	SEG CS
	DEC B,[80H]
	JZ DEFEMPTY
	JMP SPDINITLP

SPSEARCH:
	SEG CS
	MOV AL,[BX]
	CMP AL,20H
	JZ FOUNDSP
	INC BX
	SEG CS
	DEC B,[80H]
	JZ DEFEMPTY
	JMP SPSEARCH

FOUNDSP:
	SEG CS
	MOV AL,[80H]
	MOV [80H],AL
	MOV DI,81H
FILEMOVLP:
	SEG CS
	MOV AL,[BX]
	MOV [DI],AL
	INC BX
	INC DI
	SEG CS
	DEC B,[80H]
 	JNZ FILEMOVLP
	MOV B,[DI],00H
	JMP FILEMOVDN
DEFEMPTY:
	MOV W,[80H],00H

FILEMOVDN:
	MOV B,[BYTERDYFLG],00H	;INIT FLAGS
	MOV B,[COMBRDYFLG],00H
	MOV B,[PRTFLAG],00H
	MOV B,[SPCOUNT],00H
	MOV B,[CURFLAG],00H
	MOV B,[EQFLAG],00H
	MOV B,[ROWFLAG],00H

	MOV W,[DRVLOG],01H	;START WITH DRIVE A ALWAYS LOGGED IN
	MOV AH,19H
	INT 21H			;ALSO LOG IN DEFAULT DRIVE
	INC AL
	MOV BX,1
DRVINTLOOP:
	DEC AL
	JZ DRVINTALLDN
	CLC
	RCL BX
	JMP DRVINTLOOP

DRVINTALLDN:
	OR [DRVLOG],BX

	MOV BX,ALLOC
	MOV CL,00H		;INIT DRV ALLOC TABLE
ALLOCINT:
	MOV B,[BX],00H
	INC BX
	DEC CL
	JNZ ALLOCINT

	MOV AH,30H
	INT 21H
	CMP AL,0
	JNZ SETDP2

	MOV W,[DPARM],32	;SPT	;FOR VERSION 1 MSDOS
	MOV B,[DPARM+2],3	;BSH
	MOV B,[DPARM+3],7	;BLM
	MOV B,[DPARM+4],0	;EXM
	MOV W,[DPARM+5],160	;DSM
	MOV W,[DPARM+7],63	;DRM
	MOV B,[DPARM+9],0C0H	;AL0
	MOV B,[DPARM+10],00H	;AL1
	MOV W,[DPARM+11],16	;CKS
	MOV W,[DPARM+13],2	;OFF
	JMP INITCURPOS

SETDP2:
	MOV W,[DPARM],36	;SPT	;FOR VERSION 2 MSDOS
	MOV B,[DPARM+2],3	;BSH
	MOV B,[DPARM+3],7	;BLM
	MOV B,[DPARM+4],0	;EXM
	MOV W,[DPARM+5],359	;DSM
	MOV W,[DPARM+7],63	;DRM
	MOV B,[DPARM+9],0C0H	;AL0
	MOV B,[DPARM+10],00H	;AL1
	MOV W,[DPARM+11],16	;CKS
	MOV W,[DPARM+13],2	;OFF


INITCURPOS:
	MOV AX,[DPARM+9]	;GET DIR ALLOC
	MOV W,[ALLOC],AX	;SETUP ALLOC TABLE 
	MOV AH,3		;INIT CURSOR TO SAFE POSITION
	MOV AL,0
	MOV BX,0
	INT 10H
	CMP DH,24
	JC SROWOK
	PUSH DX
	MOV AL,1
	MOV AH,6
	MOV CX,0
	MOV DH,23
	MOV DL,79
	SEG CS
	MOV BH,[ATRIB]
	INT 10H
	POP DX
	MOV DH,23
	MOV AH,2
	MOV AL,0
	MOV BX,0
	INT 10H
SROWOK:

;
     IF NOTREENTER
;
; OPEN THE COM FILE
;
	MOV BX,0FE01H
	MOV AL,[BX]
	CMP AL,' '
	JNZ GOTAFILE 

;DO ADVERTISMENT MSGS
ADVERT:
	MOV BX,BLNKSCR	;BLANK THE SCREEN FIRST
	CALL MSGLOOP
	MOV BX,CPMMSG	;NO FILENAME, SO PRINT HEADER 
	CALL MSGLOOP
	JMP USERBOOT

;-------------------------------------------------------
GOTAFILE:
	MOV AH,0FH	;OPEN FILE FUNCTION
	MOV DX,0FE00H	;FCB IN HIGH MEMORY
	INT 21H
	OR AL,AL
	JNZ NOFILEFND
	JMP OPENOK
;			FILE DOES NOT EXIST MESSAGE
NOFILEFND:
	MOV AL,CR
	CALL TYPEITOUT
	MOV AL,LF
	CALL TYPEITOUT
	MOV AL,BELL
	CALL TYPEITOUT

	MOV DX,0FE00H
	CALL FPRINT	;PRINT THE FILE NAME



	MOV BX,CS
	MOV DS,BX
	MOV DX,NOFILMSG
	MOV AH,09H
	INT 21H
	JMP USERBOOT		;RE BOOT

NOFILMSG:
	DB ' <- That program name does not exist ***',CR,LF,'$'

FILETOOBIG:
	MOV AL,CR
	CALL TYPEITOUT
	MOV AL,LF
	CALL TYPEITOUT
	MOV AL,BELL
	CALL TYPEITOUT

	MOV DX,0FE00H
	CALL FPRINT

	MOV BX,CS
	MOV DS,BX
	MOV DX,BIGFILMSG
	MOV AH,09H
	INT 21H
	JMP USERBOOT		;RE BOOT

BIGFILMSG:
	DB ' <- That program is too big to run ***',CR,LF,'$' 

;---------------------------------------------------------
MSGLOOP:
	MOV AX,CS	;MAKE SURE IT IS OUR DATA SEGMENT
	MOV DS,AX
	MOV DL,[BX]
	CMP DL,0FFH	;KEEP PRINTING UNTIL FF FOUND 
	JZ MSGDONE
	MOV AH,2
	PUSH BX
	INT 21H
	POP BX
	INC BX
	JMP MSGLOOP
MSGDONE:
	RET


;--------------------------------------------------------------------
OPENOK:
;
;
; READ COM FILE INTO MEMORY 
;
READFILE:
	MOV BX,[0FE00H+18]
	OR BX,BX
	JNZ FILETOOBIG

	MOV BX,[0FE00H+16]	;GET FILE SIZE TO READ
	CMP BX,0EC00H
	JNC FILETOOBIG
	MOV [0FE00H+14],BX

	MOV DX,100H
	MOV [DMA],DX
; READ A RECORD
READLOOP:
	MOV DX,[DMA]
	MOV AH,1AH	;SET DMA
	INT 21H
;
	MOV DX,0FE00H
	MOV AH,14H
	INT 21H		;READ PRG IN
;

     ENDIF


; CREATE FIRST AND SECOND FCB IN PROGRAM AREA
;
; CLEAR FCB AREA
;
	MOV BX,5CH	;TARGET AREA IN DS
	MOV CX,24H	;COUNT 80H-5CH
CLRLOOP:
	MOV B,[BX],00H	;CLEAR A BYTE
	INC BX
	DEC CX
	JNZ CLRLOOP
;
;		SET UP FIRST FILE NAME FOR EMULATOR
	MOV CX,16
	MOV BX,6CH
	MOV DI,5CH
MOVFILNAM:
	SEG CS
	MOV AL,[BX]
	MOV [DI],AL
	INC BX
	INC DI
	DEC CX
	JNZ MOVFILNAM

;NOW GEN THE SECOND FILENAME IN FCB

	MOV BX,81H
	MOV CL,[80H]
	MOV AL,[BX]
	CMP AL,20H
	JNZ SKIPFILE
	INC BX
	DEC CL

SKIPFILE:
	OR CL,CL
	JZ EMPTY
	MOV AL,[BX]
	CMP AL,20H
	JZ SKIPSPACE
	DEC CL
	INC BX
	JMP SKIPFILE
;
SKIPSPACE:
	INC BX
	DEC CL
	JZ EMPTY
	CMP B,[BX],20H
	JZ SKIPSPACE

;BX NOW POINTS TO BEG OF SECOND FILENAME,
; SO PARSE IT WITH MSDOS CALL 
;
FINDFILE:

	MOV DI,6CH
	MOV SI,DS
	MOV ES,SI
	MOV SI,BX
	MOV AL,00H
	MOV AH,29H
	INT 21H

	JMP FILEDONE

;GENERATE A BLANK FCB HERE IF NO NAME WAS GIVEN

EMPTY:
	MOV B,[6CH],00H

	MOV CL,11
	MOV BX,6DH
EMPTYSP:
	MOV B,[BX],20H
	INC BX
	DEC CL
	JNZ EMPTYSP
	JMP FILEDONE

;THE TRAILING NULLS WERE LOADED DURING THE FCB INIT



;THIS PRINTS A FILENAME

FPRINT:
	PUSH BX
	PUSH DX
	PUSH CX
	MOV BX,DX
	MOV AL,[BX]
	INC BX
	CMP AL,00H
	JNZ FPRINTOK
	MOV AH,19H
	INT 21H
	INC AL
FPRINTOK:
	OR AL,40H
	CALL TYPEITOUT
	MOV AL,3AH
	CALL TYPEITOUT
	MOV CX,9
FPRINT1LP:
	MOV AL,[BX]
	INC BX
	DEC CX
	JZ FPRINT3
	CMP AL,' '
	JZ FPRINT2
	CALL TYPEITOUT
	JMP FPRINT1LP
FPRINT2:
	INC BX
	DEC CX
	JNZ FPRINT2
FPRINT3:
	DEC BX
	MOV AL,'.'
	CALL TYPEITOUT
	MOV CX,4
FPRINT3LP:
	MOV AL,[BX]
	INC BX
	DEC CX
	JZ FPRINT4
	CMP AL,' '
	JZ FPRINT4
	CALL TYPEITOUT
	JMP FPRINT3LP
FPRINT4:
	POP DX
	POP BX
	POP CX
	RET


TYPEITOUT:
	PUSH AX
	PUSH CX
	PUSH DX
	MOV DL,AL
	MOV AH,2
	INT 21H
	POP DX
	POP CX
	POP AX
	RET

;WE AFE ALL READY, SO LET'S GO OK?

FILEDONE:

;
; SET DMA TO CP/M DEFAULT

	MOV DX,80H
	MOV [DMA],DX
	MOV AH,1AH	;SET DMA
	INT 21H

	MOV BP,CPMSTACK	;INIT CPM STACK
	MOV [CPMSTACK],0FA00H	;EXIT TO COLD BOOT 

;
; TURN OFF TRACE
	MOV B,[BUGFLG],00H

SETPC:
	MOV SI,100H

;
; CLEAR COMMAND LINE
;
; DO AN INSTRUCTION ROUTINE
; MAIN SUBROUTINE TO FETCH THE FIRST BYTE OF AN INSTRUCTION
; AND CHOSE A ROUTINE TO PERFORM THE REQUIRED FUNCTION.
;
; THE ROUTINE JUMPED TO SHOULD JUMP BACK TO DONE, WHEN FINISHED
; TO PERFORM THE NEXT INSTRUCTION.
;
DONE:
;
; RETURN HERE FROM INSTRUCTION PROCESSING
;
DOANINST:
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


;
;
; TABLE OF JUMP ADDRESSES FOR EACH POSSIBLE INSTRUCTION
; Z80 CODE IS NOT IMPLEMENTED.
;
;
;
;
JMPTAB:	DW NOP80		;00H
	DW LXIB
	DW STAXB
	DW INXB
	DW INRB
	DW DCRB
	DW MVIB
	DW RLC80
	DW Z8008		;08H
	DW DADB
	DW LDAXB
	DW DCXB
	DW INRC
	DW DCRC
	DW MVIC
	DW RRC80
	DW DJNZ		;10H
	DW LXID
	DW STAXD
	DW INXD
	DW INRD
	DW DCRD
	DW MVID
	DW RAL80
	DW RELJMP		;18H
	DW DADD
	DW LDAXD
	DW DCXD
	DW INRE
	DW DCRE
	DW MVIE
	DW RAR80
	DW JRNZ		;20H
	DW LXIH
	DW SHLD
	DW INXH
	DW INRH
	DW DCRH
	DW MVIH
	DW DAA80
	DW JRZ		;28H
	DW DADH
	DW LHLD
	DW DCXH
	DW INRL
	DW DCRL
	DW MVIL
	DW CMA80
	DW JRNC		;30H
	DW LXISP
	DW STA
	DW INXSP
	DW INRM
	DW DCRM
	DW MVIM
	DW STC80
	DW JRC		;38H
	DW DADSP
	DW LDA
	DW DCXSP
	DW INRA
	DW DCRA
	DW MVIA
	DW CMC80
	DW MOVBB		;40H
	DW MOVBC
	DW MOVBD
	DW MOVBE
	DW MOVBH
	DW MOVBL
	DW MOVBM
	DW MOVBA
	DW MOVCB	;48H
	DW MOVCC
	DW MOVCD
	DW MOVCE
	DW MOVCH
	DW MOVCL
	DW MOVCM
	DW MOVCA
	DW MOVDB		;50H
	DW MOVDC
	DW MOVDD
	DW MOVDE
	DW MOVDH
	DW MOVDL
	DW MOVDM
	DW MOVDA
	DW MOVEB	;58H
	DW MOVEC
	DW MOVED
	DW MOVEE
	DW MOVEH
	DW MOVEL
	DW MOVEM
	DW MOVEA
	DW MOVHB	;60H
	DW MOVHC
	DW MOVHD
	DW MOVHE
	DW MOVHH
	DW MOVHL
	DW MOVHM
	DW MOVHA
	DW MOVLB
	DW MOVLC
	DW MOVLD
	DW MOVLE
	DW MOVLH
	DW MOVLL
	DW MOVLM
	DW MOVLA
	DW MOVMB	;70H
	DW MOVMC
	DW MOVMD
	DW MOVME
	DW MOVMH
	DW MOVML
	DW HLT80		;76H
	DW MOVMA
	DW MOVAB
	DW MOVAC
	DW MOVAD
	DW MOVAE
	DW MOVAH
	DW MOVAL
	DW MOVAM
	DW MOVAA
	DW ADDB		;80H
	DW ADDC
	DW ADDD
	DW ADDE
	DW ADDH
	DW ADDL
	DW ADDM
	DW ADDA
	DW ADCB
	DW ADCC
	DW ADCD
	DW ADCE
	DW ADCH
	DW ADCL
	DW ADCM
	DW ADCA
	DW SUBB		;90H
	DW SUBC
	DW SUBD
	DW SUBE
	DW SUBH
	DW SUBL
	DW SUBM
	DW SUBA
	DW SBBB
	DW SBBC
	DW SBBD
	DW SBBE
	DW SBBH
	DW SBBL
	DW SBBM
	DW SBBA
	DW ANAB		;A0H
	DW ANAC
	DW ANAD
	DW ANAE
	DW ANAH
	DW ANAL
	DW ANAM
	DW ANAA
	DW XRAB
	DW XRAC
	DW XRAD
	DW XRAE
	DW XRAH
	DW XRAL
	DW XRAM
	DW XRAA
	DW ORAB		;B0H
	DW ORAC
	DW ORAD
	DW ORAE
	DW ORAH
	DW ORAL
	DW ORAM
	DW ORAA
	DW CMPB
	DW CMPC
	DW CMPD
	DW CMPE
	DW CMPH
	DW CMPL
	DW CMPM
	DW CMPA
	DW RNZ80
	DW POPB		;C1H
	DW JNZ80
	DW JMP80
	DW CNZ80
	DW PUSHB	;C5H
	DW ADI80
	DW RST0		;C7H
	DW RZ80
	DW XRET
	DW JZ80
	DW CBMACRO		;CBH
	DW CZ80
	DW CALL80
	DW ACI80
	DW RST1		;CFH
	DW RNC80
	DW POPD		;D1H
	DW JNC80
	DW OUT80
	DW CNC80
	DW PUSHD	;D5H
	DW SUI80
	DW RST2		;D7H
	DW RC80
	DW Z80D9		;D9H
	DW JC80
	DW IN80
	DW CC80
	DW DDMACRO		;DDH
	DW SBI80
	DW RST3		;DFH
	DW RPO80
	DW POPH		;E1H
	DW JPO80
	DW XTHL
	DW CPO80
	DW PUSHH	;E5H
	DW ANI80
	DW RST4		;E7H
	DW RPE80
	DW PCHL
	DW JPE80
	DW XCHG80
	DW CPE80
	DW EDMACRO	;EDH
	DW XRI80
	DW RST5		;EFH
	DW RP80
	DW POPPSW
	DW JP80
	DW DI80
	DW CP80
	DW PUSHPSW
	DW ORI80
	DW RST6		;F7H
	DW RM80
	DW SPHL
	DW JM80
	DW EI80
	DW CM80
	DW FDMACRO		;FDH
	DW CPI80
	DW RST7		;FFH
;
; END OF CODE TABLE
;
;Z80 'DD' MACRO EXTENSION CALLS
;
DDMACRO:
	INC SI
;	CALL DEBUG
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [DDMACTABLE+BX]


DDMACTABLE:
	DW Z80DD	;0  00H
	DW Z80DD  	;1  01H
	DW Z80DD	;2  02H
	DW Z80DD	;3  03H
	DW Z80DD	;4  04H
	DW Z80DD	;5  05H
	DW Z80DD	;6  06H
	DW Z80DD	;7  07H
	DW Z80DD	;8  08H
	DW ADDIXBC	;9  09H
	DW Z80DD	;10 0AH	
	DW Z80DD	;11 0BH
	DW Z80DD	;12 0CH
	DW Z80DD	;13 0DH
	DW Z80DD	;14 0EH
	DW Z80DD	;15 0FH
	DW Z80DD	;16 10H
	DW Z80DD	;17 11H
	DW Z80DD	;18 12H
	DW Z80DD	;19 13H
	DW Z80DD	;20 14H
	DW Z80DD	;21 15H
	DW Z80DD	;22 16H
	DW Z80DD	;23 17H
	DW Z80DD	;24 18H
	DW ADDIXDE	;25 19H
	DW Z80DD	;26 1AH
	DW Z80DD	;27 1BH
	DW Z80DD	;28 1CH
	DW Z80DD	;29 1DH
	DW Z80DD	;30 1EH
	DW Z80DD	;31 1FH
	DW Z80DD	;32 20H
	DW LXIX
	DW SIXD
	DW INCIX
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD	;40 28H
	DW ADDIXIX
	DW LXID
	DW DECIX
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD	;48 30H
	DW Z80DD	;49
	DW Z80DD	;50
	DW Z80DD
	DW INCAIXD
	DW DECAIXD
	DW MOVIXDN
	DW Z80DD
	DW Z80DD	;56 38H
	DW ADDIXSP
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD	;64 40H
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW MOVBIXD
	DW Z80DD
	DW Z80DD	;72 48H
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW MOVCIXD
	DW Z80DD
	DW Z80DD	;80 50H
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW MOVDIXD
	DW Z80DD
	DW Z80DD	;88 58H
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW MOVEIXD
	DW Z80DD
	DW Z80DD 	;96 60H
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW MOVHIXD
	DW Z80DD
	DW Z80DD	;104 68H
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW MOVLIXD
	DW Z80DD
	DW MOVIXDB	;112 70H
	DW MOVIXDC
	DW MOVIXDD
	DW MOVIXDE
	DW MOVIXDH
	DW MOVIXDL
	DW Z80DD
	DW MOVIXDA
	DW Z80DD	;120 78H
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW MOVAIXD
	DW Z80DD

	DW Z80DD	;128 80H
	DW Z80DD	;129 81H
	DW Z80DD	;130 82H
	DW Z80DD	;131 83H
	DW Z80DD	;132 84H
	DW Z80DD	;133 85H
	DW ADDAIXD	;134 86H
	DW Z80DD	;135 87H
	DW Z80DD	;136 88H
	DW Z80DD	;137 89H
	DW Z80DD	;138 8AH
	DW Z80DD	;139 8BH
	DW Z80DD	;140 8CH
	DW Z80DD	;141 8DH
	DW ADCAIXD	;142 8EH
	DW Z80DD	;143 8FH
	DW Z80DD	;144 90H
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW SUBAIXD
	DW Z80DD
	DW Z80DD	;152 98H
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW SBBAIXD
	DW Z80DD
	DW Z80DD	;160 A0H
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW ANDAIXD
	DW Z80DD
	DW Z80DD	;168 A8H
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW XORAIXD
	DW Z80DD
	DW Z80DD	;176 B0H
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW ORAIXD
	DW Z80DD
	DW Z80DD	;184 B8H
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW CMPAIXD
	DW Z80DD
	DW Z80DD	;192 C0H
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD	;200 C8H
	DW Z80DD
	DW Z80DD
	DW DDCBMACRO
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD	;208 D0H
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD	;216 D8H
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD	;224 E0H
	DW POPIX
	DW Z80DD
	DW XTIX
	DW Z80DD
	DW PUSHIX
	DW Z80DD
	DW Z80DD
	DW Z80DD	;232 E8H
	DW PCIX
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD	;240 F0H
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD	;248 F8H
	DW SPIX
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD
	DW Z80DD	;255 FFH
;
; END OF 'DD' MACRO TABLE
;

;
;Z80 'ED' MACRO EXTENSION (INCLUDES INTERNAL MACRO CALLS)
; 
EDMACRO:
	INC SI
;	MOV BL,[SI]
;	CMP BL,18
;	JC EDMACE
;	CALL DEBUG
EDMACE:
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [EDMACTABLE+BX]


EDMACTABLE:
	DW RBDOS	;0  00H
	DW USERBOOT  	;1  01H
	DW USERBOOT	;2  02H
	DW JCONST	;3  03H
	DW JCONIN	;4  04H
	DW JCONOUT	;5  05H
	DW JLIST	;6  06H
	DW JPUNCH	;7  07H
	DW JREADER	;8  08H
	DW JHOME	;9  09H
	DW JSELDSK	;10 0AH	
	DW JSETTRK	;11 0BH
	DW JSETSEC	;12 0CH
	DW JSETDMA	;13 0DH
	DW JREAD	;14 0EH
	DW JWRITE	;15 0FH
	DW JLISTST	;16 10H
	DW JSECTRAN	;17 11H

	DW Z80ED	;18 12H
	DW Z80ED	;19 13H
	DW Z80ED	;20 14H
	DW Z80ED	;21 15H
	DW Z80ED	;22 16H
	DW Z80ED	;23 17H
	DW Z80ED	;24 18H
	DW Z80ED	;25 19H
	DW Z80ED	;26 1AH
	DW Z80ED	;27 1BH
	DW Z80ED	;28 1CH
	DW Z80ED	;29 1DH
	DW Z80ED	;30 1EH
	DW Z80ED	;31 1FH
	DW Z80ED	;32 20H
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED	;40 28H
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED	;48 30H
	DW Z80ED	;49
	DW Z80ED	;50
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED	;56 38H
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW INBBC	;64 40H
	DW OUTBBC
	DW SBBHLBC
	DW SBCD
	DW ANEG
	DW XRET
	DW NOP80
	DW MOVIA
	DW INCBC	;72 48H
	DW OUTCBC
	DW ADCHLBC
	DW LBCD
	DW Z80ED
	DW XRET
	DW Z80ED
	DW MOVRA
	DW INDBC	;80 50H
	DW OUTDBC
	DW SBBHLDE
	DW SDED
	DW Z80ED
	DW Z80ED
	DW NOP80
	DW MOVAI
	DW INEBC	;88 58H
	DW OUTEBC
	DW ADCHLDE
	DW LDED
	DW Z80ED
	DW Z80ED
	DW NOP80
	DW MOVAR
	DW INHBC	;96 60H
	DW OUTHBC
	DW SBBHLHL
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW XRRD
	DW INLBC	;104 68H
	DW OUTLBC
	DW ADCHLHL
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW XRLD
	DW INFBC	;112 70H
	DW NOP80
	DW SBBHLSP
	DW SSPD
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW INABC	;120 78H
	DW OUTABC
	DW ADCHLSP
	DW LSPD
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED

	DW Z80ED	;128 80H
	DW Z80ED	;129 81H
	DW Z80ED	;130 82H
	DW Z80ED	;131 83H
	DW Z80ED	;132 84H
	DW Z80ED	;133 85H
	DW Z80ED	;134 86H
	DW Z80ED	;135 87H
	DW Z80ED	;136 88H
	DW Z80ED	;137 89H
	DW Z80ED	;138 8AH
	DW Z80ED	;139 8BH
	DW Z80ED	;140 8CH
	DW Z80ED	;141 8DH
	DW Z80ED	;142 8EH
	DW Z80ED	;143 8FH
	DW Z80ED	;144 90H
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED	;152 98H
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW LDIZ		;160 A0H
	DW CPIZ
	DW INI
	DW OUTI
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW LDDZ		;168 A8H
	DW CPDZ
	DW IND
	DW OUTD
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW LDIRZ	;176 B0H
	DW CPIRZ
	DW INIR
	DW OUTIR
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW LDDRZ	;184 B8H
	DW CPDRZ
	DW INDR
	DW OUTDR
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED	;192 C0H
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED	;200 C8H
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED	;208 D0H
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED	;216 D8H
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED	;224 E0H
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED	;232 E8H
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED	;240 F0H
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED	;248 F8H
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED
	DW Z80ED	;255 FFH
;
; END OF ED MACRO TABLE
;
FDMACRO:
	INC SI
;	CALL DEBUG
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [FDMACTABLE+BX]


FDMACTABLE:
	DW Z80FD	;0  00H
	DW Z80FD  	;1  01H
	DW Z80FD	;2  02H
	DW Z80FD	;3  03H
	DW Z80FD	;4  04H
	DW Z80FD	;5  05H
	DW Z80FD	;6  06H
	DW Z80FD	;7  07H
	DW Z80FD	;8  08H
	DW ADDIYBC	;9  09H
	DW Z80FD	;10 0AH	
	DW Z80FD	;11 0BH
	DW Z80FD	;12 0CH
	DW Z80FD	;13 0DH
	DW Z80FD	;14 0EH
	DW Z80FD	;15 0FH
	DW Z80FD	;16 10H
	DW Z80FD	;17 11H
	DW Z80FD	;18 12H
	DW Z80FD	;19 13H
	DW Z80FD	;20 14H
	DW Z80FD	;21 15H
	DW Z80FD	;22 16H
	DW Z80FD	;23 17H
	DW Z80FD	;24 18H
	DW ADDIYDE	;25 19H
	DW Z80FD	;26 1AH
	DW Z80FD	;27 1BH
	DW Z80FD	;28 1CH
	DW Z80FD	;29 1DH
	DW Z80FD	;30 1EH
	DW Z80FD	;31 1FH
	DW Z80FD	;32 20H
	DW LXIY
	DW SIYD
	DW INCIY
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD	;40 28H
	DW ADDIYIY
	DW LIYD
	DW DECIY
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD	;48 30H
	DW Z80FD	;49
	DW Z80FD	;50
	DW Z80FD
	DW INCAIYD
	DW DECAIYD
	DW MOVIYDN
	DW Z80FD
	DW Z80FD	;56 38H
	DW ADDIYSP
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD	;64 40H
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW MOVBIYD
	DW Z80FD
	DW Z80FD	;72 48H
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW MOVCIYD
	DW Z80FD
	DW Z80FD	;80 50H
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW MOVDIYD
	DW Z80FD
	DW Z80FD	;88 58H
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW MOVEIYD
	DW Z80FD
	DW Z80FD	;96 60H
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW MOVHIYD
	DW Z80FD
	DW Z80FD	;104 68H
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW MOVLIYD
	DW Z80FD
	DW MOVIYDB	;112 70H
	DW MOVIYDC
	DW MOVIYDD
	DW MOVIYDE
	DW MOVIYDH
	DW MOVIYDL
	DW MOVIYDA
	DW Z80FD
	DW Z80FD	;120 78H
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW MOVAIYD
	DW Z80FD

	DW Z80FD	;128 80H
	DW Z80FD	;129 81H
	DW Z80FD	;130 82H
	DW Z80FD	;131 83H
	DW Z80FD	;132 84H
	DW Z80FD	;133 85H
	DW ADDAIYD	;134 86H
	DW Z80FD	;135 87H
	DW Z80FD	;136 88H
	DW Z80FD	;137 89H
	DW Z80FD	;138 8AH
	DW Z80FD	;139 8BH
	DW Z80FD	;140 8CH
	DW Z80FD	;141 8DH
	DW ADCAIYD	;142 8EH
	DW Z80FD	;143 8FH
	DW Z80FD	;144 90H
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW SUBAIYD
	DW Z80FD
	DW Z80FD	;152 98H
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW SBBAIYD
	DW Z80FD
	DW Z80FD	;160 A0H
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW ANDAIYD
	DW Z80FD
	DW Z80FD	;168 A8H
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW XORAIYD
	DW Z80FD
	DW Z80FD	;176 B0H
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW ORAIYD
	DW Z80FD
	DW Z80FD	;184 B8H
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW CMPAIYD
	DW Z80FD
	DW Z80FD	;192 C0H
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD	;200 C8H
	DW Z80FD
	DW Z80FD
	DW FDCBMACRO
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD	;208 D0H
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD	;216 D8H
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD	;224 E0H
	DW POPIY
	DW Z80FD
	DW XTIY
	DW Z80FD
	DW PUSHIY
	DW Z80FD
	DW Z80FD
	DW Z80FD	;232 E8H
	DW PCIY
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD	;240 F0H
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD	;248 F8H
	DW SPIY
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD
	DW Z80FD	;255 FFH
;
; END OF 'FD' MACRO TABLE
;
;**********************************************

CBMACRO:
	INC SI
;	CALL DEBUG
	MOV ES,DI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [CBMACTABLE+BX]


DDCBMACRO:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	ADD BX,[IIX]
	MOV ES,BX
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [CBMACTABLE+BX]

FDCBMACRO:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	ADD BX,[IIY]
	MOV ES,BX
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [CBMACTABLE+BX]


CBMACTABLE:
	DW RLCB		;0  00H
	DW RLCC  	;1  01H
	DW RLCD		;2  02H
	DW RLCE		;3  03H
	DW RLCH		;4  04H
	DW RLCL		;5  05H
	DW RLCM		;6  06H
	DW RLCA		;7  07H
	DW RRCB		;8  08H
	DW RRCC		;9  09H
	DW RRCD		;10 0AH	
	DW RRCE		;11 0BH
	DW RRCH		;12 0CH
	DW RRCL		;13 0DH
	DW RRCM		;14 0EH
	DW RRCA		;15 0FH
	DW ZRLB		;16 10H
	DW ZRLC		;17 11H
	DW ZRLD		;18 12H
	DW ZRLE		;19 13H
	DW ZRLH		;20 14H
	DW ZRLL		;21 15H
	DW ZRLM		;22 16H
	DW ZRLA		;23 17H
	DW ZRRB		;24 18H
	DW ZRRC		;25 19H
	DW ZRRD		;26 1AH
	DW ZRRE		;27 1BH
	DW ZRRH		;28 1CH
	DW ZRRL		;29 1DH
	DW ZRRM		;30 1EH
	DW ZRRA		;31 1FH
	DW SLAB		;32 20H
	DW SLAC
	DW SLAD
	DW SLAE
	DW SLAH
	DW SLAL
	DW SLAM
	DW SLAA
	DW SRAB		;40 28H
	DW SRAC
	DW SRAD
	DW SRAE
	DW SRAH
	DW SRAL
	DW SRAM
	DW SRAA
	DW Z80CB	;48 30H
	DW Z80CB	;49
	DW Z80CB	;50
	DW Z80CB
	DW Z80CB
	DW Z80CB
	DW Z80CB
	DW Z80CB
	DW SRLB		;56 38H
	DW SRLC
	DW SRLD
	DW SRLE
	DW SRLH
	DW SRLL
	DW SRLM
	DW SRLA
	DW BITB0	;64 40H
	DW BITC0
	DW BITD0
	DW BITE0
	DW BITH0
	DW BITL0
	DW BITM0
	DW BITA0
	DW BITB1	;72 48H
	DW BITC1
	DW BITD1
	DW BITE1
	DW BITH1
	DW BITL1
	DW BITM1
	DW BITA1
	DW BITB2	;80 50H
	DW BITC2
	DW BITD2
	DW BITE2
	DW BITH2
	DW BITL2
	DW BITM2
	DW BITA2
	DW BITB3	;88 58H
	DW BITC3
	DW BITD3
	DW BITE3
	DW BITH3
	DW BITL3
	DW BITM3
	DW BITA3
	DW BITB4	;96 60H
	DW BITC4
	DW BITD4
	DW BITE4
	DW BITH4
	DW BITL4
	DW BITM4
	DW BITA4
	DW BITB5	;104 68H
	DW BITC5
	DW BITD5
	DW BITE5
	DW BITH5
	DW BITL5
	DW BITM5
	DW BITA5
	DW BITB6	;112 70H
	DW BITC6
	DW BITD6
	DW BITE6
	DW BITH6
	DW BITL6
	DW BITM6
	DW BITA6
	DW BITB7	;120 78H
	DW BITC7
	DW BITD7
	DW BITE7
	DW BITH7
	DW BITL7
	DW BITM7
	DW BITA7

	DW RESB0	;128 80H
	DW RESC0	;129 81H
	DW RESD0	;130 82H
	DW RESE0	;131 83H
	DW RESH0	;132 84H
	DW RESL0	;133 85H
	DW RESM0	;134 86H
	DW RESA0	;135 87H
	DW RESB1	;136 88H
	DW RESC1	;137 89H
	DW RESD1	;138 8AH
	DW RESE1	;139 8BH
	DW RESH1	;140 8CH
	DW RESL1	;141 8DH
	DW RESM1	;142 8EH
	DW RESA1	;143 8FH
	DW RESB2	;144 90H
	DW RESC2
	DW RESD2
	DW RESE2
	DW RESH2
	DW RESL2
	DW RESM2
	DW RESA2
	DW RESB3	;152 98H
	DW RESC3
	DW RESD3
	DW RESE3
	DW RESH3
	DW RESL3
	DW RESM3
	DW RESA3
	DW RESB4	;160 A0H
	DW RESC4
	DW RESD4
	DW RESE4
	DW RESH4
	DW RESL4
	DW RESM4
	DW RESA4
	DW RESB5	;168 A8H
	DW RESC5
	DW RESD5
	DW RESE5
	DW RESH5
	DW RESL5
	DW RESM5
	DW RESA5
	DW RESB6	;176 B0H
	DW RESC6
	DW RESD6
	DW RESE6
	DW RESH6
	DW RESL6
	DW RESM6
	DW RESA6
	DW RESB7	;184 B8H
	DW RESC7
	DW RESD7
	DW RESE7
	DW RESH7
	DW RESL7
	DW RESM7
	DW RESA7
	DW SETB0	;192 C0H
	DW SETC0
	DW SETD0
	DW SETE0
	DW SETH0
	DW SETL0
	DW SETM0
	DW SETA0
	DW SETB1	;200 C8H
	DW SETC1
	DW SETD1
	DW SETE1
	DW SETH1
	DW SETL1
	DW SETM1
	DW SETA1
	DW SETB2	;208 D0H
	DW SETC2
	DW SETD2
	DW SETE2
	DW SETH2
	DW SETL2
	DW SETM2
	DW SETA2
	DW SETB3	;216 D8H
	DW SETC3
	DW SETD3
	DW SETE3
	DW SETH3
	DW SETL3
	DW SETM3
	DW SETA3
	DW SETB4	;224 E0H
	DW SETC4
	DW SETD4
	DW SETE4
	DW SETH4
	DW SETL4
	DW SETM4
	DW SETA4
	DW SETB5	;232 E8H
	DW SETC5
	DW SETD5
	DW SETE5
	DW SETH5
	DW SETL5
	DW SETM5
	DW SETA5
	DW SETB6	;240 F0H
	DW SETC6
	DW SETD6
	DW SETE6
	DW SETH6
	DW SETL6
	DW SETM6
	DW SETA6
	DW SETB7	;248 F8H
	DW SETC7
	DW SETD7
	DW SETE7
	DW SETH7
	DW SETL7
	DW SETM7
	DW SETA7	;255 FFH
;
; END OF 'CB' MACRO TABLE
;

;
;********************************************************
;
; PERFORM EACH INSTRUCTION
;
;

MOVBB:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

MOVBC:
	MOV CH,CL
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

MOVBD:
	MOV CH,DH
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

MOVBE:
	MOV CH,DL
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVBH:
	MOV BX,DI
	MOV CH,BH
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVBL:
	MOV BX,DI
	MOV CH,BL
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVBM:
	MOV CH,[DI]
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVBA:
	MOV CH,AL
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVCB:
	MOV CL,CH
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVCC:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVCD:
	MOV CL,DH
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVCE:
	MOV CL,DL
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVCH:
	MOV BX,DI
	MOV CL,BH
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVCL:
	MOV BX,DI
	MOV CL,BL
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVCM:
	MOV CL,[DI]
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVCA:
	MOV CL,AL
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVDB:
	MOV DH,CH
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVDC:
	MOV DH,CL
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVDD:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVDE:
	MOV DH,DL
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVDH:
	MOV BX,DI
	MOV DH,BH
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVDL:
	MOV BX,DI
	MOV DH,BL
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVDM:
	MOV DH,[DI]
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVDA:
	MOV DH,AL
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVEB:
	MOV DL,CH
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVEC:
	MOV DL,CL
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVED:
	MOV DL,DH
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVEE:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVEH:
	MOV BX,DI
	MOV DL,BH
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVEL:
	MOV BX,DI
	MOV DL,BL
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVEM:
	MOV DL,[DI]
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVEA:
	MOV DL,AL
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVHB:
	MOV BX,DI
	MOV BH,CH
	MOV DI,BX
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVHC:
	MOV BX,DI
	MOV BH,CL
	MOV DI,BX
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVHD:
	MOV BX,DI
	MOV BH,DH
	MOV DI,BX
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVHE:
	MOV BX,DI
	MOV BH,DL
	MOV DI,BX
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVHH:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVHL:
	MOV BX,DI
	MOV BH,BL
	MOV DI,BX
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVHM:
	MOV BX,DI
	MOV BH,[DI]
	MOV DI,BX
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVHA:
	MOV BX,DI
	MOV BH,AL
	MOV DI,BX
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVLB:
	MOV BX,DI
	MOV BL,CH
	MOV DI,BX
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVLC:
	MOV BX,DI
	MOV BL,CL
	MOV DI,BX
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVLD:
	MOV BX,DI
	MOV BL,DH
	MOV DI,BX
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVLE:
	MOV BX,DI
	MOV BL,DL
	MOV DI,BX
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVLH:
	MOV BX,DI
	MOV BL,BH
	MOV DI,BX
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVLL:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

MOVLM:
	MOV BX,DI
	MOV BL,[DI]
	MOV DI,BX
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVLA:
	MOV BX,DI
	MOV BL,AL
	MOV DI,BX
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]



MOVMB:
	MOV [DI],CH
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVMC:
	MOV [DI],CL
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVMD:
	MOV [DI],DH
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVME:
	MOV [DI],DL
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVMH:
	MOV BX,DI
	MOV [DI],BH
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVML:
	MOV BX,DI
	MOV [DI],BL
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


; NOTE MOVMM IS HLT

MOVMA:
	MOV [DI],AL
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]




MOVAB:
	MOV AL,CH
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVAC:
	MOV AL,CL
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVAD:
	MOV AL,DH
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVAE:
	MOV AL,DL
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVAH:
	MOV BX,DI
	MOV AL,BH
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVAL:
	MOV BX,DI
	MOV AL,BL
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVAM:
	MOV AL,[DI]
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVAA:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]



MVIB:
	INC SI
	MOV CH,[SI]
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MVIC:
	INC SI
	MOV CL,[SI]
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MVID:
	INC SI
	MOV DH,[SI]
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MVIE:
	INC SI
	MOV DL,[SI]
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MVIH:
	INC SI 
	MOV BX,DI
	MOV BH,[SI]
	MOV DI,BX
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MVIL:
	INC SI 
	MOV BX,DI
	MOV BL,[SI]
	MOV DI,BX
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MVIM:
	INC SI
	MOV BL,[SI]
	MOV [DI],BL
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]



MVIA:
	INC SI
	MOV AL,[SI]
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]



LXIB:
	INC SI
	MOV CX,[SI]
	INC SI
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


LXID:
	INC SI
	MOV DX,[SI]
	INC SI
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]



LXIH:
	INC SI
	MOV DI,[SI]
	INC SI
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


LXISP:
	INC SI
	MOV BP,[SI]
	INC SI
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

LDA:
	INC SI
	MOV BX,[SI]
	MOV AL,[BX]
	INC SI
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

STA:
	INC SI
	MOV BX,[SI]
	MOV [BX],AL
	INC SI
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

LHLD:
	INC SI
	MOV BX,[SI]
	MOV DI,[BX]
	INC SI
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

SHLD:
	INC SI
	MOV BX,[SI]
	MOV [BX],DI
	INC SI
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


LDAXB:
	MOV BX,CX
	MOV AL,[BX]
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


LDAXD:
	MOV BX,DX
	MOV AL,[BX]
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


STAXB:
	MOV BX,CX
	MOV [BX],AL
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


STAXD:
	MOV BX,DX
	MOV [BX],AL
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


XCHG80:
	XCHG DI,DX
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


ADDB:
	INC SI
	SAHF
	ADD AL,CH
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


ADDC:
	INC SI
	SAHF
	ADD AL,CL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


ADDD:
	INC SI
	SAHF
	ADD AL,DH
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


ADDE:
	INC SI
	SAHF
	ADD AL,DL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


ADDH:
	INC SI
	MOV BX,DI
	SAHF
	ADD AL,BH
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


ADDL:
	INC SI
	MOV BX,DI
	SAHF
	ADD AL,BL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


ADDM:
	INC SI
	SAHF
	ADD AL,[DI]
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


ADDA:
	INC SI
	SAHF
	ADD AL,AL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


ADI80:
	INC SI
	MOV BL,[SI]
	INC SI
	SAHF
	ADD AL,BL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


ADCB:
	INC SI
	SAHF
	ADC AL,CH
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


ADCC:
	INC SI
	SAHF
	ADC AL,CL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


ADCD:
	INC SI
	SAHF
	ADC AL,DH
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


ADCE:
	INC SI
	SAHF
	ADC AL,DL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


ADCH:
	INC SI
	MOV BX,DI
	SAHF
	ADC AL,BH
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


ADCL:
	INC SI
	MOV BX,DI
	SAHF
	ADC AL,BL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


ADCM:
	INC SI
	SAHF
	ADC AL,[DI]
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


ADCA:
	INC SI
	SAHF
	ADC AL,AL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


ACI80:
	INC SI
	MOV BL,[SI]
	INC SI
	SAHF
	ADC AL,BL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


SUBB:
	INC SI
	SAHF
	SUB AL,CH
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


SUBC:
	INC SI
	SAHF
	SUB AL,CL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


SUBD:
	INC SI
	SAHF
	SUB AL,DH
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


SUBE:
	INC SI
	SAHF
	SUB AL,DL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


SUBH:
	INC SI
	MOV BX,DI
	SAHF
	SUB AL,BH
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


SUBL:
	INC SI
	MOV BX,DI
	SAHF
	SUB AL,BL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


SUBM:
	INC SI
	SAHF
	SUB AL,[DI]
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


SUBA:
	INC SI
	SAHF
	SUB AL,AL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


SUI80:
	INC SI
	MOV BL,[SI]
	INC SI
	SAHF
	SUB AL,BL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


SBBB:
	INC SI
	SAHF
	SBB AL,CH
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


SBBC:
	INC SI
	SAHF
	SBB AL,CL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


SBBD:
	INC SI
	SAHF
	SBB AL,DH
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


SBBE:
	INC SI
	SAHF
	SBB AL,DL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


SBBH:
	INC SI
	MOV BX,DI
	SAHF
	SBB AL,BH
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


SBBL:
	INC SI
	MOV BX,DI
	SAHF
	SBB AL,BL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


SBBM:
	INC SI
	SAHF
	SBB AL,[DI]
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


SBBA:
	INC SI
	SAHF
	SBB AL,AL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


INRA:
	INC SI
	SAHF
	INC AL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

INRB:
	INC SI
	SAHF
	INC CH
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

INRC:
	INC SI
	SAHF
	INC CL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

INRD:
	INC SI
	SAHF
	INC DH
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

INRE:
	INC SI
	SAHF
	INC DL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

INRH:
	INC SI
	SAHF
	MOV BX,DI
	INC BH
	MOV DI,BX
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

INRL:
	INC SI
	SAHF
	MOV BX,DI
	INC BL
	MOV DI,BX
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

INRM:
	INC SI
	SAHF
	INC B,[DI]
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

DCRA:
	INC SI
	SAHF
	DEC AL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

DCRB:
	INC SI
	SAHF
	DEC CH
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

DCRC:
	INC SI
	SAHF
	DEC CL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

DCRD:
	INC SI
	SAHF
	DEC DH
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

DCRE:
	INC SI
	SAHF
	DEC DL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

DCRH:
	INC SI
	SAHF
	MOV BX,DI
	DEC BH
	MOV DI,BX
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

DCRL:
	INC SI
	SAHF
	MOV BX,DI
	DEC BL
	MOV DI,BX
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

DCRM:
	INC SI
	SAHF
	DEC B,[DI]
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

INXSP:
	INC SI
	INC BP
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


INXB:
	INC SI
	INC CX
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

INXD:
	INC SI
	INC DX
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

INXH:
	INC SI
	INC DI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

DCXSP:
	INC SI
	DEC BP
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

DCXB:
	INC SI
	DEC CX
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

DCXD:
	INC SI
	DEC DX
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

DCXH:
	INC SI
	DEC DI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

SBI80:
	INC SI
	MOV BL,[SI]
	INC SI
	SAHF
	SBB AL,BL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


DADB:
	INC SI
	ADD DI,CX
	RCR BL
	SAHF
	RCL BL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


DADD:
	INC SI
	ADD DI,DX
	RCR BL
	SAHF
	RCL BL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


DADH:
	INC SI
	ADD DI,DI
	RCR BL
	SAHF
	RCL BL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


DADSP:
	INC SI
	ADD DI,BP
	RCR BL
	SAHF
	RCL BL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


DAA80:
	INC SI
	SAHF
	DAA
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


ANAB:
	INC SI
	SAHF
	AND AL,CH
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]



ANAC:
	INC SI
	SAHF
	AND AL,CL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


ANAD:
	INC SI
	SAHF
	AND AL,DH
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


ANAE:
	INC SI
	SAHF
	AND AL,DL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


ANAH:
	INC SI
	MOV BX,DI
	SAHF
	AND AL,BH
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


ANAL:
	INC SI
	MOV BX,DI
	SAHF
	AND AL,BL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


ANAM:
	INC SI
	SAHF
	AND AL,[DI]
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


ANAA:
	INC SI
	SAHF
	AND AL,AL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]



ANI80:
	INC SI
	MOV BL,[SI]
	INC SI
	SAHF
	AND AL,BL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


XRAB:
	INC SI
	SAHF
	XOR AL,CH
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


XRAC:
	INC SI
	SAHF
	XOR AL,CL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


XRAD:
	INC SI
	SAHF
	XOR AL,DH
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


XRAE:
	INC SI
	SAHF
	XOR AL,DL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


XRAH:
	INC SI
	MOV BX,DI
	SAHF
	XOR AL,BH
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


XRAL:
	INC SI
	MOV BX,DI
	SAHF
	XOR AL,BL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


XRAM:
	INC SI
	SAHF
	XOR AL,[DI]
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


XRAA:
	INC SI
	SAHF
	XOR AL,AL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]



XRI80:
	INC SI
	MOV BL,[SI]
	INC SI
	SAHF
	XOR AL,BL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


ORAB:
	INC SI
	SAHF
	OR AL,CH
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


ORAC:
	INC SI
	SAHF
	OR AL,CL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


ORAD:
	INC SI
	SAHF
	OR AL,DH
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


ORAE:
	INC SI
	SAHF
	OR AL,DL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


ORAH:
	INC SI
	MOV BX,DI
	SAHF
	OR AL,BH
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


ORAL:
	INC SI
	MOV BX,DI
	SAHF
	OR AL,BL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


ORAM:
	INC SI
	SAHF
	OR AL,[DI]
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


ORAA:
	INC SI
	SAHF
	OR AL,AL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


ORI80:
	INC SI
	MOV BL,[SI]
	INC SI
	SAHF
	OR AL,BL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


CMPB:
	INC SI
	SAHF
	CMP AL,CH
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


CMPC:
	INC SI
	SAHF
	CMP AL,CL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


CMPD:
	INC SI
	SAHF
	CMP AL,DH
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


CMPE:
	INC SI
	SAHF
	CMP AL,DL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


CMPH:
	INC SI
	MOV BX,DI
	SAHF
	CMP AL,BH
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


CMPL:
	INC SI
	MOV BX,DI
	SAHF
	CMP AL,BL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


CMPM:
	INC SI
	SAHF
	CMP AL,[DI]
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


CMPA:
	INC SI
	SAHF
	CMP AL,AL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


CPI80:
	INC SI
	MOV BL,[SI]
	INC SI
	SAHF
	CMP AL,BL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

RLC80:
	INC SI
	SAHF
	ROL AL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

RRC80:
	INC SI
	SAHF
	ROR AL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

RAL80:
	INC SI
	SAHF
	RCL AL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

RAR80:
	INC SI
	SAHF
	RCR AL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

CMA80:
	INC SI
	NOT AL
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

CMC80:
	INC SI
	SAHF
	CMC
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

STC80:
	INC SI
	SAHF
	CLC
	CMC
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


JNZ80:
	SAHF
	JNZ JMP80
	ADD SI,3
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

JZ80:
	SAHF
	JZ JMP80
	ADD SI,3
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

JNC80:
	SAHF
	JNC JMP80
	ADD SI,3
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

JC80:
	SAHF
	JC JMP80
	ADD SI,3
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

JMP80:
	INC SI
	MOV SI,[SI]
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


JPO80:
	SAHF
	JPO JMP80
	ADD SI,3
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

JPE80:
	SAHF
	JPE JMP80
	ADD SI,3
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

JP80:
	SAHF
	JNS JMP80
	ADD SI,3
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

JM80:
	SAHF
	JS JMP80
	ADD SI,3
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


CNZ80:
	SAHF
	JNZ CALL80
	ADD SI,3
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

CZ80:
	SAHF
	JZ CALL80
	ADD SI,3
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

CNC80:
	SAHF
	JNC CALL80
	ADD SI,3
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

CC80:
	SAHF
	JC CALL80
	ADD SI,3
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

CALL80:
	DEC BP
	DEC BP
	ADD SI,3
	SEG DS
	MOV [BP],SI
	MOV SI,[SI-2]
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


CPO80:
	SAHF
	JPO CALL80
	ADD SI,3
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

CPE80:
	SAHF
	JPE CALL80
	ADD SI,3
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

CP80:
	SAHF
	JNS CALL80
	ADD SI,3
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

CM80:
	SAHF
	JS CALL80
	ADD SI,3
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


RNZ80:
	INC SI
	SAHF
	JNZ XRET
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

RZ80:
	INC SI
	SAHF
	JZ XRET
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

RNC80:
	INC SI
	SAHF
	JNC XRET
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

RC80:
	INC SI
	SAHF
	JC XRET
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]
XRET:
	SEG DS
	MOV SI,[BP]
	INC BP
	INC BP
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


RPO80:
	INC SI
	SAHF
	JPO XRET
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

RPE80:
	INC SI
	SAHF
	JPE XRET
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

RP80:
	INC SI
	SAHF
	JNS XRET
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

RM80:
	INC SI
	SAHF
	JS XRET
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]



RST0:
	INC SI
	DEC BP
	DEC BP
	SEG DS
	MOV [BP],SI
	MOV SI,00H
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


RST1:
	INC SI
	DEC BP
	DEC BP
	SEG DS
	MOV [BP],SI
	MOV SI,08H
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


RST2:
	INC SI
	DEC BP
	DEC BP
	SEG DS
	MOV [BP],SI
	MOV SI,10H
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


RST3:
	INC SI
	DEC BP
	DEC BP
	SEG DS
	MOV [BP],SI
	MOV SI,18H
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


RST4:
	INC SI
	DEC BP
	DEC BP
	SEG DS
	MOV [BP],SI
	MOV SI,20H
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


RST5:
	INC SI
	DEC BP
	DEC BP
	SEG DS
	MOV [BP],SI
	MOV SI,28H
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


RST6:
	INC SI
	DEC BP
	DEC BP
	SEG DS
	MOV [BP],SI
	MOV SI,30H
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


RST7:
	INC SI
	DEC BP
	DEC BP
	SEG DS
	MOV [BP],SI
	MOV SI,38H
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


PCHL:
	MOV SI,DI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]



PUSHPSW:
	DEC BP
	DEC BP
	MOV BL,AH
	MOV BH,AL
	SEG DS
	MOV [BP],BX
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

PUSHB:
	DEC BP
	DEC BP
	SEG DS
	MOV [BP],CX
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


PUSHD:
	DEC BP
	DEC BP
	SEG DS
	MOV [BP],DX
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


PUSHH:
	DEC BP
	DEC BP
	SEG DS
	MOV [BP],DI
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


;
;
POPPSW:
	SEG DS
	MOV BX,[BP]
	MOV AH,BL
	MOV AL,BH
	INC BP
	INC BP 
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

POPB:
	SEG DS
	MOV CX,[BP]
	INC BP
	INC BP 
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


POPD:
	SEG DS
	MOV DX,[BP]
	INC BP
	INC BP
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


POPH:
	SEG DS
	MOV DI,[BP]
	INC BP
	INC BP
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


XTHL:
	SEG DS
	XCHG DI,[BP] 
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


SPHL:
	MOV BP,DI
	INC SI
	SAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


HLT80:
	JMP DONE	;RUN THIS INSTRUCTION FOREVER

IN80:
	INC SI
	PUSH DX
	MOV DH,0
	MOV DL,[SI]
	INB DX
	POP DX
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]



OUT80:
	INC SI
	PUSH DX
	MOV DH,0
	MOV DL,[SI]
	OUTB DX		; SEE IF THIS WORKS TOO
	POP DX
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]



;INTERRUPT CONTROL DISALLOWED
EI80:
DI80:

NOP80:
	INC SI
	JMP DONE
;
;******************************************************
;Z80 EXTENTION INSTRUCTIONS BEGIN HERE
;

Z8008:
	INC SI
;	CALL DEBUG
	XCHG AX,[I2PSW]	;EX (AF & AF')
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

Z80D9:
	INC SI
;	CALL DEBUG
	XCHG CX,[I2BC]	;EXX (BC,DE,HL & BC',DE',HL')
	XCHG DX,[I2DE]
	XCHG DI,[I2HL]
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


XTIX:
	SEG DS
	MOV BX,[BP]
	XCHG BX,[IIX]
	SEG DS
	MOV [BP],BX
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


XTIY:
	SEG DS
	MOV BX,[BP]
	XCHG BX,[IIY]
	SEG DS
	MOV [BP],BX
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

LBCD:
	INC SI
	MOV BX,[SI]
	MOV CX,[BX]
	INC SI
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

LDED:
	INC SI
	MOV BX,[SI]
	MOV DX,[BX]
	INC SI
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

LSPD:
	INC SI
	MOV BX,[SI]
	MOV BP,[BX]
	INC SI
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

LIXD:
	INC SI
	MOV BX,[SI]
	MOV BX,[BX]
	MOV [IIX],BX
	INC SI
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

LIYD:
	INC SI
	MOV BX,[SI]
	MOV BX,[BX]
	MOV [IIY],BX
	INC SI
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


SBCD:
	INC SI
	MOV BX,[SI]
	MOV [BX],CX
	INC SI
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

SDED:
	INC SI
	MOV BX,[SI]
	MOV [BX],DX
	INC SI
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

SSPD:
	INC SI
	MOV BX,[SI]
	MOV [BX],BP
	INC SI
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

SIXD:
	INC SI
	MOV BX,[SI]
	PUSH DX
	MOV DX,[IIX]
	MOV [BX],DX
	POP DX
	INC SI
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

SIYD:
	INC SI
	MOV BX,[SI]
	PUSH DX
	MOV DX,[IIY]
	MOV [BX],DX
	POP DX
	INC SI
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


LXIX:
	INC SI
	MOV BX,[SI]
	MOV [IIX],BX
	INC SI
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

LXIY:
	INC SI
	MOV BX,[SI]
	MOV [IIY],BX
	INC SI
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

PUSHIX:
	DEC BP
	DEC BP
	MOV BX,[IIX]
	SEG DS
	MOV [BP],BX
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

PUSHIY:
	DEC BP
	DEC BP
	MOV BX,[IIY]
	SEG DS
	MOV [BP],BX
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

POPIX:
	SEG DS
	MOV BX,[BP]
	MOV [IIX],BX
	INC BP
	INC BP
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


POPIY:
	SEG DS
	MOV BX,[BP]
	MOV [IIY],BX
	INC BP
	INC BP
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVIA:
	MOV [II],AL
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

MOVRA:
	MOV [IR],AL
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

MOVAI:
	MOV AL,[II]
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

MOVAR:
	MOV AL,[IR]
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

ANEG:
	INC SI
	SAHF
	NEG AL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


PCIX:
	MOV SI,[IIX]
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

PCIY:
	MOV SI,[IIY]
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

SPIX:
	MOV BP,[IIX]
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

SPIY:
	MOV BP,[IIY]
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

MOVIXDA:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	ADD BX,[IIX]
	MOV [BX],AL
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

MOVIXDB:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	ADD BX,[IIX]
	MOV [BX],CH
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

MOVIXDC:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	ADD BX,[IIX]
	MOV [BX],CL
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


MOVIXDD:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	ADD BX,[IIX]
	MOV [BX],DH
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

MOVIXDE:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	ADD BX,[IIX]
	MOV [BX],DL
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

MOVIXDH:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	ADD BX,[IIX]
	PUSH DX
	MOV DX,DI
	MOV [BX],DH
	POP DX
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

MOVIXDL:
	INC SI 
	XOR BX,BX
	MOV BL,[SI]
	ADD BX,[IIX]
	PUSH DX
	MOV DX,DI
	MOV [BX],DL
	POP DX
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

MOVIYDA:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	ADD BX,[IIY]
	MOV [BX],AL
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

MOVIYDB:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	ADD BX,[IIY]
	MOV [BX],CH
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

MOVIYDC:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	ADD BX,[IIY]
	MOV [BX],CL
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

MOVIYDD:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	ADD BX,[IIY]
	MOV [BX],DH
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

MOVIYDE:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	ADD BX,[IIY]
	MOV [BX],DL
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

MOVIYDH:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	ADD BX,[IIY]
	PUSH DX
	MOV DX,DI
	MOV [BX],DH
	POP DX
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

MOVIYDL:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	ADD BX,[IIY]
	PUSH DX
	MOV DX,DI
	MOV [BX],DL
	POP DX
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

MOVAIXD:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	ADD BX,[IIX]
	MOV AL,[BX]
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

MOVBIXD:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	ADD BX,[IIX]
	MOV CH,[BX]
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

MOVCIXD:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	ADD BX,[IIX]
	MOV CL,[BX]
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

MOVDIXD:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	ADD BX,[IIX]
	MOV DH,[BX]
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

MOVEIXD:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	ADD BX,[IIX]
	MOV DL,[BX]
	INC SI 
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

MOVHIXD:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	ADD BX,[IIX]
	PUSH DX
	MOV DX,DI
	MOV DH,[BX]
	MOV DI,DX
	POP DX
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

MOVLIXD:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	ADD BX,[IIX]
	PUSH DX
	MOV DX,DI
	MOV DL,[BX]
	MOV DI,DX
	POP DX
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

MOVAIYD:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	ADD BX,[IIY]
	MOV AL,[BX]
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

MOVBIYD:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	ADD BX,[IIY]
	MOV CH,[BX]
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

MOVCIYD:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	ADD BX,[IIY]
	MOV CL,[BX]
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

MOVDIYD:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	ADD BX,[IIY]
	MOV DH,[BX]
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

MOVEIYD:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	ADD BX,[IIY]
	MOV DL,[BX]
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

MOVHIYD:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	ADD BX,[IIY]
	PUSH DX
	MOV DX,DI 
	MOV DH,[BX]
	MOV DI,DX
	POP DX
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

MOVLIYD:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	ADD BX,[IIY]
	PUSH DX
	MOV DX,DI
	MOV DL,[BX]
	MOV DI,DX
	POP DX
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

MOVIXDN:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	INC SI
	ADD BX,[IIX]
	PUSH DX
	MOV DL,[SI]
	MOV [BX],DL
	POP DX
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

MOVIYDN:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	INC SI
	ADD BX,[IIY]
	PUSH DX
	MOV DL,[SI]
	MOV [BX],DL
	POP DX
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

ADDIXBC:
	INC SI
	ADD [IIX],CX
	RCR BL
	SAHF
	RCL BL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

ADDIXDE:
	INC SI
	ADD [IIX],DX
	RCR BL
	SAHF
	RCL BL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

ADDIXIX:
	INC SI
	MOV BX,[IIX]
	ADD [IIX],BX
	RCR BL
	SAHF
	RCL BL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

ADDIXSP:
	INC SI
	ADD [IIX],BP
	RCR BL
	SAHF
	RCL BL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

ADDIYBC:
	INC SI
	ADD [IIY],CX
	RCR BL
	SAHF
	RCL BL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

ADDIYDE:
	INC SI
	ADD [IIY],DX
	RCR BL
	SAHF
	RCL BL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

ADDIYIY:
	INC SI
	MOV BX,[IIY]
	ADD [IIY],BX
	RCR BL
	SAHF
	RCL BL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

ADDIYSP:
	INC SI
	ADD [IIY],BP
	RCR BL
	SAHF
	RCL BL
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

INCIX:
	INC SI
	INC [IIX]
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

INCIY:
	INC SI
	INC [IIY]
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

DECIX:
	INC SI
	DEC [IIX]
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

DECIY:
	INC SI
	DEC [IIY]
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

ADCHLBC:
	INC SI
	SAHF
	ADC DI,CX
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

ADCHLDE:
	INC SI
	SAHF
	ADC DI,DX
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

ADCHLHL:
	INC SI
	SAHF
	ADC DI,DI
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

ADCHLSP:
	INC SI
	SAHF
	ADC DI,BP
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

SBBHLBC:
	INC SI
	SAHF
	SBB DI,CX
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

SBBHLDE:
	INC SI
	SAHF
	SBB DI,DX
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

SBBHLHL:
	INC SI
	SAHF
	SBB DI,DI
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

SBBHLSP:
	INC SI
	SAHF
	SBB DI,BP
	LAHF
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

ADDAIXD:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	ADD BX,[IIX]
	SAHF
	ADD AL,[BX]
	LAHF
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

ADCAIXD:
	INC SI 
	XOR BX,BX
	MOV BL,[SI]
	ADD BX,[IIX]
	SAHF
	ADC AL,[BX]
	LAHF
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

SUBAIXD:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	ADD BX,[IIX]
	SAHF
	SUB AL,[BX]
	LAHF
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

SBBAIXD:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	ADD BX,[IIX]
	SAHF
	SBB AL,[BX]
	LAHF
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

ANDAIXD:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	ADD BX,[IIX]
	SAHF
	AND AL,[BX]
	LAHF
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

XORAIXD:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	ADD BX,[IIX]
	SAHF
	XOR AL,[BX]
	LAHF
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

ORAIXD:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	ADD BX,[IIX]
	SAHF
	OR AL,[BX]
	LAHF
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

CMPAIXD:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	ADD BX,[IIX]
	SAHF
	CMP AL,[BX]
	LAHF
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

INCAIXD:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	ADD BX,[IIX]
	SAHF
	INC B,[BX]
	LAHF
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

DECAIXD:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	ADD BX,[IIX]
	SAHF
	DEC B,[BX]
	LAHF
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

ADDAIYD:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	ADD BX,[IIY]
	SAHF
	ADD AL,[BX]
	LAHF
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

ADCAIYD:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	ADD BX,[IIY]
	SAHF
	ADC AL,[BX]
	LAHF
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

SUBAIYD:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	ADD BX,[IIY]
	SAHF
	SUB AL,[BX]
	LAHF
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

SBBAIYD:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	ADD BX,[IIY]
	SAHF
	SBB AL,[BX]
	LAHF
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

ANDAIYD:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	ADD BX,[IIY]
	SAHF
	AND AL,[BX]
	LAHF
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

XORAIYD:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	ADD BX,[IIY]
	SAHF
	XOR AL,[BX]
	LAHF
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

ORAIYD:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	ADD BX,[IIY]
	SAHF
	OR AL,[BX]
	LAHF
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

CMPAIYD:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	ADD BX,[IIY]
	SAHF
	CMP AL,[BX]
	LAHF
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

INCAIYD:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	ADD BX,[IIY]
	SAHF
	INC B,[BX]
	LAHF
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

DECAIYD:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	ADD BX,[IIY]
	SAHF
	DEC B,[BX]
	LAHF
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


LDIZ:
	OR AH,04H
	MOV BX,DX
	MOV DL,[DI]
	MOV [BX],DL
	MOV DX,BX
	INC DX
	INC DI
	DEC CX
	JNZ LDIZ5
	AND AH,0FBH
LDIZ5:
	AND AH,0EDH
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

LDIRZ:
	PUSH ES
	PUSH DI
	PUSH SI
	MOV BX,DS
	MOV ES,BX
	MOV SI,DI
	MOV DI,DX
	CLD
	REP
	MOVSB
	MOV DX,DI
	MOV DI,SI
	POP SI
	POP DI
	POP ES
	AND AH,0E9H
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]
	
LDDZ:
	OR AH,04H
	MOV BX,DX
	MOV DL,[DI]
	MOV [BX],DL
	MOV DX,BX
	DEC DI
	DEC DX
	DEC CX
	JNZ LDDZ5
	AND AH,0FBH
LDDZ5:
	AND AH,0EDH
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

LDDRZ:
	PUSH ES
	PUSH DI
	PUSH SI
	MOV BX,DS
	MOV ES,BX
	MOV SI,DI
	MOV DI,DX
	STD
	REP
	MOVSB
	MOV DX,DI
	MOV DI,SI
	POP SI
	POP DI
	POP ES
	AND AH,0E9H
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

CPIZ:
	MOV BX,DI
	SAHF
	JC CPIZ3
	CMP AL,[BX]
	LAHF
	OR AH,04H
	AND AH,0FEH
	JMP CPIZ4
CPIZ3:
	CMP AL,[BX]
	LAHF
	OR AH,05H
CPIZ4:
	INC DI
	DEC CX
	JNZ CPIZ5
	AND AH,0FBH
CPIZ5:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


CPIRZ:
	OR AH,04H
	SAHF
	JC CPIRZ8
CPIRZ3:
	MOV BX,DI
	SAHF
	CMP AL,[BX]
	LAHF
	JZ CPIRZ7
	INC DI
	DEC CX
	JNZ CPIRZ3
	AND AH,0FBH
CPIRZ7:
	AND AH,0FEH
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

CPIRZ8:
	MOV BX,DI
	SAHF
	CMP AL,[BX]
	LAHF
	JZ CPIRZ9
	INC DI
	DEC CX
	JNZ CPIRZ8
	AND AH,0FBH
CPIRZ9:
	OR AL,01H
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


	
CPDZ:
	MOV BX,DI
	SAHF
	JC CPDZ3
	CMP AL,[BX]
	LAHF
	OR AH,04H
	AND AH,0FEH
	JMP CPDZ4
CPDZ3:
	CMP AL,[BX]
	LAHF
	OR AH,05H
CPDZ4:
	DEC DI
	DEC CX
	JNZ CPDZ5
	AND AH,0FBH
CPDZ5:
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

CPDRZ:
	OR AH,04H
	SAHF
	JC CPDRZ8
CPDRZ3:
	MOV BX,DI
	SAHF
	CMP AL,[BX]
	LAHF
	JZ CPDRZ7
	DEC DI
	DEC CX
	JNZ CPDRZ3
	AND AH,0FBH
CPDRZ7:
	AND AH,0FEH
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

CPDRZ8:
	MOV BX,DI
	SAHF
	CMP AL,[BX]
	LAHF
	JZ CPDRZ9
	DEC DI
	DEC CX
	JNZ CPDRZ8
	AND AH,0FBH
CPDRZ9:
	OR AL,01H
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;********************************************
;Z80 OUTPUT CONTROL

INI:
	PUSH DX
	MOV DX,CX
	INB DX
	POP DX
	INC DI
	SAHF
	DEC CH
	LAHF
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

IND:
	PUSH DX
	MOV DX,CX
	INB DX
	POP DX
	DEC DI
	SAHF
	DEC CH
	LAHF
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

INIR:
	PUSH DX
	MOV DX,CX
	INB DX
	POP DX
	INC DI
	SAHF
	DEC CH
	LAHF
	JNZ INIR
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

INDR:
	PUSH DX
	MOV DX,CX
	INB DX
	POP DX
	DEC DI
	SAHF
	DEC CH
	LAHF
	JNZ INDR
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


OUTI:
	PUSH DX
	MOV DX,CX
	OUTB DX		; SEE IF THIS WORKS TOO
	POP DX
	INC DI
	SAHF
	DEC CH
	LAHF
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

OUTD:
	PUSH DX
	MOV DX,CX
	OUTB DX		; SEE IF THIS WORKS TOO
	POP DX
	DEC DI
	SAHF
	DEC CH
	LAHF
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

OUTIR:
	PUSH DX
	MOV DX,CX
	OUTB DX		; SEE IF THIS WORKS TOO
	POP DX
	INC DI
	SAHF
	DEC CH
	LAHF
	JNZ OUTIR
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

OUTDR:
	PUSH DX
	MOV DX,CX
	OUTB DX		; SEE IF THIS WORKS TOO
	POP DX
	DEC DI
	SAHF
	DEC CH
	LAHF
	JNZ OUTDR
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]


;********************************************

DJNZ:
	DEC CH
	JNZ RELJMP
;	CALL DEBUG
	INC SI
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

JRC:
	SAHF
	JC RELJMP
;	CALL DEBUG
	INC SI
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

JRNC:
	SAHF
	JNC RELJMP
;	CALL DEBUG
	INC SI
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

RELJMP:
	INC SI
;	CALL DEBUG
	XOR BX,BX
	OR BL,[SI]	
	JNS JRFRWD
	NOT BL
	SUB SI,BX
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

JRFRWD:
	INC SI
	AND BL,07FH
	ADD SI,BX
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

JRZ:
	SAHF
	JZ RELJMP
;	CALL DEBUG
	INC SI
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

JRNZ:
	SAHF
	JNZ RELJMP
;	CALL DEBUG
	INC SI
	INC SI
	XOR BX,BX
	MOV BL,[SI]
	SAL BX
	SEG CS
	JMP [JMPTAB+BX]

;*******************************************
;Z80 ROTATE AND SHIFT GROUP

RLCA:
	INC SI
	SAHF
	ROL AL
	LAHF
	JMP DONE

RLCB:
	INC SI
	SAHF
	ROL CH
	LAHF
	JMP DONE

RLCC:
	INC SI
	SAHF
	ROL CL
	LAHF
	JMP DONE

RLCD:
	INC SI
	SAHF
	ROL DH
	LAHF
	JMP DONE

RLCE:
	INC SI
	SAHF
	ROL DL
	LAHF
	JMP DONE

RLCH:
	INC SI
	SAHF
	MOV BX,DI
	ROL BH
	MOV DI,BX
	LAHF
	JMP DONE

RLCL:
	INC SI
	SAHF
	MOV BX,DI
	ROL BL
	MOV DI,BX
	LAHF
	JMP DONE

RLCM:
	INC SI
	SAHF
	MOV BX,ES
	ROL B,[BX]
	LAHF
	JMP DONE


RRCA:
	INC SI
	SAHF
	ROR AL
	LAHF
	JMP DONE

RRCB:
	INC SI
	SAHF
	ROR CH
	LAHF
	JMP DONE

RRCC:
	INC SI
	SAHF
	ROR CL
	LAHF
	JMP DONE

RRCD:
	INC SI
	SAHF
	ROR DH
	LAHF
	JMP DONE

RRCE:
	INC SI
	SAHF
	ROR DL
	LAHF
	JMP DONE

RRCH:
	INC SI
	SAHF
	MOV BX,DI
	ROR BH
	MOV DI,BX
	LAHF
	JMP DONE

RRCL:
	INC SI
	SAHF
	MOV BX,DI
	ROR BL
	MOV DI,BX
	LAHF
	JMP DONE

RRCM:
	INC SI
	SAHF
	MOV BX,ES
	ROR B,[BX]
	LAHF
	JMP DONE


ZRLA:
	INC SI
	SAHF
	RCL AL
	LAHF
	JMP DONE

ZRLB:
	INC SI
	SAHF
	RCL CH
	LAHF
	JMP DONE

ZRLC:
	INC SI
	SAHF
	RCL CL
	LAHF
	JMP DONE

ZRLD:
	INC SI
	SAHF
	RCL DH
	LAHF
	JMP DONE

ZRLE:
	INC SI
	SAHF
	RCL DL
	LAHF
	JMP DONE

ZRLH:
	INC SI
	SAHF
	MOV BX,DI
	RCL BH
	MOV DI,BX
	LAHF
	JMP DONE

ZRLL:
	INC SI
	SAHF
	MOV BX,DI
	RCL BL
	MOV DI,BX
	LAHF
	JMP DONE

ZRLM:
	INC SI
	SAHF
	MOV BX,ES
	RCL B,[BX]
	LAHF
	JMP DONE


ZRRA:
	INC SI
	SAHF
	RCR AL
	LAHF
	JMP DONE

ZRRB:
	INC SI
	SAHF
	RCR CH
	LAHF
	JMP DONE

ZRRC:
	INC SI
	SAHF
	RCR CL
	LAHF
	JMP DONE

ZRRD:
	INC SI
	SAHF
	RCR DH
	LAHF
	JMP DONE

ZRRE:
	INC SI
	SAHF
	RCR DL
	LAHF
	JMP DONE

ZRRH:
	INC SI
	SAHF
	MOV BX,DI
	RCR BH
	MOV DI,BX
	LAHF
	JMP DONE

ZRRL:
	INC SI
	SAHF
	MOV BX,DI
	RCR BL
	MOV DI,BX
	LAHF
	JMP DONE

ZRRM:
	INC SI
	SAHF
	MOV BX,ES
	RCR B,[BX]
	LAHF
	JMP DONE


SLAA:
	INC SI
	SAHF
	SAL AL
	LAHF
	JMP DONE

SLAB:
	INC SI
	SAHF
	SAL CH
	LAHF
	JMP DONE

SLAC:
	INC SI
	SAHF
	SAL CL
	LAHF
	JMP DONE

SLAD:
	INC SI
	SAHF
	SAL DH
	LAHF
	JMP DONE

SLAE:
	INC SI
	SAHF
	SAL DL
	LAHF
	JMP DONE

SLAH:
	INC SI
	SAHF
	MOV BX,DI
	SAL BH
	MOV DI,BX
	LAHF
	JMP DONE

SLAL:
	INC SI
	SAHF
	MOV BX,DI
	SAL BL
	MOV DI,BX
	LAHF
	JMP DONE

SLAM:
	INC SI
	SAHF
	MOV BX,ES
	SAL B,[BX]
	LAHF
	JMP DONE


SRAA:
	INC SI
	SAHF
	SAL AL
	LAHF
	JMP DONE

SRAB:
	INC SI
	SAHF
	SAL CH
	LAHF
	JMP DONE

SRAC:
	INC SI
	SAHF
	SAL CL
	LAHF
	JMP DONE

SRAD:
	INC SI
	SAHF
	SAL DH
	LAHF
	JMP DONE

SRAE:
	INC SI
	SAHF
	SAL DL
	LAHF
	JMP DONE

SRAH:
	INC SI
	SAHF
	MOV BX,DI
	SAL BH
	MOV DI,BX
	LAHF
	JMP DONE

SRAL:
	INC SI
	SAHF
	MOV BX,DI
	SAL BL
	MOV DI,BX
	LAHF
	JMP DONE

SRAM:
	INC SI
	SAHF
	MOV BX,ES
	SAL B,[BX]
	LAHF
	JMP DONE

SRLA:
	INC SI
	SAHF
	CLC
	RCR AL
	LAHF
	JMP DONE

SRLB:
	INC SI
	SAHF
	CLC
	RCR CH
	LAHF
	JMP DONE

SRLC:
	INC SI
	SAHF
	CLC
	RCR CL
	LAHF
	JMP DONE

SRLD:
	INC SI
	SAHF
	CLC
	RCR DH
	LAHF
	JMP DONE

SRLE:
	INC SI
	SAHF
	CLC
	RCR DL
	LAHF
	JMP DONE

SRLH:
	INC SI
	SAHF
	MOV BX,DI
	CLC
	RCR BH
	MOV DI,BX
	LAHF
	JMP DONE

SRLL:
	INC SI
	SAHF
	MOV BX,DI
	CLC
	RCR BL
	MOV DI,BX
	LAHF
	JMP DONE

SRLM:
	INC SI
	SAHF
	MOV BX,ES
	CLC
	RCR B,[BX]
	LAHF
	JMP DONE




XRLD:
	INC SI
	MOV BL,[DI]
	MOV BH,BL
	SAL BL
	SAL BL
	SAL BL
	SAL BL
	MOV [DI],BL
	MOV BL,AL
	AND BL,0FH
	OR [DI],BL
	AND AL,0F0H
	SAR BH
	SAR BH
	SAR BH
	SAR BH
	AND BH,0FH
	OR AL,BH
	SAHF
	JMP DONE

XRRD:
	INC SI
	MOV BL,[DI]
	SAR BL
	SAR BL
	SAR BL
	SAR BL
	AND BL,0FH
	MOV BH,AL
	SAL BH
	SAL BH
	SAL BH
	SAL BH
	OR BL,BH
	MOV BH,[DI]
	MOV [DI],BL
	AND BH,0FH
	AND AL,0F0H
	OR AL,BH
	SAHF
	JMP DONE


;********************************************
;Z80 I/O GROUP

INABC:
	INC SI
	PUSH DX
	MOV DX,CX
	INB DX
	OR AL,AL
	POP DX 	
	LAHF
	JMP DONE

INBBC:
	INC SI
	PUSH DX
	PUSH AX
	MOV DX,CX
	INB DX
	OR AL,AL
	MOV CH,AL
	POP AX
	POP DX 	
	LAHF
	JMP DONE

INCBC:
	INC SI
	PUSH DX
	PUSH AX
	MOV DX,CX
	INB DX
	OR AL,AL
	MOV CL,AL
	POP AX
	POP DX 	
	LAHF
	JMP DONE

INDBC:
	INC SI
	PUSH DX
	PUSH AX
	MOV DX,CX
	INB DX
	OR AL,AL
	MOV DH,AL
	POP AX
	POP DX 	
	LAHF
	JMP DONE

INEBC:
	INC SI
	PUSH DX
	PUSH AX
	MOV DX,CX
	INB DX
	OR AL,AL
	MOV DL,AL
	POP AX
	POP DX 	
	LAHF
	JMP DONE

INHBC:
	INC SI
	PUSH DX
	PUSH AX
	MOV BX,DI
	MOV DX,CX
	INB DX
	OR AL,AL
	MOV BH,AL
	MOV DI,BX
	POP AX
	POP DX 	
	LAHF
	JMP DONE

INLBC:
	INC SI
	PUSH DX
	PUSH AX
	MOV BX,DI
	MOV DX,CX
	INB DX
	OR AL,AL
	MOV BL,AL
	MOV DI,BX
	POP AX
	POP DX 	
	LAHF
	JMP DONE


INFBC:
	INC SI
	PUSH DX
	PUSH AX
	MOV DX,CX
	INB DX
	OR AL,AL
	POP AX
	POP DX 	
	LAHF
	JMP DONE


OUTABC:
	INC SI
	PUSH DX
	MOV DX,CX
 	OUTB DX
	POP DX 	
	JMP DONE

OUTBBC:
	INC SI
	PUSH DX
	PUSH AX
	MOV DX,CX
	MOV AL,CH
 	OUTB DX
	POP AX
	POP DX 	
	JMP DONE

OUTCBC:
	INC SI
	PUSH DX
	PUSH AX
	MOV DX,CX
	MOV AL,CL
 	OUTB DX
	POP AX
	POP DX 	
	JMP DONE

OUTDBC:
	INC SI
	PUSH DX
	PUSH AX
	MOV DX,CX
	MOV AL,DH
 	OUTB DX
	POP AX
	POP DX 	
	JMP DONE

OUTEBC:
	INC SI
	PUSH DX
	PUSH AX
	MOV DX,CX
	MOV AL,DL
 	OUTB DX
	POP AX
	POP DX 	
	JMP DONE

OUTHBC:
	INC SI
	PUSH DX
	PUSH AX
	MOV DX,CX
	MOV BX,DI
	MOV AL,BH
 	OUTB DX
	POP AX
	POP DX 	
	JMP DONE

OUTLBC: 
	INC SI
	PUSH DX
	PUSH AX
	MOV DX,CX
	MOV BX,DI
	MOV AL,BL
 	OUTB DX
	POP AX
	POP DX 	
	JMP DONE


;**********************************************

BITA0:
	INC SI
	TEST AL,01H
	LAHF
	JMP DONE
	
BITA1:
	INC SI
	TEST AL,02H
	LAHF
	JMP DONE
	
BITA2:
	INC SI
	TEST AL,04H
	LAHF
	JMP DONE
	
BITA3:
	INC SI
	TEST AL,08H
	LAHF
	JMP DONE
	
BITA4:
	INC SI
	TEST AL,10H
	LAHF
	JMP DONE
	
BITA5:
	INC SI
	TEST AL,20H
	LAHF
	JMP DONE
	
BITA6:
	INC SI
	TEST AL,40H
	LAHF
	JMP DONE
	
BITA7:
	INC SI
	TEST AL,80H
	LAHF
	JMP DONE
	

BITB0:
	INC SI
	TEST CH,01H
	LAHF
	JMP DONE
	
BITB1:
	INC SI
	TEST CH,02H
	LAHF
	JMP DONE
	
BITB2:
	INC SI
	TEST CH,04H
	LAHF
	JMP DONE
	
BITB3:
	INC SI
	TEST CH,08H
	LAHF
	JMP DONE
	
BITB4:
	INC SI
	TEST CH,10H
	LAHF
	JMP DONE
	
BITB5:
	INC SI
	TEST CH,20H
	LAHF
	JMP DONE
	
BITB6:
	INC SI
	TEST CH,40H
	LAHF
	JMP DONE
	
BITB7:
	INC SI
	TEST CH,80H
	LAHF
	JMP DONE
	
	
BITC0:
	INC SI
	TEST CL,01H
	LAHF
	JMP DONE
	
BITC1:
	INC SI
	TEST CL,02H
	LAHF
	JMP DONE
	
BITC2:
	INC SI
	TEST CL,04H
	LAHF
	JMP DONE
	
BITC3:
	INC SI
	TEST CL,08H
	LAHF
	JMP DONE
	
BITC4:
	INC SI
	TEST CL,10H
	LAHF
	JMP DONE
	
BITC5:
	INC SI
	TEST CL,20H
	LAHF
	JMP DONE
	
BITC6:
	INC SI
	TEST CL,40H
	LAHF
	JMP DONE
	
BITC7:
	INC SI
	TEST CL,80H
	LAHF
	JMP DONE
	

BITD0:
	INC SI
	TEST DH,01H
	LAHF
	JMP DONE
	
BITD1:
	INC SI
	TEST DH,02H
	LAHF
	JMP DONE
	
BITD2:
	INC SI
	TEST DH,04H
	LAHF
	JMP DONE
	
BITD3:
	INC SI
	TEST DH,08H
	LAHF
	JMP DONE
	
BITD4:
	INC SI
	TEST DH,10H
	LAHF
	JMP DONE
	
BITD5:
	INC SI
	TEST DH,20H
	LAHF
	JMP DONE
	
BITD6:
	INC SI
	TEST DH,40H
	LAHF
	JMP DONE
	
BITD7:
	INC SI
	TEST DH,80H
	LAHF
	JMP DONE
	

BITE0:
	INC SI
	TEST DL,01H
	LAHF
	JMP DONE
	
BITE1:
	INC SI
	TEST DL,02H
	LAHF
	JMP DONE
	
BITE2:
	INC SI
	TEST DL,04H
	LAHF
	JMP DONE
	
BITE3:
	INC SI
	TEST DL,08H
	LAHF
	JMP DONE
	
BITE4:
	INC SI
	TEST DL,10H
	LAHF
	JMP DONE
	
BITE5:
	INC SI
	TEST DL,20H
	LAHF
	JMP DONE
	
BITE6:
	INC SI
	TEST DL,40H
	LAHF
	JMP DONE
	
BITE7:
	INC SI
	TEST DL,80H
	LAHF
	JMP DONE
	

BITH0:
	INC SI
	MOV BX,DI
	TEST BH,01H
	LAHF
	JMP DONE
	
BITH1:
	INC SI
	MOV BX,DI
	TEST BH,02H
	LAHF
	JMP DONE
	
BITH2:
	INC SI
	MOV BX,DI
	TEST BH,04H
	LAHF
	JMP DONE
	
BITH3:
	INC SI
	MOV BX,DI
	TEST BH,08H
	LAHF
	JMP DONE
	
BITH4:
	INC SI
	MOV BX,DI
	TEST BH,10H
	LAHF
	JMP DONE
	
BITH5:
	INC SI
	MOV BX,DI
	TEST BH,20H
	LAHF
	JMP DONE
	
BITH6:
	INC SI
	MOV BX,DI
	TEST BH,40H
	LAHF
	JMP DONE
	
BITH7:
	INC SI
	MOV BX,DI
	TEST BH,80H
	LAHF
	JMP DONE
	

BITL0:
	INC SI
	MOV BX,DI
	TEST BL,01H
	LAHF
	JMP DONE
	
BITL1:
	INC SI
	MOV BX,DI
	TEST BL,02H
	LAHF
	JMP DONE
	
BITL2:
	INC SI
	MOV BX,DI
	TEST BL,04H
	LAHF
	JMP DONE
	
BITL3:
	INC SI
	MOV BX,DI
	TEST BL,08H
	LAHF
	JMP DONE
	
BITL4:
	INC SI
	MOV BX,DI
	TEST BL,10H
	LAHF
	JMP DONE
	
BITL5:
	INC SI
	MOV BX,DI
	TEST BL,20H
	LAHF
	JMP DONE
	
BITL6:
	INC SI
	MOV BX,DI
	TEST BL,40H
	LAHF
	JMP DONE
	
BITL7:
	INC SI
	MOV BX,DI
	TEST BL,80H
	LAHF
	JMP DONE
	

BITM0:
	INC SI
	MOV BX,ES
	TEST B,[BX],01H
	LAHF
	JMP DONE
	
BITM1:
	INC SI
	MOV BX,ES
	TEST B,[BX],02H
	LAHF
	JMP DONE
	
BITM2:
	INC SI
	MOV BX,ES
	TEST B,[BX],04H
	LAHF
	JMP DONE
	
BITM3:
	INC SI
	MOV BX,ES
	TEST B,[BX],08H
	LAHF
	JMP DONE
	
BITM4:
	INC SI
	MOV BX,ES
	TEST B,[BX],10H
	LAHF
	JMP DONE
	
BITM5:
	INC SI
	MOV BX,ES
	TEST B,[BX],20H
	LAHF
	JMP DONE
	
BITM6:
	INC SI
	MOV BX,ES
	TEST B,[BX],40H
	LAHF
	JMP DONE
	
BITM7:
	INC SI
	MOV BX,ES
	TEST B,[BX],80H
	LAHF
	JMP DONE
	

SETA0:
	INC SI
	OR AL,01H
	JMP DONE
	
SETA1:
	INC SI
	OR AL,02H
	JMP DONE
	
SETA2:
	INC SI
	OR AL,04H
	JMP DONE
	
SETA3:
	INC SI
	OR AL,08H
	JMP DONE
	
SETA4:
	INC SI
	OR AL,10H
	JMP DONE
	
SETA5:
	INC SI
	OR AL,20H
	JMP DONE
	
SETA6:
	INC SI
	OR AL,40H
	JMP DONE
	
SETA7:
	INC SI
	OR AL,80H
	JMP DONE
	

SETB0:
	INC SI
	OR CH,01H
	JMP DONE
	
SETB1:
	INC SI
	OR CH,02H
	JMP DONE
	
SETB2:
	INC SI
	OR CH,04H
	JMP DONE
	
SETB3:
	INC SI
	OR CH,08H
	JMP DONE
	
SETB4:
	INC SI
	OR CH,10H
	JMP DONE
	
SETB5:
	INC SI
	OR CH,20H
	JMP DONE
	
SETB6:
	INC SI
	OR CH,40H
	JMP DONE
	
SETB7:
	INC SI
	OR CH,80H
	JMP DONE
	
	
SETC0:
	INC SI
	OR CL,01H
	JMP DONE
	
SETC1:
	INC SI
	OR CL,02H
	JMP DONE
	
SETC2:
	INC SI
	OR CL,04H
	JMP DONE
	
SETC3:
	INC SI
	OR CL,08H
	JMP DONE
	
SETC4:
	INC SI
	OR CL,10H
	JMP DONE
	
SETC5:
	INC SI
	OR CL,20H
	JMP DONE
	
SETC6:
	INC SI
	OR CL,40H
	JMP DONE
	
SETC7:
	INC SI
	OR CL,80H
	JMP DONE
	

SETD0:
	INC SI
	OR DH,01H
	JMP DONE
	
SETD1:
	INC SI
	OR DH,02H
	JMP DONE
	
SETD2:
	INC SI
	OR DH,04H
	JMP DONE
	
SETD3:
	INC SI
	OR DH,08H
	JMP DONE
	
SETD4:
	INC SI
	OR DH,10H
	JMP DONE
	
SETD5:
	INC SI
	OR DH,20H
	JMP DONE
	
SETD6:
	INC SI
	OR DH,40H
	JMP DONE
	
SETD7:
	INC SI
	OR DH,80H
	JMP DONE
	

SETE0:
	INC SI
	OR DL,01H
	JMP DONE
	
SETE1:
	INC SI
	OR DL,02H
	JMP DONE
	
SETE2:
	INC SI
	OR DL,04H
	JMP DONE
	
SETE3:
	INC SI
	OR DL,08H
	JMP DONE
	
SETE4:
	INC SI
	OR DL,10H
	JMP DONE
	
SETE5:
	INC SI
	OR DL,20H
	JMP DONE
	
SETE6:
	INC SI
	OR DL,40H
	JMP DONE
	
SETE7:
	INC SI
	OR DL,80H
	JMP DONE
	

SETH0:
	INC SI
	MOV BX,DI
	OR BH,01H
	JMP DONE
	
SETH1:
	INC SI
	MOV BX,DI
	OR BH,02H
	JMP DONE
	
SETH2:
	INC SI
	MOV BX,DI
	OR BH,04H
	JMP DONE
	
SETH3:
	INC SI
	MOV BX,DI
	OR BH,08H
	JMP DONE
	
SETH4:
	INC SI
	MOV BX,DI
	OR BH,10H
	JMP DONE
	
SETH5:
	INC SI
	MOV BX,DI
	OR BH,20H
	JMP DONE
	
SETH6:
	INC SI
	MOV BX,DI
	OR BH,40H
	JMP DONE
	
SETH7:
	INC SI
	MOV BX,DI
	OR BH,80H
	JMP DONE
	

SETL0:
	INC SI
	MOV BX,DI
	OR BL,01H
	JMP DONE
	
SETL1:
	INC SI
	MOV BX,DI
	OR BL,02H
	JMP DONE
	
SETL2:
	INC SI
	MOV BX,DI
	OR BL,04H
	JMP DONE
	
SETL3:
	INC SI
	MOV BX,DI
	OR BL,08H
	JMP DONE
	
SETL4:
	INC SI
	MOV BX,DI
	OR BL,10H
	JMP DONE
	
SETL5:
	INC SI
	MOV BX,DI
	OR BL,20H
	JMP DONE
	
SETL6:
	INC SI
	MOV BX,DI
	OR BL,40H
	JMP DONE
	
SETL7:
	INC SI
	MOV BX,DI
	OR BL,80H
	JMP DONE
	

SETM0:
	INC SI
	MOV BX,ES
	OR B,[BX],01H
	JMP DONE
	
SETM1:
	INC SI
	MOV BX,ES
	OR B,[BX],02H
	JMP DONE
	
SETM2:
	INC SI
	MOV BX,ES
	OR B,[BX],04H
	JMP DONE
	
SETM3:
	INC SI
	MOV BX,ES
	OR B,[BX],08H
	JMP DONE
	
SETM4:
	INC SI
	MOV BX,ES
	OR B,[BX],10H
	JMP DONE
	
SETM5:
	INC SI
	MOV BX,ES
	OR B,[BX],20H
	JMP DONE
	
SETM6:
	INC SI
	MOV BX,ES
	OR B,[BX],40H
	JMP DONE
	
SETM7:
	INC SI
	MOV BX,ES
	OR B,[BX],80H
	JMP DONE
	

RESA0:
	INC SI
	AND AL,0FFH-01H
	JMP DONE
	
RESA1:
	INC SI
	AND AL,0FFH-02H
	JMP DONE
	
RESA2:
	INC SI
	AND AL,0FFH-04H
	JMP DONE
	
RESA3:
	INC SI
	AND AL,0FFH-08H
	JMP DONE
	
RESA4:
	INC SI
	AND AL,0FFH-10H
	JMP DONE
	
RESA5:
	INC SI
	AND AL,0FFH-20H
	JMP DONE
	
RESA6:
	INC SI
	AND AL,0FFH-40H
	JMP DONE
	
RESA7:
	INC SI
	AND AL,0FFH-80H
	JMP DONE
	

RESB0:
	INC SI
	AND CH,0FFH-01H
	JMP DONE
	
RESB1:
	INC SI
	AND CH,0FFH-02H
	JMP DONE
	
RESB2:
	INC SI
	AND CH,0FFH-04H
	JMP DONE
	
RESB3:
	INC SI
	AND CH,0FFH-08H
	JMP DONE
	
RESB4:
	INC SI
	AND CH,0FFH-10H
	JMP DONE
	
RESB5:
	INC SI
	AND CH,0FFH-20H
	JMP DONE
	
RESB6:
	INC SI
	AND CH,0FFH-40H
	JMP DONE
	
RESB7:
	INC SI
	AND CH,0FFH-80H
	JMP DONE
	
	
RESC0:
	INC SI
	AND CL,0FFH-01H
	JMP DONE
	
RESC1:
	INC SI
	AND CL,0FFH-02H
	JMP DONE
	
RESC2:
	INC SI
	AND CL,0FFH-04H
	JMP DONE
	
RESC3:
	INC SI
	AND CL,0FFH-08H
	JMP DONE
	
RESC4:
	INC SI
	AND CL,0FFH-10H
	JMP DONE
	
RESC5:
	INC SI
	AND CL,0FFH-20H
	JMP DONE
	
RESC6:
	INC SI
	AND CL,0FFH-40H
	JMP DONE
	
RESC7:
	INC SI
	AND CL,0FFH-80H
	JMP DONE
	

RESD0:
	INC SI
	AND DH,0FFH-01H
	JMP DONE
	
RESD1:
	INC SI
	AND DH,0FFH-02H
	JMP DONE
	
RESD2:
	INC SI
	AND DH,0FFH-04H
	JMP DONE
	
RESD3:
	INC SI
	AND DH,0FFH-08H
	JMP DONE
	
RESD4:
	INC SI
	AND DH,0FFH-10H
	JMP DONE
	
RESD5:
	INC SI
	AND DH,0FFH-20H
	JMP DONE
	
RESD6:
	INC SI
	AND DH,0FFH-40H
	JMP DONE
	
RESD7:
	INC SI
	AND DH,0FFH-80H
	JMP DONE
	

RESE0:
	INC SI
	AND DL,0FFH-01H
	JMP DONE
	
RESE1:
	INC SI
	AND DL,0FFH-02H
	JMP DONE
	
RESE2:
	INC SI
	AND DL,0FFH-04H
	JMP DONE
	
RESE3:
	INC SI
	AND DL,0FFH-08H
	JMP DONE
	
RESE4:
	INC SI
	AND DL,0FFH-10H
	JMP DONE
	
RESE5:
	INC SI
	AND DL,0FFH-20H
	JMP DONE
	
RESE6:
	INC SI
	AND DL,0FFH-40H
	JMP DONE
	
RESE7:
	INC SI
	AND DL,0FFH-80H
	JMP DONE
	

RESH0:
	INC SI
	MOV BX,DI
	AND BH,0FFH-01H
	JMP DONE
	
RESH1:
	INC SI
	MOV BX,DI
	AND BH,0FFH-02H
	JMP DONE
	
RESH2:
	INC SI
	MOV BX,DI
	AND BH,0FFH-04H
	JMP DONE
	
RESH3:
	INC SI
	MOV BX,DI
	AND BH,0FFH-08H
	JMP DONE
	
RESH4:
	INC SI
	MOV BX,DI
	AND BH,0FFH-10H
	JMP DONE
	
RESH5:
	INC SI
	MOV BX,DI
	AND BH,0FFH-20H
	JMP DONE
	
RESH6:
	INC SI
	MOV BX,DI
	AND BH,0FFH-40H
	JMP DONE
	
RESH7:
	INC SI
	MOV BX,DI
	AND BH,0FFH-80H
	JMP DONE
	

RESL0:
	INC SI
	MOV BX,DI
	AND BL,0FFH-01H
	JMP DONE
	
RESL1:
	INC SI
	MOV BX,DI
	AND BL,0FFH-02H
	JMP DONE
	
RESL2:
	INC SI
	MOV BX,DI
	AND BL,0FFH-04H
	JMP DONE
	
RESL3:
	INC SI
	MOV BX,DI
	AND BL,0FFH-08H
	JMP DONE
	
RESL4:
	INC SI
	MOV BX,DI
	AND BL,0FFH-10H
	JMP DONE
	
RESL5:
	INC SI
	MOV BX,DI
	AND BL,0FFH-20H
	JMP DONE
	
RESL6:
	INC SI
	MOV BX,DI
	AND BL,0FFH-40H
	JMP DONE
	
RESL7:
	INC SI
	MOV BX,DI
	AND BL,0FFH-80H
	JMP DONE
	

RESM0:
	INC SI
	MOV BX,ES
	AND B,[BX],0FFH-01H
	JMP DONE
	
RESM1:
	INC SI
	MOV BX,ES
	AND B,[BX],0FFH-02H
	JMP DONE
	
RESM2:
	INC SI
	MOV BX,ES
	AND B,[BX],0FFH-04H
	JMP DONE
	
RESM3:
	INC SI
	MOV BX,ES
	AND B,[BX],0FFH-08H
	JMP DONE
	
RESM4:
	INC SI
	MOV BX,ES
	AND B,[BX],0FFH-10H
	JMP DONE
	
RESM5:
	INC SI
	MOV BX,ES
	AND B,[BX],0FFH-20H
	JMP DONE
	
RESM6:
	INC SI
	MOV BX,ES
	AND B,[BX],0FFH-40H
	JMP DONE
	
RESM7:
	INC SI
	MOV BX,ES
	AND B,[BX],0FFH-80H
	JMP DONE
	

;
;*******************************************************
;ERROR EXITS
;

Z80CB:
	MOV BL,0CBH
	JMP Z80ERROR
Z80DD:
	MOV BL,0DDH
	JMP Z80ERROR
Z80ED:
	MOV BL,0EDH
	JMP Z80ERROR
Z80FD:
	MOV BL,0FDH
	JMP Z80ERROR

;
Z80ERROR:
	PUSH AX
	PUSH CX
	PUSH DX
	PUSH DI
	PUSH SI
	PUSH BP
	PUSH BX
	MOV DL,CR
	MOV AH,2
	INT 21H
	MOV DL,LF
	MOV AH,2
	INT 21H
	MOV DL,BELL
	MOV AH,2
	INT 21H
	POP BX
	MOV AL,BL
	CALL PRTBYTE

	PUSH DS
	MOV BX,CS
	MOV DS,BX
	MOV DX,Z80MSG
	MOV AH,09H
	INT 21H
	POP DS
	POP BP
	POP SI
	POP DI
	POP DX
	POP CX
	POP AX

	CALL HEADER
	CALL DEBUG
	JMP USERBOOT

;
Z80MSG:
	DB ' <- Invalid Operation Code encountered ***',BELL,CR,LF,'$'
;

HEADER:
	PUSH AX
	PUSH CX
	PUSH DX
	PUSH DI
	PUSH SI
	PUSH BP
	PUSH BX
	PUSH DS
	MOV BX,CS
	MOV DS,BX
	MOV DX,HEADERMSG
	MOV AH,09H
	INT 21H
	POP DS
	POP BX
	POP BP
	POP SI
	POP DI
	POP DX
	POP CX
	POP AX
	RET

HEADERMSG:
	DB CR,LF,' PC   AF   BC   DE   HL   SP   (SP)  (SP-2)'
	DB ' OP-2 OP-1 OP OP+1 OP+2 OP+3$' 

;
;
DEBUG:
	PUSH AX
	PUSHF
	PUSH BX
	PUSH CX
	PUSH DX
	PUSH BP
	PUSH DI
	PUSH SI

	PUSH BP
	PUSH DI
	PUSH DX
	PUSH CX
	PUSH AX
	PUSH SI

	MOV DL,CR
	MOV AH,2
	INT 21H
	MOV DL,LF
	MOV AH,2
	INT 21H

	POP SI
	MOV BX,SI
	CALL PRTWORD
	POP AX
	MOV BH,AH
	MOV BL,AL
	CALL PRTWORD
	POP CX
	MOV BX,CX
	CALL PRTWORD
	POP DX
	MOV BX,DX
	CALL PRTWORD
	POP DI
	MOV BX,DI
	CALL PRTWORD
	POP BP
	MOV BX,BP
	CALL PRTWORD
;
	MOV DL,'('
	MOV AH,2
	INT 21H
	SEG DS
	MOV BX,[BP]
	MOV AL,BH
	CALL PRTBYTE
	MOV AL,BH
	CALL PRTBYTE
	MOV DL,')'
	MOV AH,2
	INT 21H
	MOV DL,' '
	MOV AH,2
	INT 21H

	MOV DL,'('
	MOV AH,2
	INT 21H
	SEG DS
	MOV BX,[BP+2]
	CALL PRTBYTE
	MOV AL,BL
	CALL PRTBYTE
	MOV DL,')'
	MOV AH,2
	INT 21H
	MOV DL,' '
	MOV AH,2
	INT 21H


;
	MOV DL,'('
	MOV AH,2
	INT 21H
	MOV AL,[SI-3]
	CALL PRTBYTE	;OPCODE MINUS TWO
	MOV DL,')'
	MOV AH,2
	INT 21H
	MOV DL,' '
	MOV AH,2
	INT 21H

	MOV DL,'('
	MOV AH,2
	INT 21H
	MOV AL,[SI-2]	;OP CODE MINUS ONE
	CALL PRTBYTE
	MOV DL,')'
	MOV AH,2
	INT 21H
	MOV DL,' '
	MOV AH,2
	INT 21H

	MOV AL,[SI-1]
	CALL PRTBYTE	;OP CODE
	MOV DL,' '
	MOV AH,2
	INT 21H


	MOV DL,'('
	MOV AH,2
	INT 21H
	MOV AL,[SI]
	CALL PRTBYTE	;OP CODE PLUS ONE
	MOV DL,')'
	MOV AH,2
	INT 21H
	MOV DL,' '
	MOV AH,2
	INT 21H

	MOV DL,'('
	MOV AH,2
	INT 21H
	MOV AL,[SI+1]
	CALL PRTBYTE	;OP CODE PLUS TWO
	MOV DL,')'
	MOV AH,2
	INT 21H
	MOV DL,' '
	MOV AH,2
	INT 21H

	MOV DL,'('
	MOV AH,2
	INT 21H
	MOV AL,[SI+2]
	CALL PRTBYTE	;OP CODE PLUS THREE
	MOV DL,')'
	MOV AH,2
	INT 21H
	MOV DL,' '
	MOV AH,2
	INT 21H

	POP SI
	POP DI
	POP BP
	POP DX
	POP CX
	POP BX
	POPF
	POP AX
	RET
;
PRTWORD:
	PUSH SI
	MOV AL,BH
	CALL PRTBYTE
	MOV AL,BL
	CALL PRTBYTE
	MOV AH,2
	MOV DL,' '
	INT 21H
	POP SI
	RET
;
PRTBYTE:
	PUSH DX
	PUSH BX
	MOV BL,AL
	ROR BL
	ROR BL
	ROR BL
	ROR BL
	AND BL,0FH
	CALL HEX2A
	MOV DL,BL
	PUSH AX
	MOV AH,2
	INT 21H
	POP AX
	MOV BL,AL
	AND BL,0FH
	CALL HEX2A
	MOV DL,BL
	MOV AH,2
	INT 21H
	POP BX
	POP DX
	RET
;
HEX2A:
	ADD BL,30H
	CMP BL,3AH
	JC HEXN
	ADD BL,07H
HEXN:	RET
;

;
;
; PROGRAM TEMPORARY FCB TO READ COM FILE
;
FCB:
	DB 0,0,0,0,0,0,0
	DB 0,0,0,0,0,0,0
	DB 0,0,0,0,0,0,0
	DB 0,0,0,0,0,0,0
	DB 0,0,0,0,0,0,0
	DB 0,0,0,0
;
;
;
; MAP OUT REAL CPM SYSTEM
;
;
BOOT:	DB 0C3H,03H,0FAH

IOBYTE:	DB 094H

USRBYT:	DB 00H

BDOS:	DB 0C3H,06H,0ECH
	DS 54H
	DB 00H,20H,20H,20H
	DS 0A0H
TBA:
	DB 76H
;
;
; DECODE BDOS CALLS
;
REALBDOS:
	DW 00EDH	;RBDOS
	DB 0C9H
;
;
; CPM JUMP TABLE
; (FOR THOSE WHO NEED TO SEE A JUMP TABLE HERE) 
;
CPMJMP:
	DB 0C3H
	DW 0FB00H	;CBOOT
;
	DB 0C3H
	DW 0FB03H	;WBOOT
;
	DB 0C3H
	DW 0FB06H	;CONST
;
	DB 0C3H
	DW 0FB09H	;CONIN
;
	DB 0C3H
	DW 0FB0CH	;CONOUT
;
	DB 0C3H
	DW 0FB0FH	;LIST
;
	DB 0C3H
	DW 0FB12H	;PUNCH
;
	DB 0C3H
	DW 0FB15H	;READER
;
	DB 0C3H
	DW 0FB18H	;HOME
;
	DB 0C3H
	DW 0FB1BH	;SELDSK
;
	DB 0C3H
	DW 0FB1EH	;SETTRK
;
	DB 0C3H
	DW 0FB21H	;SETSEC
;
	DB 0C3H
	DW 0FB24H	;SETDMA
;
	DB 0C3H
	DW 0FB27H	;READ
;
	DB 0C3H
	DW 0FB2AH	;WRITE
;
	DB 0C3H
	DW 0FB2DH	;LISTST
;
	DB 0C3H
	DW 0FB30H	;SECTRAN

;
;NOW CONVERT TO OUR OWN CONTROL VIA MACRO COMMAND
;

CBOOT:	DW 01EDH		;0FB00H
	DB 0C9H

WBOOT:	DW 02EDH		;0FB03H
	DB 0C9H

CONST:	DW 03EDH		;0FB06H
	DB 0C9H

CONIN:	DW 04EDH		;0FB09H
	DB 0C9H

CONOUT:	DW 05EDH		;0FB0CH
	DB 0C9H

LIST:	DW 06EDH		;0FB0FH
	DB 0C9H

PUNCH:	DW 07EDH		;0FB12H
	DB 0C9H

READER:	DW 08EDH		;0FB15H
	DB 0C9H

HOME:	DW 09EDH		;0FB18H
	DB 0C9H

SELDSK:	DW 0AEDH		;0FB1BH
	DB 0C9H

SETTRK:	DW 0BEDH		;0FB1EH
	DB 0C9H

SETSEC	DW 0CEDH		;0FB21H
	DB 0C9H

SETDMA:	DW 0DEDH		;0FB24H
	DB 0C9H

READ:	DW 0EEDH		;0FB27H
	DB 0C9H

WRITE:	DW 0FEDH		;0FB2AH
	DB 0C9H

LISTST:	DW 10EDH		;0FB2DH
	DB 0C9H

SECTRAN: DW 11EDH		;0FB30H
	DB 0C9H



;*****************************************
; END OF BIOS SECTION
;***************************************
;
;
; STACK AREA HERE
;
	DS 400H
STACK	EQU $
;
;
;
;
;  8080 REGISTERS MAPPED INTO MEMORY
;
	DS 0FC00H-$
;
;
I2BC:	DS 2
I2DE:	DS 2
I2HL:	DS 2
I2PSW:	DS 2

IIX:	DS 2
IIY:	DS 2
IIR:
IR:	DS 1
II:	DS 1
;
	DS 2	;EXTRA
DMA	DS 2	;DMA ADDRESS
;
CPMEND:
	DS 2
;
BUGFLG:
	DS 1
	DS 1	;SAFETY
;

BYTEIN:
	DS 1

BYTERDYFLG:
	DS 1
	DS 1
COMBRDYFLG:
	DS 1
	DS 1

COMBYTEIN:
	DS 1
	DS 1
GETIN:
	DS 1
	DS 1
STRDY:
	DS 1
	DS 1


PRTFLAG:
	DS 1
	DS 1
SPCOUNT:
	DS 1
	DS 1

DRVLOG:
	DS 2	;DRV SEL FLAG


CURFLAG:
	DS 1
	DS 1

EQFLAG:
	DS 1
	DS 1

ROWFLAG:
	DS 1
	DS 1

ROWCNT:
	DS 1
	DS 1

LASTXY:
	DS 2 

CONFLAG:
	DS 1
	DS 1

BEGBUFF:
	DS 1
	DS 1

DELCOUNT:
	DS 1
	DS 1

DISKREG:
	DS 1
	DS 1

DMAFLAG:
	DS 1
	DS 1

OLDBUGVAL:
	DS 1
	DS 1


;
TEMPFCB:
	DS 48
	DS 32
DPARM:
	DS 16
ALLOC:
	DS 256

	DS 32	;CPM STACK
CPMSTACK:
	DS 4	;BEG OF CPM STACK


	END 100H
